<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'XzufiWebserviceFault' => '\\StructType\\XzufiWebserviceFault',
            'XzufiWebservice' => '\\StructType\\XzufiWebservice',
            'Amount' => '\\StructType\\Amount',
            'BinaryObject' => '\\StructType\\BinaryObject',
            'Identifikator' => '\\StructType\\Identifikator',
            'String.Localized' => '\\StructType\\String_Localized',
            'Zeitraum' => '\\StructType\\Zeitraum',
            'CodeType' => '\\StructType\\CodeType',
            'CodeWithAuthorityType' => '\\StructType\\CodeWithAuthorityType',
            'MeasureType' => '\\StructType\\MeasureType',
            'CoordinatesType' => '\\StructType\\CoordinatesType',
            'CodeListType' => '\\StructType\\CodeListType',
            'CodeOrNilReasonListType' => '\\StructType\\CodeOrNilReasonListType',
            'MeasureListType' => '\\StructType\\MeasureListType',
            'MeasureOrNilReasonListType' => '\\StructType\\MeasureOrNilReasonListType',
            'simple' => '\\StructType\\Simple',
            'extended' => '\\StructType\\Extended',
            'titleEltType' => '\\StructType\\TitleEltType',
            'resourceType' => '\\StructType\\ResourceType',
            'locatorType' => '\\StructType\\LocatorType',
            'arcType' => '\\StructType\\ArcType',
            'AbstractGMLType' => '\\StructType\\AbstractGMLType',
            'AssociationRoleType' => '\\StructType\\AssociationRoleType',
            'ReferenceType' => '\\StructType\\ReferenceType',
            'InlinePropertyType' => '\\StructType\\InlinePropertyType',
            'AbstractMemberType' => '\\StructType\\AbstractMemberType',
            'AbstractMetadataPropertyType' => '\\StructType\\AbstractMetadataPropertyType',
            'DefinitionBaseType' => '\\StructType\\DefinitionBaseType',
            'DefinitionType' => '\\StructType\\DefinitionType',
            'DictionaryType' => '\\StructType\\DictionaryType',
            'DictionaryEntryType' => '\\StructType\\DictionaryEntryType',
            'UnitOfMeasureType' => '\\StructType\\UnitOfMeasureType',
            'UnitDefinitionType' => '\\StructType\\UnitDefinitionType',
            'BaseUnitType' => '\\StructType\\BaseUnitType',
            'DerivedUnitType' => '\\StructType\\DerivedUnitType',
            'DerivationUnitTermType' => '\\StructType\\DerivationUnitTermType',
            'ConventionalUnitType' => '\\StructType\\ConventionalUnitType',
            'ConversionToPreferredUnitType' => '\\StructType\\ConversionToPreferredUnitType',
            'FormulaType' => '\\StructType\\FormulaType',
            'LengthType' => '\\StructType\\LengthType',
            'ScaleType' => '\\StructType\\ScaleType',
            'TimeType' => '\\StructType\\TimeType',
            'GridLengthType' => '\\StructType\\GridLengthType',
            'AreaType' => '\\StructType\\AreaType',
            'VolumeType' => '\\StructType\\VolumeType',
            'SpeedType' => '\\StructType\\SpeedType',
            'AngleType' => '\\StructType\\AngleType',
            'AbstractGeometryType' => '\\StructType\\AbstractGeometryType',
            'GeometryPropertyType' => '\\StructType\\GeometryPropertyType',
            'GeometryArrayPropertyType' => '\\StructType\\GeometryArrayPropertyType',
            'DirectPositionType' => '\\StructType\\DirectPositionType',
            'DirectPositionListType' => '\\StructType\\DirectPositionListType',
            'VectorType' => '\\StructType\\VectorType',
            'EnvelopeType' => '\\StructType\\EnvelopeType',
            'AbstractGeometricPrimitiveType' => '\\StructType\\AbstractGeometricPrimitiveType',
            'GeometricPrimitivePropertyType' => '\\StructType\\GeometricPrimitivePropertyType',
            'PointType' => '\\StructType\\PointType',
            'PointPropertyType' => '\\StructType\\PointPropertyType',
            'PointArrayPropertyType' => '\\StructType\\PointArrayPropertyType',
            'AbstractCurveType' => '\\StructType\\AbstractCurveType',
            'CurvePropertyType' => '\\StructType\\CurvePropertyType',
            'CurveArrayPropertyType' => '\\StructType\\CurveArrayPropertyType',
            'LineStringType' => '\\StructType\\LineStringType',
            'AbstractSurfaceType' => '\\StructType\\AbstractSurfaceType',
            'SurfacePropertyType' => '\\StructType\\SurfacePropertyType',
            'SurfaceArrayPropertyType' => '\\StructType\\SurfaceArrayPropertyType',
            'PolygonType' => '\\StructType\\PolygonType',
            'AbstractRingType' => '\\StructType\\AbstractRingType',
            'AbstractRingPropertyType' => '\\StructType\\AbstractRingPropertyType',
            'LinearRingType' => '\\StructType\\LinearRingType',
            'LinearRingPropertyType' => '\\StructType\\LinearRingPropertyType',
            'CurveType' => '\\StructType\\CurveType',
            'OrientableCurveType' => '\\StructType\\OrientableCurveType',
            'AbstractCurveSegmentType' => '\\StructType\\AbstractCurveSegmentType',
            'CurveSegmentArrayPropertyType' => '\\ArrayType\\CurveSegmentArrayPropertyType',
            'LineStringSegmentType' => '\\StructType\\LineStringSegmentType',
            'ArcStringType' => '\\StructType\\ArcStringType',
            'ArcType' => '\\StructType\\ArcType_1',
            'CircleType' => '\\StructType\\CircleType',
            'ArcStringByBulgeType' => '\\StructType\\ArcStringByBulgeType',
            'ArcByBulgeType' => '\\StructType\\ArcByBulgeType',
            'ArcByCenterPointType' => '\\StructType\\ArcByCenterPointType',
            'CircleByCenterPointType' => '\\StructType\\CircleByCenterPointType',
            'CubicSplineType' => '\\StructType\\CubicSplineType',
            'BSplineType' => '\\StructType\\BSplineType',
            'KnotType' => '\\StructType\\KnotType',
            'KnotPropertyType' => '\\StructType\\KnotPropertyType',
            'BezierType' => '\\StructType\\BezierType',
            'OffsetCurveType' => '\\StructType\\OffsetCurveType',
            'AffinePlacementType' => '\\StructType\\AffinePlacementType',
            'ClothoidType' => '\\StructType\\ClothoidType',
            'refLocation' => '\\StructType\\RefLocation',
            'GeodesicStringType' => '\\StructType\\GeodesicStringType',
            'GeodesicType' => '\\StructType\\GeodesicType',
            'SurfaceType' => '\\StructType\\SurfaceType',
            'OrientableSurfaceType' => '\\StructType\\OrientableSurfaceType',
            'AbstractSurfacePatchType' => '\\StructType\\AbstractSurfacePatchType',
            'SurfacePatchArrayPropertyType' => '\\ArrayType\\SurfacePatchArrayPropertyType',
            'PolygonPatchType' => '\\StructType\\PolygonPatchType',
            'TriangleType' => '\\StructType\\TriangleType',
            'RectangleType' => '\\StructType\\RectangleType',
            'RingType' => '\\StructType\\RingType',
            'RingPropertyType' => '\\StructType\\RingPropertyType',
            'rows' => '\\StructType\\Rows',
            'Row' => '\\StructType\\Row',
            'AbstractParametricCurveSurfaceType' => '\\StructType\\AbstractParametricCurveSurfaceType',
            'AbstractGriddedSurfaceType' => '\\StructType\\AbstractGriddedSurfaceType',
            'ConeType' => '\\StructType\\ConeType',
            'CylinderType' => '\\StructType\\CylinderType',
            'SphereType' => '\\StructType\\SphereType',
            'TinType' => '\\StructType\\TinType',
            'controlPoint' => '\\StructType\\ControlPoint',
            'LineStringSegmentArrayPropertyType' => '\\ArrayType\\LineStringSegmentArrayPropertyType',
            'AbstractSolidType' => '\\StructType\\AbstractSolidType',
            'SolidPropertyType' => '\\StructType\\SolidPropertyType',
            'SolidArrayPropertyType' => '\\StructType\\SolidArrayPropertyType',
            'SolidType' => '\\StructType\\SolidType',
            'ShellType' => '\\StructType\\ShellType',
            'ShellPropertyType' => '\\StructType\\ShellPropertyType',
            'AbstractGeometricAggregateType' => '\\StructType\\AbstractGeometricAggregateType',
            'MultiGeometryType' => '\\StructType\\MultiGeometryType',
            'MultiGeometryPropertyType' => '\\StructType\\MultiGeometryPropertyType',
            'MultiPointType' => '\\StructType\\MultiPointType',
            'MultiPointPropertyType' => '\\StructType\\MultiPointPropertyType',
            'MultiCurveType' => '\\StructType\\MultiCurveType',
            'MultiCurvePropertyType' => '\\StructType\\MultiCurvePropertyType',
            'MultiSurfaceType' => '\\StructType\\MultiSurfaceType',
            'MultiSurfacePropertyType' => '\\StructType\\MultiSurfacePropertyType',
            'MultiSolidType' => '\\StructType\\MultiSolidType',
            'MultiSolidPropertyType' => '\\StructType\\MultiSolidPropertyType',
            'AbstractTimeObjectType' => '\\StructType\\AbstractTimeObjectType',
            'AbstractTimePrimitiveType' => '\\StructType\\AbstractTimePrimitiveType',
            'TimePrimitivePropertyType' => '\\StructType\\TimePrimitivePropertyType',
            'RelatedTimeType' => '\\StructType\\RelatedTimeType',
            'AbstractTimeComplexType' => '\\StructType\\AbstractTimeComplexType',
            'AbstractTimeGeometricPrimitiveType' => '\\StructType\\AbstractTimeGeometricPrimitiveType',
            'TimeInstantType' => '\\StructType\\TimeInstantType',
            'TimeInstantPropertyType' => '\\StructType\\TimeInstantPropertyType',
            'TimePeriodType' => '\\StructType\\TimePeriodType',
            'TimePeriodPropertyType' => '\\StructType\\TimePeriodPropertyType',
            'TimePositionType' => '\\StructType\\TimePositionType',
            'TimeIntervalLengthType' => '\\StructType\\TimeIntervalLengthType',
            'AbstractFeatureType' => '\\StructType\\AbstractFeatureType',
            'FeaturePropertyType' => '\\StructType\\FeaturePropertyType',
            'BoundingShapeType' => '\\StructType\\BoundingShapeType',
            'EnvelopeWithTimePeriodType' => '\\StructType\\EnvelopeWithTimePeriodType',
            'AbstractFeatureMemberType' => '\\StructType\\AbstractFeatureMemberType',
            'DirectionPropertyType' => '\\StructType\\DirectionPropertyType',
            'DirectionVectorType' => '\\StructType\\DirectionVectorType',
            'DirectionDescriptionType' => '\\StructType\\DirectionDescriptionType',
            'DynamicFeatureType' => '\\StructType\\DynamicFeatureType',
            'DynamicFeatureCollectionType' => '\\StructType\\DynamicFeatureCollectionType',
            'DynamicFeatureMemberType' => '\\StructType\\DynamicFeatureMemberType',
            'AbstractTimeSliceType' => '\\StructType\\AbstractTimeSliceType',
            'HistoryPropertyType' => '\\StructType\\HistoryPropertyType',
            'GeometricComplexType' => '\\StructType\\GeometricComplexType',
            'GeometricComplexPropertyType' => '\\StructType\\GeometricComplexPropertyType',
            'CompositeCurveType' => '\\StructType\\CompositeCurveType',
            'CompositeSurfaceType' => '\\StructType\\CompositeSurfaceType',
            'CompositeSolidType' => '\\StructType\\CompositeSolidType',
            'AbstractTopologyType' => '\\StructType\\AbstractTopologyType',
            'AbstractTopoPrimitiveType' => '\\StructType\\AbstractTopoPrimitiveType',
            'NodeOrEdgePropertyType' => '\\StructType\\NodeOrEdgePropertyType',
            'NodePropertyType' => '\\StructType\\NodePropertyType',
            'FaceOrTopoSolidPropertyType' => '\\StructType\\FaceOrTopoSolidPropertyType',
            'TopoSolidPropertyType' => '\\StructType\\TopoSolidPropertyType',
            'NodeType' => '\\StructType\\NodeType',
            'DirectedNodePropertyType' => '\\StructType\\DirectedNodePropertyType',
            'EdgeType' => '\\StructType\\EdgeType',
            'DirectedEdgePropertyType' => '\\StructType\\DirectedEdgePropertyType',
            'FaceType' => '\\StructType\\FaceType',
            'DirectedFacePropertyType' => '\\StructType\\DirectedFacePropertyType',
            'TopoSolidType' => '\\StructType\\TopoSolidType',
            'DirectedTopoSolidPropertyType' => '\\StructType\\DirectedTopoSolidPropertyType',
            'TopoPointType' => '\\StructType\\TopoPointType',
            'TopoPointPropertyType' => '\\StructType\\TopoPointPropertyType',
            'TopoCurveType' => '\\StructType\\TopoCurveType',
            'TopoCurvePropertyType' => '\\StructType\\TopoCurvePropertyType',
            'TopoSurfaceType' => '\\StructType\\TopoSurfaceType',
            'TopoSurfacePropertyType' => '\\StructType\\TopoSurfacePropertyType',
            'TopoVolumeType' => '\\StructType\\TopoVolumeType',
            'TopoVolumePropertyType' => '\\StructType\\TopoVolumePropertyType',
            'TopoComplexType' => '\\StructType\\TopoComplexType',
            'TopoPrimitiveMemberType' => '\\StructType\\TopoPrimitiveMemberType',
            'TopoPrimitiveArrayAssociationType' => '\\StructType\\TopoPrimitiveArrayAssociationType',
            'TopoComplexPropertyType' => '\\StructType\\TopoComplexPropertyType',
            'Boolean' => '\\StructType\\Boolean',
            'Category' => '\\StructType\\Category',
            'Count' => '\\StructType\\Count',
            'Quantity' => '\\StructType\\Quantity',
            'ValuePropertyType' => '\\StructType\\ValuePropertyType',
            'ValueArrayPropertyType' => '\\StructType\\ValueArrayPropertyType',
            'CompositeValueType' => '\\StructType\\CompositeValueType',
            'ValueArrayType' => '\\StructType\\ValueArrayType',
            'CategoryExtentType' => '\\StructType\\CategoryExtentType',
            'QuantityExtentType' => '\\StructType\\QuantityExtentType',
            'BooleanPropertyType' => '\\StructType\\BooleanPropertyType',
            'CategoryPropertyType' => '\\StructType\\CategoryPropertyType',
            'QuantityPropertyType' => '\\StructType\\QuantityPropertyType',
            'CountPropertyType' => '\\StructType\\CountPropertyType',
            'GridType' => '\\StructType\\GridType',
            'GridLimitsType' => '\\StructType\\GridLimitsType',
            'GridEnvelopeType' => '\\StructType\\GridEnvelopeType',
            'RectifiedGridType' => '\\StructType\\RectifiedGridType',
            'AbstractCoverageType' => '\\StructType\\AbstractCoverageType',
            'DiscreteCoverageType' => '\\StructType\\DiscreteCoverageType',
            'AbstractContinuousCoverageType' => '\\StructType\\AbstractContinuousCoverageType',
            'DomainSetType' => '\\StructType\\DomainSetType',
            'RangeSetType' => '\\StructType\\RangeSetType',
            'DataBlockType' => '\\StructType\\DataBlockType',
            'FileType' => '\\StructType\\FileType',
            'CoverageFunctionType' => '\\StructType\\CoverageFunctionType',
            'MappingRuleType' => '\\StructType\\MappingRuleType',
            'GridFunctionType' => '\\StructType\\GridFunctionType',
            'SequenceRuleType' => '\\StructType\\SequenceRuleType',
            'AbstractObject_Type' => '\\StructType\\AbstractObject_Type',
            'ObjectReference_PropertyType' => '\\StructType\\ObjectReference_PropertyType',
            'CodeListValue_Type' => '\\StructType\\CodeListValue_Type',
            'TypeName_Type' => '\\StructType\\TypeName_Type',
            'TypeName_PropertyType' => '\\StructType\\TypeName_PropertyType',
            'MemberName_Type' => '\\StructType\\MemberName_Type',
            'MemberName_PropertyType' => '\\StructType\\MemberName_PropertyType',
            'Multiplicity_Type' => '\\StructType\\Multiplicity_Type',
            'Multiplicity_PropertyType' => '\\StructType\\Multiplicity_PropertyType',
            'MultiplicityRange_Type' => '\\StructType\\MultiplicityRange_Type',
            'MultiplicityRange_PropertyType' => '\\StructType\\MultiplicityRange_PropertyType',
            'Measure_PropertyType' => '\\StructType\\Measure_PropertyType',
            'Length_PropertyType' => '\\StructType\\Length_PropertyType',
            'Angle_PropertyType' => '\\StructType\\Angle_PropertyType',
            'Scale_PropertyType' => '\\StructType\\Scale_PropertyType',
            'Distance_PropertyType' => '\\StructType\\Distance_PropertyType',
            'CharacterString_PropertyType' => '\\StructType\\CharacterString_PropertyType',
            'Boolean_PropertyType' => '\\StructType\\Boolean_PropertyType',
            'GenericName_PropertyType' => '\\StructType\\GenericName_PropertyType',
            'LocalName_PropertyType' => '\\StructType\\LocalName_PropertyType',
            'ScopedName_PropertyType' => '\\StructType\\ScopedName_PropertyType',
            'UomAngle_PropertyType' => '\\StructType\\UomAngle_PropertyType',
            'UomLength_PropertyType' => '\\StructType\\UomLength_PropertyType',
            'UomScale_PropertyType' => '\\StructType\\UomScale_PropertyType',
            'UnitOfMeasure_PropertyType' => '\\StructType\\UnitOfMeasure_PropertyType',
            'UomArea_PropertyType' => '\\StructType\\UomArea_PropertyType',
            'UomVelocity_PropertyType' => '\\StructType\\UomVelocity_PropertyType',
            'UomTime_PropertyType' => '\\StructType\\UomTime_PropertyType',
            'UomVolume_PropertyType' => '\\StructType\\UomVolume_PropertyType',
            'DateTime_PropertyType' => '\\StructType\\DateTime_PropertyType',
            'Date_PropertyType' => '\\StructType\\Date_PropertyType',
            'Number_PropertyType' => '\\StructType\\Number_PropertyType',
            'Decimal_PropertyType' => '\\StructType\\Decimal_PropertyType',
            'Real_PropertyType' => '\\StructType\\Real_PropertyType',
            'Integer_PropertyType' => '\\StructType\\Integer_PropertyType',
            'UnlimitedInteger_Type' => '\\StructType\\UnlimitedInteger_Type',
            'UnlimitedInteger_PropertyType' => '\\StructType\\UnlimitedInteger_PropertyType',
            'Record_PropertyType' => '\\StructType\\Record_PropertyType',
            'RecordType_Type' => '\\StructType\\RecordType_Type',
            'RecordType_PropertyType' => '\\StructType\\RecordType_PropertyType',
            'Binary_Type' => '\\StructType\\Binary_Type',
            'Binary_PropertyType' => '\\StructType\\Binary_PropertyType',
            'GM_Point_PropertyType' => '\\StructType\\GM_Point_PropertyType',
            'GM_Object_PropertyType' => '\\StructType\\GM_Object_PropertyType',
            'TM_Primitive_PropertyType' => '\\StructType\\TM_Primitive_PropertyType',
            'TM_PeriodDuration_PropertyType' => '\\StructType\\TM_PeriodDuration_PropertyType',
            'SC_CRS_PropertyType' => '\\StructType\\SC_CRS_PropertyType',
            'EX_TemporalExtent_Type' => '\\StructType\\EX_TemporalExtent_Type',
            'EX_TemporalExtent_PropertyType' => '\\StructType\\EX_TemporalExtent_PropertyType',
            'EX_VerticalExtent_Type' => '\\StructType\\EX_VerticalExtent_Type',
            'EX_VerticalExtent_PropertyType' => '\\StructType\\EX_VerticalExtent_PropertyType',
            'EX_BoundingPolygon_Type' => '\\StructType\\EX_BoundingPolygon_Type',
            'EX_BoundingPolygon_PropertyType' => '\\StructType\\EX_BoundingPolygon_PropertyType',
            'EX_Extent_Type' => '\\StructType\\EX_Extent_Type',
            'EX_Extent_PropertyType' => '\\StructType\\EX_Extent_PropertyType',
            'AbstractEX_GeographicExtent_Type' => '\\StructType\\AbstractEX_GeographicExtent_Type',
            'EX_GeographicExtent_PropertyType' => '\\StructType\\EX_GeographicExtent_PropertyType',
            'EX_GeographicBoundingBox_Type' => '\\StructType\\EX_GeographicBoundingBox_Type',
            'EX_GeographicBoundingBox_PropertyType' => '\\StructType\\EX_GeographicBoundingBox_PropertyType',
            'EX_SpatialTemporalExtent_Type' => '\\StructType\\EX_SpatialTemporalExtent_Type',
            'EX_SpatialTemporalExtent_PropertyType' => '\\StructType\\EX_SpatialTemporalExtent_PropertyType',
            'EX_GeographicDescription_Type' => '\\StructType\\EX_GeographicDescription_Type',
            'EX_GeographicDescription_PropertyType' => '\\StructType\\EX_GeographicDescription_PropertyType',
            'RS_Identifier_Type' => '\\StructType\\RS_Identifier_Type',
            'RS_Identifier_PropertyType' => '\\StructType\\RS_Identifier_PropertyType',
            'MD_ReferenceSystem_Type' => '\\StructType\\MD_ReferenceSystem_Type',
            'MD_ReferenceSystem_PropertyType' => '\\StructType\\MD_ReferenceSystem_PropertyType',
            'MD_Identifier_Type' => '\\StructType\\MD_Identifier_Type',
            'MD_Identifier_PropertyType' => '\\StructType\\MD_Identifier_PropertyType',
            'AbstractRS_ReferenceSystem_Type' => '\\StructType\\AbstractRS_ReferenceSystem_Type',
            'RS_ReferenceSystem_PropertyType' => '\\StructType\\RS_ReferenceSystem_PropertyType',
            'CI_ResponsibleParty_Type' => '\\StructType\\CI_ResponsibleParty_Type',
            'CI_ResponsibleParty_PropertyType' => '\\StructType\\CI_ResponsibleParty_PropertyType',
            'CI_Citation_Type' => '\\StructType\\CI_Citation_Type',
            'CI_Citation_PropertyType' => '\\StructType\\CI_Citation_PropertyType',
            'CI_Address_Type' => '\\StructType\\CI_Address_Type',
            'CI_Address_PropertyType' => '\\StructType\\CI_Address_PropertyType',
            'CI_OnlineResource_Type' => '\\StructType\\CI_OnlineResource_Type',
            'CI_OnlineResource_PropertyType' => '\\StructType\\CI_OnlineResource_PropertyType',
            'CI_Contact_Type' => '\\StructType\\CI_Contact_Type',
            'CI_Contact_PropertyType' => '\\StructType\\CI_Contact_PropertyType',
            'CI_Telephone_Type' => '\\StructType\\CI_Telephone_Type',
            'CI_Telephone_PropertyType' => '\\StructType\\CI_Telephone_PropertyType',
            'CI_Date_Type' => '\\StructType\\CI_Date_Type',
            'CI_Date_PropertyType' => '\\StructType\\CI_Date_PropertyType',
            'CI_Series_Type' => '\\StructType\\CI_Series_Type',
            'CI_Series_PropertyType' => '\\StructType\\CI_Series_PropertyType',
            'URL_PropertyType' => '\\StructType\\URL_PropertyType',
            'CI_RoleCode_PropertyType' => '\\StructType\\CI_RoleCode_PropertyType',
            'CI_PresentationFormCode_PropertyType' => '\\StructType\\CI_PresentationFormCode_PropertyType',
            'CI_OnLineFunctionCode_PropertyType' => '\\StructType\\CI_OnLineFunctionCode_PropertyType',
            'CI_DateTypeCode_PropertyType' => '\\StructType\\CI_DateTypeCode_PropertyType',
            'MD_GridSpatialRepresentation_Type' => '\\StructType\\MD_GridSpatialRepresentation_Type',
            'MD_GridSpatialRepresentation_PropertyType' => '\\StructType\\MD_GridSpatialRepresentation_PropertyType',
            'MD_VectorSpatialRepresentation_Type' => '\\StructType\\MD_VectorSpatialRepresentation_Type',
            'MD_VectorSpatialRepresentation_PropertyType' => '\\StructType\\MD_VectorSpatialRepresentation_PropertyType',
            'AbstractMD_SpatialRepresentation_Type' => '\\StructType\\AbstractMD_SpatialRepresentation_Type',
            'MD_SpatialRepresentation_PropertyType' => '\\StructType\\MD_SpatialRepresentation_PropertyType',
            'MD_Georeferenceable_Type' => '\\StructType\\MD_Georeferenceable_Type',
            'MD_Georeferenceable_PropertyType' => '\\StructType\\MD_Georeferenceable_PropertyType',
            'MD_Dimension_Type' => '\\StructType\\MD_Dimension_Type',
            'MD_Dimension_PropertyType' => '\\StructType\\MD_Dimension_PropertyType',
            'MD_Georectified_Type' => '\\StructType\\MD_Georectified_Type',
            'MD_Georectified_PropertyType' => '\\StructType\\MD_Georectified_PropertyType',
            'MD_GeometricObjects_Type' => '\\StructType\\MD_GeometricObjects_Type',
            'MD_GeometricObjects_PropertyType' => '\\StructType\\MD_GeometricObjects_PropertyType',
            'MD_PixelOrientationCode_PropertyType' => '\\StructType\\MD_PixelOrientationCode_PropertyType',
            'MD_TopologyLevelCode_PropertyType' => '\\StructType\\MD_TopologyLevelCode_PropertyType',
            'MD_GeometricObjectTypeCode_PropertyType' => '\\StructType\\MD_GeometricObjectTypeCode_PropertyType',
            'MD_CellGeometryCode_PropertyType' => '\\StructType\\MD_CellGeometryCode_PropertyType',
            'MD_DimensionNameTypeCode_PropertyType' => '\\StructType\\MD_DimensionNameTypeCode_PropertyType',
            'MD_ExtendedElementInformation_Type' => '\\StructType\\MD_ExtendedElementInformation_Type',
            'MD_ExtendedElementInformation_PropertyType' => '\\StructType\\MD_ExtendedElementInformation_PropertyType',
            'MD_MetadataExtensionInformation_Type' => '\\StructType\\MD_MetadataExtensionInformation_Type',
            'MD_MetadataExtensionInformation_PropertyType' => '\\StructType\\MD_MetadataExtensionInformation_PropertyType',
            'MD_ObligationCode_PropertyType' => '\\StructType\\MD_ObligationCode_PropertyType',
            'MD_DatatypeCode_PropertyType' => '\\StructType\\MD_DatatypeCode_PropertyType',
            'MD_FeatureCatalogueDescription_Type' => '\\StructType\\MD_FeatureCatalogueDescription_Type',
            'MD_FeatureCatalogueDescription_PropertyType' => '\\StructType\\MD_FeatureCatalogueDescription_PropertyType',
            'MD_CoverageDescription_Type' => '\\StructType\\MD_CoverageDescription_Type',
            'MD_CoverageDescription_PropertyType' => '\\StructType\\MD_CoverageDescription_PropertyType',
            'MD_ImageDescription_Type' => '\\StructType\\MD_ImageDescription_Type',
            'MD_ImageDescription_PropertyType' => '\\StructType\\MD_ImageDescription_PropertyType',
            'AbstractMD_ContentInformation_Type' => '\\StructType\\AbstractMD_ContentInformation_Type',
            'MD_ContentInformation_PropertyType' => '\\StructType\\MD_ContentInformation_PropertyType',
            'MD_RangeDimension_Type' => '\\StructType\\MD_RangeDimension_Type',
            'MD_RangeDimension_PropertyType' => '\\StructType\\MD_RangeDimension_PropertyType',
            'MD_Band_Type' => '\\StructType\\MD_Band_Type',
            'MD_Band_PropertyType' => '\\StructType\\MD_Band_PropertyType',
            'MD_CoverageContentTypeCode_PropertyType' => '\\StructType\\MD_CoverageContentTypeCode_PropertyType',
            'MD_ImagingConditionCode_PropertyType' => '\\StructType\\MD_ImagingConditionCode_PropertyType',
            'MD_ApplicationSchemaInformation_Type' => '\\StructType\\MD_ApplicationSchemaInformation_Type',
            'MD_ApplicationSchemaInformation_PropertyType' => '\\StructType\\MD_ApplicationSchemaInformation_PropertyType',
            'MD_PortrayalCatalogueReference_Type' => '\\StructType\\MD_PortrayalCatalogueReference_Type',
            'MD_PortrayalCatalogueReference_PropertyType' => '\\StructType\\MD_PortrayalCatalogueReference_PropertyType',
            'MD_Constraints_Type' => '\\StructType\\MD_Constraints_Type',
            'MD_Constraints_PropertyType' => '\\StructType\\MD_Constraints_PropertyType',
            'MD_LegalConstraints_Type' => '\\StructType\\MD_LegalConstraints_Type',
            'MD_LegalConstraints_PropertyType' => '\\StructType\\MD_LegalConstraints_PropertyType',
            'MD_SecurityConstraints_Type' => '\\StructType\\MD_SecurityConstraints_Type',
            'MD_SecurityConstraints_PropertyType' => '\\StructType\\MD_SecurityConstraints_PropertyType',
            'MD_ClassificationCode_PropertyType' => '\\StructType\\MD_ClassificationCode_PropertyType',
            'MD_RestrictionCode_PropertyType' => '\\StructType\\MD_RestrictionCode_PropertyType',
            'MD_Medium_Type' => '\\StructType\\MD_Medium_Type',
            'MD_Medium_PropertyType' => '\\StructType\\MD_Medium_PropertyType',
            'MD_DigitalTransferOptions_Type' => '\\StructType\\MD_DigitalTransferOptions_Type',
            'MD_DigitalTransferOptions_PropertyType' => '\\StructType\\MD_DigitalTransferOptions_PropertyType',
            'MD_StandardOrderProcess_Type' => '\\StructType\\MD_StandardOrderProcess_Type',
            'MD_StandardOrderProcess_PropertyType' => '\\StructType\\MD_StandardOrderProcess_PropertyType',
            'MD_Distributor_Type' => '\\StructType\\MD_Distributor_Type',
            'MD_Distributor_PropertyType' => '\\StructType\\MD_Distributor_PropertyType',
            'MD_Distribution_Type' => '\\StructType\\MD_Distribution_Type',
            'MD_Distribution_PropertyType' => '\\StructType\\MD_Distribution_PropertyType',
            'MD_Format_Type' => '\\StructType\\MD_Format_Type',
            'MD_Format_PropertyType' => '\\StructType\\MD_Format_PropertyType',
            'MD_DistributionUnits_PropertyType' => '\\StructType\\MD_DistributionUnits_PropertyType',
            'MD_MediumFormatCode_PropertyType' => '\\StructType\\MD_MediumFormatCode_PropertyType',
            'MD_MediumNameCode_PropertyType' => '\\StructType\\MD_MediumNameCode_PropertyType',
            'MD_MaintenanceInformation_Type' => '\\StructType\\MD_MaintenanceInformation_Type',
            'MD_MaintenanceInformation_PropertyType' => '\\StructType\\MD_MaintenanceInformation_PropertyType',
            'MD_ScopeDescription_Type' => '\\StructType\\MD_ScopeDescription_Type',
            'MD_ScopeDescription_PropertyType' => '\\StructType\\MD_ScopeDescription_PropertyType',
            'MD_MaintenanceFrequencyCode_PropertyType' => '\\StructType\\MD_MaintenanceFrequencyCode_PropertyType',
            'MD_ScopeCode_PropertyType' => '\\StructType\\MD_ScopeCode_PropertyType',
            'AbstractMD_Identification_Type' => '\\StructType\\AbstractMD_Identification_Type',
            'MD_Identification_PropertyType' => '\\StructType\\MD_Identification_PropertyType',
            'MD_BrowseGraphic_Type' => '\\StructType\\MD_BrowseGraphic_Type',
            'MD_BrowseGraphic_PropertyType' => '\\StructType\\MD_BrowseGraphic_PropertyType',
            'MD_DataIdentification_Type' => '\\StructType\\MD_DataIdentification_Type',
            'MD_DataIdentification_PropertyType' => '\\StructType\\MD_DataIdentification_PropertyType',
            'MD_ServiceIdentification_Type' => '\\StructType\\MD_ServiceIdentification_Type',
            'MD_ServiceIdentification_PropertyType' => '\\StructType\\MD_ServiceIdentification_PropertyType',
            'MD_RepresentativeFraction_Type' => '\\StructType\\MD_RepresentativeFraction_Type',
            'MD_RepresentativeFraction_PropertyType' => '\\StructType\\MD_RepresentativeFraction_PropertyType',
            'MD_Usage_Type' => '\\StructType\\MD_Usage_Type',
            'MD_Usage_PropertyType' => '\\StructType\\MD_Usage_PropertyType',
            'MD_Keywords_Type' => '\\StructType\\MD_Keywords_Type',
            'MD_Keywords_PropertyType' => '\\StructType\\MD_Keywords_PropertyType',
            'DS_Association_Type' => '\\StructType\\DS_Association_Type',
            'DS_Association_PropertyType' => '\\StructType\\DS_Association_PropertyType',
            'MD_AggregateInformation_Type' => '\\StructType\\MD_AggregateInformation_Type',
            'MD_AggregateInformation_PropertyType' => '\\StructType\\MD_AggregateInformation_PropertyType',
            'MD_Resolution_Type' => '\\StructType\\MD_Resolution_Type',
            'MD_Resolution_PropertyType' => '\\StructType\\MD_Resolution_PropertyType',
            'MD_TopicCategoryCode_PropertyType' => '\\StructType\\MD_TopicCategoryCode_PropertyType',
            'MD_CharacterSetCode_PropertyType' => '\\StructType\\MD_CharacterSetCode_PropertyType',
            'MD_SpatialRepresentationTypeCode_PropertyType' => '\\StructType\\MD_SpatialRepresentationTypeCode_PropertyType',
            'MD_ProgressCode_PropertyType' => '\\StructType\\MD_ProgressCode_PropertyType',
            'MD_KeywordTypeCode_PropertyType' => '\\StructType\\MD_KeywordTypeCode_PropertyType',
            'DS_AssociationTypeCode_PropertyType' => '\\StructType\\DS_AssociationTypeCode_PropertyType',
            'DS_InitiativeTypeCode_PropertyType' => '\\StructType\\DS_InitiativeTypeCode_PropertyType',
            'LI_ProcessStep_Type' => '\\StructType\\LI_ProcessStep_Type',
            'LI_ProcessStep_PropertyType' => '\\StructType\\LI_ProcessStep_PropertyType',
            'LI_Source_Type' => '\\StructType\\LI_Source_Type',
            'LI_Source_PropertyType' => '\\StructType\\LI_Source_PropertyType',
            'LI_Lineage_Type' => '\\StructType\\LI_Lineage_Type',
            'LI_Lineage_PropertyType' => '\\StructType\\LI_Lineage_PropertyType',
            'DQ_ConformanceResult_Type' => '\\StructType\\DQ_ConformanceResult_Type',
            'DQ_ConformanceResult_PropertyType' => '\\StructType\\DQ_ConformanceResult_PropertyType',
            'DQ_QuantitativeResult_Type' => '\\StructType\\DQ_QuantitativeResult_Type',
            'DQ_QuantitativeResult_PropertyType' => '\\StructType\\DQ_QuantitativeResult_PropertyType',
            'AbstractDQ_Result_Type' => '\\StructType\\AbstractDQ_Result_Type',
            'DQ_Result_PropertyType' => '\\StructType\\DQ_Result_PropertyType',
            'DQ_TemporalValidity_Type' => '\\StructType\\DQ_TemporalValidity_Type',
            'DQ_TemporalValidity_PropertyType' => '\\StructType\\DQ_TemporalValidity_PropertyType',
            'DQ_TemporalConsistency_Type' => '\\StructType\\DQ_TemporalConsistency_Type',
            'DQ_TemporalConsistency_PropertyType' => '\\StructType\\DQ_TemporalConsistency_PropertyType',
            'DQ_AccuracyOfATimeMeasurement_Type' => '\\StructType\\DQ_AccuracyOfATimeMeasurement_Type',
            'DQ_AccuracyOfATimeMeasurement_PropertyType' => '\\StructType\\DQ_AccuracyOfATimeMeasurement_PropertyType',
            'DQ_QuantitativeAttributeAccuracy_Type' => '\\StructType\\DQ_QuantitativeAttributeAccuracy_Type',
            'DQ_QuantitativeAttributeAccuracy_PropertyType' => '\\StructType\\DQ_QuantitativeAttributeAccuracy_PropertyType',
            'DQ_NonQuantitativeAttributeAccuracy_Type' => '\\StructType\\DQ_NonQuantitativeAttributeAccuracy_Type',
            'DQ_NonQuantitativeAttributeAccuracy_PropertyType' => '\\StructType\\DQ_NonQuantitativeAttributeAccuracy_PropertyType',
            'DQ_ThematicClassificationCorrectness_Type' => '\\StructType\\DQ_ThematicClassificationCorrectness_Type',
            'DQ_ThematicClassificationCorrectness_PropertyType' => '\\StructType\\DQ_ThematicClassificationCorrectness_PropertyType',
            'DQ_RelativeInternalPositionalAccuracy_Type' => '\\StructType\\DQ_RelativeInternalPositionalAccuracy_Type',
            'DQ_RelativeInternalPositionalAccuracy_PropertyType' => '\\StructType\\DQ_RelativeInternalPositionalAccuracy_PropertyType',
            'DQ_GriddedDataPositionalAccuracy_Type' => '\\StructType\\DQ_GriddedDataPositionalAccuracy_Type',
            'DQ_GriddedDataPositionalAccuracy_PropertyType' => '\\StructType\\DQ_GriddedDataPositionalAccuracy_PropertyType',
            'DQ_AbsoluteExternalPositionalAccuracy_Type' => '\\StructType\\DQ_AbsoluteExternalPositionalAccuracy_Type',
            'DQ_AbsoluteExternalPositionalAccuracy_PropertyType' => '\\StructType\\DQ_AbsoluteExternalPositionalAccuracy_PropertyType',
            'DQ_TopologicalConsistency_Type' => '\\StructType\\DQ_TopologicalConsistency_Type',
            'DQ_TopologicalConsistency_PropertyType' => '\\StructType\\DQ_TopologicalConsistency_PropertyType',
            'DQ_FormatConsistency_Type' => '\\StructType\\DQ_FormatConsistency_Type',
            'DQ_FormatConsistency_PropertyType' => '\\StructType\\DQ_FormatConsistency_PropertyType',
            'DQ_DomainConsistency_Type' => '\\StructType\\DQ_DomainConsistency_Type',
            'DQ_DomainConsistency_PropertyType' => '\\StructType\\DQ_DomainConsistency_PropertyType',
            'DQ_ConceptualConsistency_Type' => '\\StructType\\DQ_ConceptualConsistency_Type',
            'DQ_ConceptualConsistency_PropertyType' => '\\StructType\\DQ_ConceptualConsistency_PropertyType',
            'DQ_CompletenessOmission_Type' => '\\StructType\\DQ_CompletenessOmission_Type',
            'DQ_CompletenessOmission_PropertyType' => '\\StructType\\DQ_CompletenessOmission_PropertyType',
            'DQ_CompletenessCommission_Type' => '\\StructType\\DQ_CompletenessCommission_Type',
            'DQ_CompletenessCommission_PropertyType' => '\\StructType\\DQ_CompletenessCommission_PropertyType',
            'AbstractDQ_TemporalAccuracy_Type' => '\\StructType\\AbstractDQ_TemporalAccuracy_Type',
            'DQ_TemporalAccuracy_PropertyType' => '\\StructType\\DQ_TemporalAccuracy_PropertyType',
            'AbstractDQ_ThematicAccuracy_Type' => '\\StructType\\AbstractDQ_ThematicAccuracy_Type',
            'DQ_ThematicAccuracy_PropertyType' => '\\StructType\\DQ_ThematicAccuracy_PropertyType',
            'AbstractDQ_PositionalAccuracy_Type' => '\\StructType\\AbstractDQ_PositionalAccuracy_Type',
            'DQ_PositionalAccuracy_PropertyType' => '\\StructType\\DQ_PositionalAccuracy_PropertyType',
            'AbstractDQ_LogicalConsistency_Type' => '\\StructType\\AbstractDQ_LogicalConsistency_Type',
            'DQ_LogicalConsistency_PropertyType' => '\\StructType\\DQ_LogicalConsistency_PropertyType',
            'AbstractDQ_Completeness_Type' => '\\StructType\\AbstractDQ_Completeness_Type',
            'DQ_Completeness_PropertyType' => '\\StructType\\DQ_Completeness_PropertyType',
            'AbstractDQ_Element_Type' => '\\StructType\\AbstractDQ_Element_Type',
            'DQ_Element_PropertyType' => '\\StructType\\DQ_Element_PropertyType',
            'DQ_DataQuality_Type' => '\\StructType\\DQ_DataQuality_Type',
            'DQ_DataQuality_PropertyType' => '\\StructType\\DQ_DataQuality_PropertyType',
            'DQ_Scope_Type' => '\\StructType\\DQ_Scope_Type',
            'DQ_Scope_PropertyType' => '\\StructType\\DQ_Scope_PropertyType',
            'DQ_EvaluationMethodTypeCode_PropertyType' => '\\StructType\\DQ_EvaluationMethodTypeCode_PropertyType',
            'PT_FreeText_Type' => '\\StructType\\PT_FreeText_Type',
            'PT_FreeText_PropertyType' => '\\StructType\\PT_FreeText_PropertyType',
            'PT_Locale_Type' => '\\StructType\\PT_Locale_Type',
            'PT_Locale_PropertyType' => '\\StructType\\PT_Locale_PropertyType',
            'LocalisedCharacterString_Type' => '\\StructType\\LocalisedCharacterString_Type',
            'LocalisedCharacterString_PropertyType' => '\\StructType\\LocalisedCharacterString_PropertyType',
            'PT_LocaleContainer_Type' => '\\StructType\\PT_LocaleContainer_Type',
            'PT_LocaleContainer_PropertyType' => '\\StructType\\PT_LocaleContainer_PropertyType',
            'LanguageCode_PropertyType' => '\\StructType\\LanguageCode_PropertyType',
            'Country_PropertyType' => '\\StructType\\Country_PropertyType',
            'MD_Metadata_Type' => '\\StructType\\MD_Metadata_Type',
            'MD_Metadata_PropertyType' => '\\StructType\\MD_Metadata_PropertyType',
            'AbstractDS_Aggregate_Type' => '\\StructType\\AbstractDS_Aggregate_Type',
            'DS_Aggregate_PropertyType' => '\\StructType\\DS_Aggregate_PropertyType',
            'DS_DataSet_Type' => '\\StructType\\DS_DataSet_Type',
            'DS_DataSet_PropertyType' => '\\StructType\\DS_DataSet_PropertyType',
            'DS_OtherAggregate_Type' => '\\StructType\\DS_OtherAggregate_Type',
            'DS_OtherAggregate_PropertyType' => '\\StructType\\DS_OtherAggregate_PropertyType',
            'DS_Series_Type' => '\\StructType\\DS_Series_Type',
            'DS_Series_PropertyType' => '\\StructType\\DS_Series_PropertyType',
            'DS_Initiative_Type' => '\\StructType\\DS_Initiative_Type',
            'DS_Initiative_PropertyType' => '\\StructType\\DS_Initiative_PropertyType',
            'DS_Platform_Type' => '\\StructType\\DS_Platform_Type',
            'DS_Platform_PropertyType' => '\\StructType\\DS_Platform_PropertyType',
            'DS_Sensor_Type' => '\\StructType\\DS_Sensor_Type',
            'DS_Sensor_PropertyType' => '\\StructType\\DS_Sensor_PropertyType',
            'DS_ProductionSeries_Type' => '\\StructType\\DS_ProductionSeries_Type',
            'DS_ProductionSeries_PropertyType' => '\\StructType\\DS_ProductionSeries_PropertyType',
            'DS_StereoMate_Type' => '\\StructType\\DS_StereoMate_Type',
            'DS_StereoMate_PropertyType' => '\\StructType\\DS_StereoMate_PropertyType',
            'IdentifiedObjectType' => '\\StructType\\IdentifiedObjectType',
            'AbstractCRSType' => '\\StructType\\AbstractCRSType',
            'domainOfValidity' => '\\StructType\\DomainOfValidity',
            'CRSPropertyType' => '\\StructType\\CRSPropertyType',
            'CoordinateSystemAxisType' => '\\StructType\\CoordinateSystemAxisType',
            'CoordinateSystemAxisPropertyType' => '\\StructType\\CoordinateSystemAxisPropertyType',
            'AbstractCoordinateSystemType' => '\\StructType\\AbstractCoordinateSystemType',
            'CoordinateSystemPropertyType' => '\\StructType\\CoordinateSystemPropertyType',
            'EllipsoidalCSType' => '\\StructType\\EllipsoidalCSType',
            'EllipsoidalCSPropertyType' => '\\StructType\\EllipsoidalCSPropertyType',
            'CartesianCSType' => '\\StructType\\CartesianCSType',
            'CartesianCSPropertyType' => '\\StructType\\CartesianCSPropertyType',
            'VerticalCSType' => '\\StructType\\VerticalCSType',
            'VerticalCSPropertyType' => '\\StructType\\VerticalCSPropertyType',
            'TimeCSType' => '\\StructType\\TimeCSType',
            'TimeCSPropertyType' => '\\StructType\\TimeCSPropertyType',
            'LinearCSType' => '\\StructType\\LinearCSType',
            'LinearCSPropertyType' => '\\StructType\\LinearCSPropertyType',
            'UserDefinedCSType' => '\\StructType\\UserDefinedCSType',
            'UserDefinedCSPropertyType' => '\\StructType\\UserDefinedCSPropertyType',
            'SphericalCSType' => '\\StructType\\SphericalCSType',
            'SphericalCSPropertyType' => '\\StructType\\SphericalCSPropertyType',
            'PolarCSType' => '\\StructType\\PolarCSType',
            'PolarCSPropertyType' => '\\StructType\\PolarCSPropertyType',
            'CylindricalCSType' => '\\StructType\\CylindricalCSType',
            'CylindricalCSPropertyType' => '\\StructType\\CylindricalCSPropertyType',
            'AffineCSType' => '\\StructType\\AffineCSType',
            'AffineCSPropertyType' => '\\StructType\\AffineCSPropertyType',
            'AbstractDatumType' => '\\StructType\\AbstractDatumType',
            'DatumPropertyType' => '\\StructType\\DatumPropertyType',
            'GeodeticDatumType' => '\\StructType\\GeodeticDatumType',
            'GeodeticDatumPropertyType' => '\\StructType\\GeodeticDatumPropertyType',
            'EllipsoidType' => '\\StructType\\EllipsoidType',
            'secondDefiningParameter' => '\\StructType\\SecondDefiningParameter',
            'SecondDefiningParameter' => '\\StructType\\SecondDefiningParameter_1',
            'EllipsoidPropertyType' => '\\StructType\\EllipsoidPropertyType',
            'PrimeMeridianType' => '\\StructType\\PrimeMeridianType',
            'PrimeMeridianPropertyType' => '\\StructType\\PrimeMeridianPropertyType',
            'EngineeringDatumType' => '\\StructType\\EngineeringDatumType',
            'EngineeringDatumPropertyType' => '\\StructType\\EngineeringDatumPropertyType',
            'ImageDatumType' => '\\StructType\\ImageDatumType',
            'ImageDatumPropertyType' => '\\StructType\\ImageDatumPropertyType',
            'VerticalDatumType' => '\\StructType\\VerticalDatumType',
            'VerticalDatumPropertyType' => '\\StructType\\VerticalDatumPropertyType',
            'TemporalDatumType' => '\\StructType\\TemporalDatumType',
            'TemporalDatumBaseType' => '\\StructType\\TemporalDatumBaseType',
            'TemporalDatumPropertyType' => '\\StructType\\TemporalDatumPropertyType',
            'AbstractCoordinateOperationType' => '\\StructType\\AbstractCoordinateOperationType',
            'coordinateOperationAccuracy' => '\\StructType\\CoordinateOperationAccuracy',
            'CoordinateOperationPropertyType' => '\\StructType\\CoordinateOperationPropertyType',
            'SingleOperationPropertyType' => '\\StructType\\SingleOperationPropertyType',
            'AbstractGeneralConversionType' => '\\StructType\\AbstractGeneralConversionType',
            'GeneralConversionPropertyType' => '\\StructType\\GeneralConversionPropertyType',
            'AbstractGeneralTransformationType' => '\\StructType\\AbstractGeneralTransformationType',
            'GeneralTransformationPropertyType' => '\\StructType\\GeneralTransformationPropertyType',
            'ConcatenatedOperationType' => '\\StructType\\ConcatenatedOperationType',
            'ConcatenatedOperationPropertyType' => '\\StructType\\ConcatenatedOperationPropertyType',
            'PassThroughOperationType' => '\\StructType\\PassThroughOperationType',
            'PassThroughOperationPropertyType' => '\\StructType\\PassThroughOperationPropertyType',
            'ConversionType' => '\\StructType\\ConversionType',
            'ConversionPropertyType' => '\\StructType\\ConversionPropertyType',
            'TransformationType' => '\\StructType\\TransformationType',
            'TransformationPropertyType' => '\\StructType\\TransformationPropertyType',
            'AbstractGeneralParameterValueType' => '\\StructType\\AbstractGeneralParameterValueType',
            'AbstractGeneralParameterValuePropertyType' => '\\StructType\\AbstractGeneralParameterValuePropertyType',
            'ParameterValueType' => '\\StructType\\ParameterValueType',
            'ParameterValueGroupType' => '\\StructType\\ParameterValueGroupType',
            'OperationMethodType' => '\\StructType\\OperationMethodType',
            'formulaCitation' => '\\StructType\\FormulaCitation',
            'OperationMethodPropertyType' => '\\StructType\\OperationMethodPropertyType',
            'AbstractGeneralOperationParameterType' => '\\StructType\\AbstractGeneralOperationParameterType',
            'AbstractGeneralOperationParameterPropertyType' => '\\StructType\\AbstractGeneralOperationParameterPropertyType',
            'OperationParameterType' => '\\StructType\\OperationParameterType',
            'OperationParameterPropertyType' => '\\StructType\\OperationParameterPropertyType',
            'OperationParameterGroupType' => '\\StructType\\OperationParameterGroupType',
            'OperationParameterGroupPropertyType' => '\\StructType\\OperationParameterGroupPropertyType',
            'SingleCRSPropertyType' => '\\StructType\\SingleCRSPropertyType',
            'AbstractGeneralDerivedCRSType' => '\\StructType\\AbstractGeneralDerivedCRSType',
            'CompoundCRSType' => '\\StructType\\CompoundCRSType',
            'CompoundCRSPropertyType' => '\\StructType\\CompoundCRSPropertyType',
            'GeodeticCRSType' => '\\StructType\\GeodeticCRSType',
            'GeodeticCRSPropertyType' => '\\StructType\\GeodeticCRSPropertyType',
            'VerticalCRSType' => '\\StructType\\VerticalCRSType',
            'VerticalCRSPropertyType' => '\\StructType\\VerticalCRSPropertyType',
            'ProjectedCRSType' => '\\StructType\\ProjectedCRSType',
            'ProjectedCRSPropertyType' => '\\StructType\\ProjectedCRSPropertyType',
            'DerivedCRSType' => '\\StructType\\DerivedCRSType',
            'DerivedCRSPropertyType' => '\\StructType\\DerivedCRSPropertyType',
            'EngineeringCRSType' => '\\StructType\\EngineeringCRSType',
            'EngineeringCRSPropertyType' => '\\StructType\\EngineeringCRSPropertyType',
            'ImageCRSType' => '\\StructType\\ImageCRSType',
            'ImageCRSPropertyType' => '\\StructType\\ImageCRSPropertyType',
            'TemporalCRSType' => '\\StructType\\TemporalCRSType',
            'TemporalCRSPropertyType' => '\\StructType\\TemporalCRSPropertyType',
            'ObservationType' => '\\StructType\\ObservationType',
            'ProcedurePropertyType' => '\\StructType\\ProcedurePropertyType',
            'TargetPropertyType' => '\\StructType\\TargetPropertyType',
            'ResultType' => '\\StructType\\ResultType',
            'DirectedObservationType' => '\\StructType\\DirectedObservationType',
            'DirectedObservationAtDistanceType' => '\\StructType\\DirectedObservationAtDistanceType',
            'AbstractTimeTopologyPrimitiveType' => '\\StructType\\AbstractTimeTopologyPrimitiveType',
            'TimeTopologyPrimitivePropertyType' => '\\StructType\\TimeTopologyPrimitivePropertyType',
            'TimeTopologyComplexType' => '\\StructType\\TimeTopologyComplexType',
            'TimeTopologyComplexPropertyType' => '\\StructType\\TimeTopologyComplexPropertyType',
            'TimeNodeType' => '\\StructType\\TimeNodeType',
            'TimeNodePropertyType' => '\\StructType\\TimeNodePropertyType',
            'TimeEdgeType' => '\\StructType\\TimeEdgeType',
            'TimeEdgePropertyType' => '\\StructType\\TimeEdgePropertyType',
            'TimeReferenceSystemType' => '\\StructType\\TimeReferenceSystemType',
            'TimeCoordinateSystemType' => '\\StructType\\TimeCoordinateSystemType',
            'TimeCalendarType' => '\\StructType\\TimeCalendarType',
            'TimeCalendarEraType' => '\\StructType\\TimeCalendarEraType',
            'TimeCalendarPropertyType' => '\\StructType\\TimeCalendarPropertyType',
            'TimeCalendarEraPropertyType' => '\\StructType\\TimeCalendarEraPropertyType',
            'TimeClockType' => '\\StructType\\TimeClockType',
            'TimeClockPropertyType' => '\\StructType\\TimeClockPropertyType',
            'TimeOrdinalReferenceSystemType' => '\\StructType\\TimeOrdinalReferenceSystemType',
            'TimeOrdinalEraType' => '\\StructType\\TimeOrdinalEraType',
            'TimeOrdinalEraPropertyType' => '\\StructType\\TimeOrdinalEraPropertyType',
            'OperationPropertyType' => '\\StructType\\OperationPropertyType',
            'TemporalCSType' => '\\StructType\\TemporalCSType',
            'TemporalCSPropertyType' => '\\StructType\\TemporalCSPropertyType',
            'ObliqueCartesianCSType' => '\\StructType\\ObliqueCartesianCSType',
            'ObliqueCartesianCSPropertyType' => '\\StructType\\ObliqueCartesianCSPropertyType',
            'GeographicCRSType' => '\\StructType\\GeographicCRSType',
            'GeographicCRSPropertyType' => '\\StructType\\GeographicCRSPropertyType',
            'GeocentricCRSType' => '\\StructType\\GeocentricCRSType',
            'GeocentricCRSPropertyType' => '\\StructType\\GeocentricCRSPropertyType',
            'DMSAngleType' => '\\StructType\\DMSAngleType',
            'DegreesType' => '\\StructType\\DegreesType',
            'AngleChoiceType' => '\\StructType\\AngleChoiceType',
            'ArrayAssociationType' => '\\StructType\\ArrayAssociationType',
            'StringOrRefType' => '\\StructType\\StringOrRefType',
            'BagType' => '\\StructType\\BagType',
            'ArrayType' => '\\ArrayType\\ArrayType',
            'MetaDataPropertyType' => '\\StructType\\MetaDataPropertyType',
            'AbstractMetaDataType' => '\\StructType\\AbstractMetaDataType',
            'GenericMetaDataType' => '\\StructType\\GenericMetaDataType',
            'LocationPropertyType' => '\\StructType\\LocationPropertyType',
            'PriorityLocationPropertyType' => '\\StructType\\PriorityLocationPropertyType',
            'FeatureArrayPropertyType' => '\\ArrayType\\FeatureArrayPropertyType',
            'BoundedFeatureType' => '\\StructType\\BoundedFeatureType',
            'AbstractFeatureCollectionType' => '\\StructType\\AbstractFeatureCollectionType',
            'FeatureCollectionType' => '\\StructType\\FeatureCollectionType',
            'IndirectEntryType' => '\\StructType\\IndirectEntryType',
            'DefinitionProxyType' => '\\StructType\\DefinitionProxyType',
            'MovingObjectStatusType' => '\\StructType\\MovingObjectStatusType',
            'Code' => '\\StructType\\Code',
            'AlternativeOrganisationshierarchie' => '\\StructType\\AlternativeOrganisationshierarchie',
            'Anschrift' => '\\StructType\\Anschrift',
            'AnschriftOrganisationseinheit' => '\\StructType\\AnschriftOrganisationseinheit',
            'AnyXMLContent' => '\\StructType\\AnyXMLContent',
            'Auskunftshinweismodul' => '\\StructType\\Auskunftshinweismodul',
            'Bankverbindung' => '\\StructType\\Bankverbindung',
            'BasisinformationObjekt' => '\\StructType\\BasisinformationObjekt',
            'Basisnachricht' => '\\StructType\\Basisnachricht',
            'Bearbeitungsdauermodul' => '\\StructType\\Bearbeitungsdauermodul',
            'BegriffImKontext' => '\\StructType\\BegriffImKontext',
            'BegriffImKontextModul' => '\\StructType\\BegriffImKontextModul',
            'Code.Anschrifttyp' => '\\StructType\\Code_Anschrifttyp',
            'Code.BegriffImKontextTyp' => '\\StructType\\Code_BegriffImKontextTyp',
            'Code.BezirkDestatis' => '\\StructType\\Code_BezirkDestatis',
            'Code.BundeslandDestatis' => '\\StructType\\Code_BundeslandDestatis',
            'Code.DokumentTyp' => '\\StructType\\Code_DokumentTyp',
            'Code.Erreichbarkeitskanal' => '\\StructType\\Code_Erreichbarkeitskanal',
            'Code.GemeindeschluesselDestatis' => '\\StructType\\Code_GemeindeschluesselDestatis',
            'Code.Gemeindeteilschluessel' => '\\StructType\\Code_Gemeindeteilschluessel',
            'Code.Hierarchietyp' => '\\StructType\\Code_Hierarchietyp',
            'Code.Identifizierungsmittel' => '\\StructType\\Code_Identifizierungsmittel',
            'Code.KlassifizierungBenutzerdefiniert' => '\\StructType\\Code_KlassifizierungBenutzerdefiniert',
            'Code.KommunikationssystemTyp' => '\\StructType\\Code_KommunikationssystemTyp',
            'Code.Kostentyp' => '\\StructType\\Code_Kostentyp',
            'Code.KreisDestatis' => '\\StructType\\Code_KreisDestatis',
            'Code.LeiKaLeistung' => '\\StructType\\Code_LeiKaLeistung',
            'Code.LeiKaLeistungsgruppierung' => '\\StructType\\Code_LeiKaLeistungsgruppierung',
            'Code.LeiKaTypisierung' => '\\StructType\\Code_LeiKaTypisierung',
            'Code.LeiKaVerrichtungskennung' => '\\StructType\\Code_LeiKaVerrichtungskennung',
            'Code.Leistungsadressat' => '\\StructType\\Code_Leistungsadressat',
            'Code.Leistungsklasse' => '\\StructType\\Code_Leistungsklasse',
            'Code.Leistungstextmodul' => '\\StructType\\Code_Leistungstextmodul',
            'Code.NachrichtAntwortCode' => '\\StructType\\Code_NachrichtAntwortCode',
            'Code.OZGLage' => '\\StructType\\Code_OZGLage',
            'Code.OZGLeistung' => '\\StructType\\Code_OZGLeistung',
            'Code.OZGThemenfeld' => '\\StructType\\Code_OZGThemenfeld',
            'Code.OnlinedienstDynamischerParameterTyp' => '\\StructType\\Code_OnlinedienstDynamischerParameterTyp',
            'Code.OnlinedienstLinkTyp' => '\\StructType\\Code_OnlinedienstLinkTyp',
            'Code.OrganisationshierarchieTyp' => '\\StructType\\Code_OrganisationshierarchieTyp',
            'Code.Rechtsform' => '\\StructType\\Code_Rechtsform',
            'Code.RegionalschluesselDestatis' => '\\StructType\\Code_RegionalschluesselDestatis',
            'Code.SDGInformationsbereich' => '\\StructType\\Code_SDGInformationsbereich',
            'Code.Signatur' => '\\StructType\\Code_Signatur',
            'Code.StaatDestatis' => '\\StructType\\Code_StaatDestatis',
            'Code.StaatsangehoerigkeitDestatis' => '\\StructType\\Code_StaatsangehoerigkeitDestatis',
            'Code.Tagesposition' => '\\StructType\\Code_Tagesposition',
            'Code.Tagestyp' => '\\StructType\\Code_Tagestyp',
            'Code.TextmodultypIndividuell' => '\\StructType\\Code_TextmodultypIndividuell',
            'Code.Vertrauensniveau' => '\\StructType\\Code_Vertrauensniveau',
            'Code.Wirtschaftszweig2008Destatis' => '\\StructType\\Code_Wirtschaftszweig2008Destatis',
            'Code.Zahlungsweise' => '\\StructType\\Code_Zahlungsweise',
            'Code.Zeiteinheit' => '\\StructType\\Code_Zeiteinheit',
            'Code.Zeitserientyp' => '\\StructType\\Code_Zeitserientyp',
            'Code.Zustaendigkeitskriterium' => '\\StructType\\Code_Zustaendigkeitskriterium',
            'Code.Zustaendigkeitsrolle' => '\\StructType\\Code_Zustaendigkeitsrolle',
            'Dokument' => '\\StructType\\Dokument',
            'DokumentTyp_Erweiterbar' => '\\StructType\\DokumentTyp_Erweiterbar',
            'Dokumentmodul' => '\\StructType\\Dokumentmodul',
            'Erreichbarkeit' => '\\StructType\\Erreichbarkeit',
            'FachlicheFreigabeModul' => '\\StructType\\FachlicheFreigabeModul',
            'Formular' => '\\StructType\\Formular',
            'Formulardatei' => '\\StructType\\Formulardatei',
            'FormulardateiBinaer' => '\\StructType\\FormulardateiBinaer',
            'FormulardateiLink' => '\\StructType\\FormulardateiLink',
            'FormulardateiXML' => '\\StructType\\FormulardateiXML',
            'FristAuswahl' => '\\StructType\\FristAuswahl',
            'FristDauer' => '\\StructType\\FristDauer',
            'FristMitTyp' => '\\StructType\\FristMitTyp',
            'FristOhneTyp' => '\\StructType\\FristOhneTyp',
            'FristStichtag' => '\\StructType\\FristStichtag',
            'von' => '\\StructType\\Von',
            'bis' => '\\StructType\\Bis',
            'Fristmodul' => '\\StructType\\Fristmodul',
            'Fristtyp_Erweiterbar' => '\\StructType\\Fristtyp_Erweiterbar',
            'code' => '\\StructType\\Code_1',
            'Gebiet' => '\\StructType\\Gebiet',
            'Gebietsklasse' => '\\StructType\\Gebietsklasse',
            'Gebietstyp' => '\\StructType\\Gebietstyp',
            'Geokodierung' => '\\StructType\\Geokodierung',
            'Herausgeber' => '\\StructType\\Herausgeber',
            'Hierarchie' => '\\StructType\\Hierarchie',
            'HyperlinkErweitert' => '\\StructType\\HyperlinkErweitert',
            'Kategorieklasse' => '\\StructType\\Kategorieklasse',
            'Kommunikationssystem' => '\\StructType\\Kommunikationssystem',
            'Kontaktperson' => '\\StructType\\Kontaktperson',
            'Kosten' => '\\StructType\\Kosten',
            'KostenFix' => '\\StructType\\KostenFix',
            'KostenFrei' => '\\StructType\\KostenFrei',
            'KostenTyp_Erweiterbar' => '\\StructType\\KostenTyp_Erweiterbar',
            'KostenVariabel' => '\\StructType\\KostenVariabel',
            'Kostenauswahl' => '\\StructType\\Kostenauswahl',
            'Kostenmodul' => '\\StructType\\Kostenmodul',
            'Leistung' => '\\StructType\\Leistung',
            'LeistungSpezialisierung' => '\\StructType\\LeistungSpezialisierung',
            'LeistungsgruppierungAuswahl' => '\\StructType\\LeistungsgruppierungAuswahl',
            'Leistungskategorie' => '\\StructType\\Leistungskategorie',
            'LeistungskategorieKlasse' => '\\StructType\\LeistungskategorieKlasse',
            'Leistungsmodul' => '\\StructType\\Leistungsmodul',
            'LeistungsmodulSpezialisierung' => '\\StructType\\LeistungsmodulSpezialisierung',
            'Leistungsstruktur' => '\\StructType\\Leistungsstruktur',
            'LeistungsstrukturObjekt' => '\\StructType\\LeistungsstrukturObjekt',
            'LeistungsstrukturObjektMitVerrichtung' => '\\StructType\\LeistungsstrukturObjektMitVerrichtung',
            'LeistungsstrukturObjektMitVerrichtungUndDetail' => '\\StructType\\LeistungsstrukturObjektMitVerrichtungUndDetail',
            'LeistungsverrichtungAuswahl' => '\\StructType\\LeistungsverrichtungAuswahl',
            'NachrichtAnfrage' => '\\StructType\\NachrichtAnfrage',
            'NachrichtAntwort' => '\\StructType\\NachrichtAntwort',
            'Nachrichtenkopf' => '\\StructType\\Nachrichtenkopf',
            'NameOrganisation' => '\\StructType\\NameOrganisation',
            'OZGLeistung' => '\\StructType\\OZGLeistung',
            'OZGZuordnungLeiKaLeistung' => '\\StructType\\OZGZuordnungLeiKaLeistung',
            'Onlinedienst' => '\\StructType\\Onlinedienst',
            'OnlinedienstDynamischerParameter' => '\\StructType\\OnlinedienstDynamischerParameter',
            'OnlinedienstErweitert' => '\\StructType\\OnlinedienstErweitert',
            'OnlinedienstLink' => '\\StructType\\OnlinedienstLink',
            'OnlinedienstParameter' => '\\StructType\\OnlinedienstParameter',
            'Organisationseinheit' => '\\StructType\\Organisationseinheit',
            'OrganisationseinheitErweitert' => '\\StructType\\OrganisationseinheitErweitert',
            'Organisationseinheitskategorie' => '\\StructType\\Organisationseinheitskategorie',
            'OrganisationseinheitskategorieKlasse' => '\\StructType\\OrganisationseinheitskategorieKlasse',
            'Sprache' => '\\StructType\\Sprache',
            'Sprachversion' => '\\StructType\\Sprachversion',
            'SuchparameterKategorie' => '\\StructType\\SuchparameterKategorie',
            'Suchprofil' => '\\StructType\\Suchprofil',
            'Textmodul' => '\\StructType\\Textmodul',
            'TextmodulIndividuell' => '\\StructType\\TextmodulIndividuell',
            'UrsprungsportalModul' => '\\StructType\\UrsprungsportalModul',
            'Versionsinformation' => '\\StructType\\Versionsinformation',
            'VerwaltungspolitischeKodierung' => '\\StructType\\VerwaltungspolitischeKodierung',
            'Wirtschaftszweig_Spezifizierbar' => '\\StructType\\Wirtschaftszweig_Spezifizierbar',
            'Zeitserie' => '\\StructType\\Zeitserie',
            'Zeitserien' => '\\StructType\\Zeitserien',
            'Zustaendigkeit' => '\\StructType\\Zustaendigkeit',
            'ZustaendigkeitOrganisationseinheit' => '\\StructType\\ZustaendigkeitOrganisationseinheit',
            'ZustaendigkeitPerson' => '\\StructType\\ZustaendigkeitPerson',
            'Zustaendigkeitskriterium' => '\\StructType\\Zustaendigkeitskriterium',
            'ZustaendigkeitskriteriumCode_Erweiterbar' => '\\StructType\\ZustaendigkeitskriteriumCode_Erweiterbar',
            'AnfrageLeistung' => '\\StructType\\AnfrageLeistung',
            'AnfrageLeistungsbericht' => '\\StructType\\AnfrageLeistungsbericht',
            'AnfrageLeistungskategorie' => '\\StructType\\AnfrageLeistungskategorie',
            'AnfrageLeistungskategorieKlasse' => '\\StructType\\AnfrageLeistungskategorieKlasse',
            'AnfrageSpezialisierung' => '\\StructType\\AnfrageSpezialisierung',
            'AntwortLeistung' => '\\StructType\\AntwortLeistung',
            'AntwortLeistungsbericht' => '\\StructType\\AntwortLeistungsbericht',
            'AntwortLeistungskategorie' => '\\StructType\\AntwortLeistungskategorie',
            'AntwortLeistungskategorieKlasse' => '\\StructType\\AntwortLeistungskategorieKlasse',
            'AntwortSpezialisierung' => '\\StructType\\AntwortSpezialisierung',
            'AuswahlLeistungBasisinformation' => '\\StructType\\AuswahlLeistungBasisinformation',
            'LeistungsverrichtungAuswahlID' => '\\StructType\\LeistungsverrichtungAuswahlID',
            'SuchprofilLeistung' => '\\StructType\\SuchprofilLeistung',
            'SuchprofilLeistungsbericht' => '\\StructType\\SuchprofilLeistungsbericht',
            'SuchprofilLeistungskategorie' => '\\StructType\\SuchprofilLeistungskategorie',
            'SuchprofilLeistungskategorieKlasse' => '\\StructType\\SuchprofilLeistungskategorieKlasse',
            'SuchprofilLeistungsverrichtung' => '\\StructType\\SuchprofilLeistungsverrichtung',
            'SuchprofilSpezialisierung' => '\\StructType\\SuchprofilSpezialisierung',
            'leistungen.anfrage.leistung.040101' => '\\StructType\\Leistungen_anfrage_leistung_040101',
            'leistungen.anfrage.leistungskategorie.040102' => '\\StructType\\Leistungen_anfrage_leistungskategorie_040102',
            'leistungen.anfrage.leistungskategorieklasse.040103' => '\\StructType\\Leistungen_anfrage_leistungskategorieklasse_040103',
            'leistungen.antwort.leistung.040104' => '\\StructType\\Leistungen_antwort_leistung_040104',
            'leistungen.antwort.leistungskategorie.040105' => '\\StructType\\Leistungen_antwort_leistungskategorie_040105',
            'leistungen.antwort.leistungskategorieklasse.040106' => '\\StructType\\Leistungen_antwort_leistungskategorieklasse_040106',
            'leistungen.anfrage.leistungsbericht.040107' => '\\StructType\\Leistungen_anfrage_leistungsbericht_040107',
            'leistungen.antwort.leistungsbericht.040108' => '\\StructType\\Leistungen_antwort_leistungsbericht_040108',
            'leistungen.anfrage.spezialisierung.040109' => '\\StructType\\Leistungen_anfrage_spezialisierung_040109',
            'leistungen.antwort.spezialisierung.040110' => '\\StructType\\Leistungen_antwort_spezialisierung_040110',
            'AnfrageFormular' => '\\StructType\\AnfrageFormular',
            'AnfrageKontaktperson' => '\\StructType\\AnfrageKontaktperson',
            'AnfrageOnlinedienst' => '\\StructType\\AnfrageOnlinedienst',
            'AnfrageOrganisationseinheit' => '\\StructType\\AnfrageOrganisationseinheit',
            'AnfrageOrganisationseinheitskategorie' => '\\StructType\\AnfrageOrganisationseinheitskategorie',
            'AnfrageOrganisationseinheitskategorieKlasse' => '\\StructType\\AnfrageOrganisationseinheitskategorieKlasse',
            'AntwortFormular' => '\\StructType\\AntwortFormular',
            'AntwortKontaktperson' => '\\StructType\\AntwortKontaktperson',
            'AntwortOnlinedienst' => '\\StructType\\AntwortOnlinedienst',
            'AntwortOrganisationseinheit' => '\\StructType\\AntwortOrganisationseinheit',
            'AntwortOrganisationseinheitskategorie' => '\\StructType\\AntwortOrganisationseinheitskategorie',
            'AntwortOrganisationseinheitskategorieKlasse' => '\\StructType\\AntwortOrganisationseinheitskategorieKlasse',
            'AuswahlFormularBasisinformation' => '\\StructType\\AuswahlFormularBasisinformation',
            'AuswahlKontaktpersonBasisinformation' => '\\StructType\\AuswahlKontaktpersonBasisinformation',
            'AuswahlOnlinedienstBasisinformation' => '\\StructType\\AuswahlOnlinedienstBasisinformation',
            'AuswahlOrganisationseinheitBasisinformation' => '\\StructType\\AuswahlOrganisationseinheitBasisinformation',
            'KontaktpersonErweitert' => '\\StructType\\KontaktpersonErweitert',
            'SuchprofilFormular' => '\\StructType\\SuchprofilFormular',
            'SuchprofilKontaktperson' => '\\StructType\\SuchprofilKontaktperson',
            'SuchprofilOnlinedienst' => '\\StructType\\SuchprofilOnlinedienst',
            'SuchprofilOrganisationseinheit' => '\\StructType\\SuchprofilOrganisationseinheit',
            'SuchprofilOrganisationseinheitskategorie' => '\\StructType\\SuchprofilOrganisationseinheitskategorie',
            'SuchprofilOrganisationseinheitskategorieKlasse' => '\\StructType\\SuchprofilOrganisationseinheitskategorieKlasse',
            'zustaendigkeiten.anfrage.organisationseinheit.040402' => '\\StructType\\Zustaendigkeiten_anfrage_organisationseinheit_040402',
            'zustaendigkeiten.anfrage.organisationseinheitskategorie.040403' => '\\StructType\\Zustaendigkeiten_anfrage_organisationseinheitskategorie_040403',
            'zustaendigkeiten.anfrage.organisationseinheitskategorieklasse.040404' => '\\StructType\\Zustaendigkeiten_anfrage_organisationseinheitskategorieklasse_040404',
            'zustaendigkeiten.antwort.organisationseinheit.040406' => '\\StructType\\Zustaendigkeiten_antwort_organisationseinheit_040406',
            'zustaendigkeiten.antwort.organisationseinheitskategorie.040407' => '\\StructType\\Zustaendigkeiten_antwort_organisationseinheitskategorie_040407',
            'zustaendigkeiten.antwort.organisationseinheitskategorieklasse.040408' => '\\StructType\\Zustaendigkeiten_antwort_organisationseinheitskategorieklasse_040408',
            'zustaendigkeiten.anfrage.kontaktperson.040409' => '\\StructType\\Zustaendigkeiten_anfrage_kontaktperson_040409',
            'zustaendigkeiten.antwort.kontaktperson.040410' => '\\StructType\\Zustaendigkeiten_antwort_kontaktperson_040410',
            'zustaendigkeiten.anfrage.formular.040411' => '\\StructType\\Zustaendigkeiten_anfrage_formular_040411',
            'zustaendigkeiten.antwort.formular.040412' => '\\StructType\\Zustaendigkeiten_antwort_formular_040412',
            'zustaendigkeiten.anfrage.onlinedienst.040413' => '\\StructType\\Zustaendigkeiten_anfrage_onlinedienst_040413',
            'zustaendigkeiten.antwort.onlinedienst.040414' => '\\StructType\\Zustaendigkeiten_antwort_onlinedienst_040414',
            'AnfrageGebiet' => '\\StructType\\AnfrageGebiet',
            'AnfrageGebietsklasse' => '\\StructType\\AnfrageGebietsklasse',
            'AnfrageGebietstyp' => '\\StructType\\AnfrageGebietstyp',
            'AntwortGebiet' => '\\StructType\\AntwortGebiet',
            'AntwortGebietsklasse' => '\\StructType\\AntwortGebietsklasse',
            'AntwortGebietstyp' => '\\StructType\\AntwortGebietstyp',
            'AuswahlGebietBasisinformation' => '\\StructType\\AuswahlGebietBasisinformation',
            'SuchprofilGebiet' => '\\StructType\\SuchprofilGebiet',
            'SuchprofilGebietsklasse' => '\\StructType\\SuchprofilGebietsklasse',
            'SuchprofilGebietstyp' => '\\StructType\\SuchprofilGebietstyp',
            'gebiete.anfrage.gebiet.040201' => '\\StructType\\Gebiete_anfrage_gebiet_040201',
            'gebiete.anfrage.gebietsklasse.040202' => '\\StructType\\Gebiete_anfrage_gebietsklasse_040202',
            'gebiete.anfrage.gebietstyp.040203' => '\\StructType\\Gebiete_anfrage_gebietstyp_040203',
            'gebiete.antwort.gebiet.040204' => '\\StructType\\Gebiete_antwort_gebiet_040204',
            'gebiete.antwort.gebietsklasse.040205' => '\\StructType\\Gebiete_antwort_gebietsklasse_040205',
            'gebiete.antwort.gebietstyp.040206' => '\\StructType\\Gebiete_antwort_gebietstyp_040206',
            'AnfrageDatei' => '\\StructType\\AnfrageDatei',
            'AnfrageHerausgeber' => '\\StructType\\AnfrageHerausgeber',
            'AnfrageSprachen' => '\\StructType\\AnfrageSprachen',
            'AntwortDatei' => '\\StructType\\AntwortDatei',
            'AntwortHerausgeber' => '\\StructType\\AntwortHerausgeber',
            'AntwortSprachen' => '\\StructType\\AntwortSprachen',
            'Datei' => '\\StructType\\Datei',
            'SuchprofilDatei' => '\\StructType\\SuchprofilDatei',
            'SuchprofilHerausgeber' => '\\StructType\\SuchprofilHerausgeber',
            'allgemein.anfrage.herausgeber.040001' => '\\StructType\\Allgemein_anfrage_herausgeber_040001',
            'allgemein.antwort.herausgeber.040002' => '\\StructType\\Allgemein_antwort_herausgeber_040002',
            'allgemein.anfrage.sprachen.040003' => '\\StructType\\Allgemein_anfrage_sprachen_040003',
            'allgemein.antwort.sprachen.040004' => '\\StructType\\Allgemein_antwort_sprachen_040004',
            'allgemein.anfrage.datei.040005' => '\\StructType\\Allgemein_anfrage_datei_040005',
            'allgemein.antwort.datei.040006' => '\\StructType\\Allgemein_antwort_datei_040006',
            'KontaktpersonTransferobjekt' => '\\StructType\\KontaktpersonTransferobjekt',
            'LoescheObjekt' => '\\StructType\\LoescheObjekt',
            'SchreibeObjekt' => '\\StructType\\SchreibeObjekt',
            'ZustaendigkeitTransferObjekt' => '\\StructType\\ZustaendigkeitTransferObjekt',
            'transfer.rueckantwort.040501' => '\\StructType\\Transfer_rueckantwort_040501',
            'transfer.operation.040502' => '\\StructType\\Transfer_operation_040502',
        );
    }
}
