<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for Codeliste.Hierarchietyp EnumType
 * @subpackage Enumerations
 */
class Codeliste_Hierarchietyp extends AbstractStructEnumBase
{
    /**
     * Constant for value 'BF'
     * Meta information extracted from the WSDL
     * - documentation: Benutzt fuer bedeutet, dass das Quellelement aktives Element für das Zielelement ist. Das Quellelement wird bei Abfragen somit bevorzugt genutzt.
     * @return string 'BF'
     */
    const VALUE_BF = 'BF';
    /**
     * Constant for value 'BS'
     * Meta information extracted from the WSDL
     * - documentation: Benutze Synonym bedeutet, dass das Quellelement passives Element für das Zielelement ist. Das Quellelement wird bei Abfragen durch das Zielelement ersetzt.
     * @return string 'BS'
     */
    const VALUE_BS = 'BS';
    /**
     * Constant for value 'OB'
     * Meta information extracted from the WSDL
     * - documentation: Oberbegriff gibt an, dass das Quellelement dem Zielelement übergeordnet ist.Der Oberbegriff ist eine Zusammenführung aller Unterbegriffe.
     * @return string 'OB'
     */
    const VALUE_OB = 'OB';
    /**
     * Constant for value 'UB'
     * Meta information extracted from the WSDL
     * - documentation: Unterbegriff gibt an, dass das Quellelement dem Zielelement untergeordnet ist. Der Unterbegriff ist eine Teilmenge des Oberbegriffs.
     * @return string 'UB'
     */
    const VALUE_UB = 'UB';
    /**
     * Constant for value 'VB'
     * Meta information extracted from the WSDL
     * - documentation: Der verwandte Begriff steht für die Beziehung von Elementen die eine wichtige Beziehung zueinander haben, aber weder hierarchisch noch äquivalent sind.
     * @return string 'VB'
     */
    const VALUE_VB = 'VB';
    /**
     * Return allowed values
     * @uses self::VALUE_BF
     * @uses self::VALUE_BS
     * @uses self::VALUE_OB
     * @uses self::VALUE_UB
     * @uses self::VALUE_VB
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_BF,
            self::VALUE_BS,
            self::VALUE_OB,
            self::VALUE_UB,
            self::VALUE_VB,
        );
    }
}
