<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for Codeliste.Kostentyp EnumType
 * @subpackage Enumerations
 */
class Codeliste_Kostentyp extends AbstractStructEnumBase
{
    /**
     * Constant for value '001'
     * Meta information extracted from the WSDL
     * - documentation: Abgaben sind materielle Aufwendungen, die zu Abgabeleistungen verpflichtete Personen an empfangsberechtigte Personen oder Institutionen abführen.
     * @return string '001'
     */
    const VALUE_001 = '001';
    /**
     * Constant for value '002'
     * Meta information extracted from the WSDL
     * - documentation: Eine Anschlußgebühr bezeichnet ein einmaliges Entgelt, das für die Nutzung einer Sache anfällt.
     * @return string '002'
     */
    const VALUE_002 = '002';
    /**
     * Constant for value '003'
     * Meta information extracted from the WSDL
     * - documentation: Eine Benutzungsgebühr bezeichnet die Kosten für die Inbetriebnahme einer Sache.
     * @return string '003'
     */
    const VALUE_003 = '003';
    /**
     * Constant for value '004'
     * Meta information extracted from the WSDL
     * - documentation: Ein Beitrag bezeichnet die Kosten, die für die Mitgliedschaft (z.B. Verein) anfallen.
     * @return string '004'
     */
    const VALUE_004 = '004';
    /**
     * Constant for value '005'
     * Meta information extracted from the WSDL
     * - documentation: Ein Bußgeld stellt eine verwaltungsrechtliche Sanktion bei Ordnungswidrigkeiten dar.
     * @return string '005'
     */
    const VALUE_005 = '005';
    /**
     * Constant for value '006'
     * Meta information extracted from the WSDL
     * - documentation: Eine Entschädigung/ Honorar bezeichnet eine Leistung, die zum Ausgleich erlittener Nachteile oder Einschränkungen geleistet wird.
     * @return string '006'
     */
    const VALUE_006 = '006';
    /**
     * Constant for value '007'
     * Meta information extracted from the WSDL
     * - documentation: Eine Erstattung bezeichnet eine Vergütung, die bei allen Auslagen, Spesen, Unkosten geleistet wird.
     * @return string '007'
     */
    const VALUE_007 = '007';
    /**
     * Constant for value '008'
     * Meta information extracted from the WSDL
     * - documentation: Eine Gebühr bezeichnet eine Abgabe, die für verschiedene behördliche Tätigkeiten erhoben wird.
     * @return string '008'
     */
    const VALUE_008 = '008';
    /**
     * Constant for value '009'
     * Meta information extracted from the WSDL
     * - documentation: Ein Honorar bezeichnet die Vergütung freiberuflicher Leistungen.
     * @return string '009'
     */
    const VALUE_009 = '009';
    /**
     * Constant for value '010'
     * Meta information extracted from the WSDL
     * - documentation: Lohn bezeichnet ein vertraglich geregeltes und regelmäßig bezogenes Entgelt für das Ausüben einer festen Tätigkeit bei Arbeitern.
     * @return string '010'
     */
    const VALUE_010 = '010';
    /**
     * Constant for value '011'
     * Meta information extracted from the WSDL
     * - documentation: Lohn / Gehalt bezeichnet ein vertraglich geregeltes und regelmäßig bezogenes Entgelt für das Ausüben einer festen Tätigkeit bei Angestellten.
     * @return string '011'
     */
    const VALUE_011 = '011';
    /**
     * Constant for value '012'
     * Meta information extracted from the WSDL
     * - documentation: Ein Ordnungsgeld bezeichnet eine von einem Gericht angeordnete Verpflichtung zur Zahlung einer Geldleistung.
     * @return string '012'
     */
    const VALUE_012 = '012';
    /**
     * Constant for value '013'
     * Meta information extracted from the WSDL
     * - documentation: Ein Spende bezeichnet eine freiwillige und unentgeltliche Leistung in Form einer Geld-, Sach-, Leistungs- oder Zeitspende für gemeinnützige, religiöse, wissenschaftliche, kulturelle oder politische Zwecke.
     * @return string '013'
     */
    const VALUE_013 = '013';
    /**
     * Constant for value '014'
     * Meta information extracted from the WSDL
     * - documentation: Als Spesen werden Betriebsausgaben und der Verpflegungsmehraufwand bezeichnet.
     * @return string '014'
     */
    const VALUE_014 = '014';
    /**
     * Constant for value '015'
     * Meta information extracted from the WSDL
     * - documentation: Staatliche Leistungen sind Maßnahmen und Leistungen, die bedürftige Personen in unterschiedlichen Lebenslagen und Lebensphasen unterstützen.
     * @return string '015'
     */
    const VALUE_015 = '015';
    /**
     * Constant for value '016'
     * Meta information extracted from the WSDL
     * - documentation: Eine Steuer ist eine Geldleistung ohne Anspruch auf eine individuelle Gegenleistung, die ein öffentlich-rechtliches Gemeinwesen zur Erzielung von Einnahmen allen Personen auferlegt, die steuerpflichtig sind.
     * @return string '016'
     */
    const VALUE_016 = '016';
    /**
     * Constant for value '017'
     * Meta information extracted from the WSDL
     * - documentation: Eine Verwaltungsgebühr bezeichnet eine kommunale Abgabe in Form einer finanziellen Gegenleistung für eine Amtshandlung oder sonstige Verwaltungstätigkeit einer Verwaltung.
     * @return string '017'
     */
    const VALUE_017 = '017';
    /**
     * Constant for value '018'
     * Meta information extracted from the WSDL
     * - documentation: Ein Verwarngeld ist eine Geldbuße, die bei geringfügigen Ordnungswidrigkeiten von einer Verwaltungsbehörde von dem Betroffenen erhoben werden kann.
     * @return string '018'
     */
    const VALUE_018 = '018';
    /**
     * Return allowed values
     * @uses self::VALUE_001
     * @uses self::VALUE_002
     * @uses self::VALUE_003
     * @uses self::VALUE_004
     * @uses self::VALUE_005
     * @uses self::VALUE_006
     * @uses self::VALUE_007
     * @uses self::VALUE_008
     * @uses self::VALUE_009
     * @uses self::VALUE_010
     * @uses self::VALUE_011
     * @uses self::VALUE_012
     * @uses self::VALUE_013
     * @uses self::VALUE_014
     * @uses self::VALUE_015
     * @uses self::VALUE_016
     * @uses self::VALUE_017
     * @uses self::VALUE_018
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_001,
            self::VALUE_002,
            self::VALUE_003,
            self::VALUE_004,
            self::VALUE_005,
            self::VALUE_006,
            self::VALUE_007,
            self::VALUE_008,
            self::VALUE_009,
            self::VALUE_010,
            self::VALUE_011,
            self::VALUE_012,
            self::VALUE_013,
            self::VALUE_014,
            self::VALUE_015,
            self::VALUE_016,
            self::VALUE_017,
            self::VALUE_018,
        );
    }
}
