<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for Codeliste.NachrichtAntwortCode EnumType
 * @subpackage Enumerations
 */
class Codeliste_NachrichtAntwortCode extends AbstractStructEnumBase
{
    /**
     * Constant for value '000'
     * Meta information extracted from the WSDL
     * - documentation: Ergebnis erfolgreich übermittelt
     * @return string '000'
     */
    const VALUE_000 = '000';
    /**
     * Constant for value '001'
     * Meta information extracted from the WSDL
     * - documentation: Es wurde die Antwort erfolgreich ermittelt - jedoch mit einem verändertem Suchprofil. Zum Beispiel wenn bestimmte Suchparameter nicht unterstützt werden. Das veränderte und angewandte Suchprofil muss in der Antwort übermittelt
     * werden.
     * @return string '001'
     */
    const VALUE_001 = '001';
    /**
     * Constant for value '101'
     * Meta information extracted from the WSDL
     * - documentation: Anfragen, die aufgrund ungültiger oder unzureichender Authentifizierung nicht weiterbearbeitet werden konnten.
     * @return string '101'
     */
    const VALUE_101 = '101';
    /**
     * Constant for value '102'
     * Meta information extracted from the WSDL
     * - documentation: Der Anfrager besitzt nicht das Recht auf Objekte zuzugreifen.
     * @return string '102'
     */
    const VALUE_102 = '102';
    /**
     * Constant for value '201'
     * Meta information extracted from the WSDL
     * - documentation: Die Anfrage ist ungültig / nicht valide. Zum Beispiel wenn diese nicht gegen das Schema validiert, Parameter fehlen oder vom Inhalt ungültig oder leer sind.
     * @return string '201'
     */
    const VALUE_201 = '201';
    /**
     * Constant for value '202'
     * Meta information extracted from the WSDL
     * - documentation: Der Aufruf dieser Funktion / Anfrage-Nachricht wird vom System nicht unterstützt bzw. ist nicht implementiert.
     * @return string '202'
     */
    const VALUE_202 = '202';
    /**
     * Constant for value '203'
     * Meta information extracted from the WSDL
     * - documentation: Die Anfrage-XZuFi-Version passt nicht zur XZuFi-Version des entgegennehmenden Systems.
     * @return string '203'
     */
    const VALUE_203 = '203';
    /**
     * Constant for value '204'
     * Meta information extracted from the WSDL
     * - documentation: Das Suchprofil wird nicht unterstützt und die Anfrage nicht ausgeführt. Hinweis: Alternativ kann eine Suche mit verändertem Suchprofil (siehe 001) durchgeführt werden.
     * @return string '204'
     */
    const VALUE_204 = '204';
    /**
     * Constant for value '301'
     * Meta information extracted from the WSDL
     * - documentation: Die Anzahl/Größe des Ergebnisses ist zu groß. Die Anfrage sollte mit weiteren Parametern im Suchprofil eingeschränkt werden. Die Quota muss in SLAs vereinbart werden.
     * @return string '301'
     */
    const VALUE_301 = '301';
    /**
     * Constant for value '901'
     * Meta information extracted from the WSDL
     * - documentation: Dienst befindet sich im Wartungsmodus und kann derzeit keine Anfragen beantworten. Die Anfrage wurde verworfen.
     * @return string '901'
     */
    const VALUE_901 = '901';
    /**
     * Constant for value '999'
     * Meta information extracted from the WSDL
     * - documentation: Ein allgemeiner bzw. nicht näher bestimmbarer Fehler ist aufgetreten.
     * @return string '999'
     */
    const VALUE_999 = '999';
    /**
     * Return allowed values
     * @uses self::VALUE_000
     * @uses self::VALUE_001
     * @uses self::VALUE_101
     * @uses self::VALUE_102
     * @uses self::VALUE_201
     * @uses self::VALUE_202
     * @uses self::VALUE_203
     * @uses self::VALUE_204
     * @uses self::VALUE_301
     * @uses self::VALUE_901
     * @uses self::VALUE_999
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_000,
            self::VALUE_001,
            self::VALUE_101,
            self::VALUE_102,
            self::VALUE_201,
            self::VALUE_202,
            self::VALUE_203,
            self::VALUE_204,
            self::VALUE_301,
            self::VALUE_901,
            self::VALUE_999,
        );
    }
}
