<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for Codeliste.Zustaendigkeitskriterium EnumType
 * @subpackage Enumerations
 */
class Codeliste_Zustaendigkeitskriterium extends AbstractStructEnumBase
{
    /**
     * Constant for value '001'
     * Meta information extracted from the WSDL
     * - documentation: Erster Buchstabe des Famliennamens, z.B. "A" oder "T-Z"
     * @return string '001'
     */
    const VALUE_001 = '001';
    /**
     * Constant for value '002'
     * Meta information extracted from the WSDL
     * - documentation: Erster Buchstabe des Vornamens, z.B. "A" oder "T-Z"
     * @return string '002'
     */
    const VALUE_002 = '002';
    /**
     * Constant for value '003'
     * Meta information extracted from the WSDL
     * - documentation: Erster Teil/Beginn des Familiennamens, z.B. "Sch"
     * @return string '003'
     */
    const VALUE_003 = '003';
    /**
     * Constant for value '004'
     * Meta information extracted from the WSDL
     * - documentation: Erster Teil/Beginn des Vornamens, z.B. "An"
     * @return string '004'
     */
    const VALUE_004 = '004';
    /**
     * Constant for value '020'
     * Meta information extracted from the WSDL
     * - documentation: Alter in (Lebens)jahren, z.B. "35" oder "0-8"
     * @return string '020'
     */
    const VALUE_020 = '020';
    /**
     * Constant for value '021'
     * Meta information extracted from the WSDL
     * - documentation: Tag der Geburt als Tag des Monats, z.B. "1" für den 1. des Monats oder "15-31" für 15. bis 31. eines beliebigen Monats
     * @return string '021'
     */
    const VALUE_021 = '021';
    /**
     * Constant for value '022'
     * Meta information extracted from the WSDL
     * - documentation: Monat der Geburt, z.B. "03" für März oder "09-12" für September bis Dezember
     * @return string '022'
     */
    const VALUE_022 = '022';
    /**
     * Constant for value '023'
     * Meta information extracted from the WSDL
     * - documentation: Jahr der Geburt, z.B. "1911" oder "2000-2014"
     * @return string '023'
     */
    const VALUE_023 = '023';
    /**
     * Constant for value '024'
     * Meta information extracted from the WSDL
     * - documentation: Konkretes Datum der Geburt, z.B. "01.03.1980-30.06.1990". Einzelangabe nicht unbedingt sinnvoll.
     * @return string '024'
     */
    const VALUE_024 = '024';
    /**
     * Constant for value '041'
     * Meta information extracted from the WSDL
     * - documentation: Gruppierung nach allgemeinen Personengruppen bzw. Zielgruppen, z.B. "Jugendliche" oder "Mieter".
     * @return string '041'
     */
    const VALUE_041 = '041';
    /**
     * Constant for value '051'
     * Meta information extracted from the WSDL
     * - documentation: Unterscheidung nach Postleitzahl.
     * @return string '051'
     */
    const VALUE_051 = '051';
    /**
     * Constant for value '052'
     * Meta information extracted from the WSDL
     * - documentation: Unterscheidung nach Straßennamen. .
     * @return string '052'
     */
    const VALUE_052 = '052';
    /**
     * Constant for value '061'
     * Meta information extracted from the WSDL
     * - documentation: Geschäftszeichen ist das Merkmal zur Differenzierung der Zuständigkeit anhand der Kennung des Sachbearbeiters und internen Fallnummer. Dies können auch beliebig komplexe Zusammenstellungen anderer Merkmal sein.
     * @return string '061'
     */
    const VALUE_061 = '061';
    /**
     * Constant for value '062'
     * Meta information extracted from the WSDL
     * - documentation: Kennnummer ist das Merkmal zur Differenzierung der Zuständigkeit anhand einer organisationsweit eindeutigen Fallnummer. Hier ist vom Geschäftszeichen als zusammengesetzte Kennung zu unterscheiden. Die Kennnummer sollte möglichst
     * nicht systematisch aufgebaut sein.
     * @return string '062'
     */
    const VALUE_062 = '062';
    /**
     * Constant for value '063'
     * Meta information extracted from the WSDL
     * - documentation: Versicherungsnummern sind spezielle systematische Kennungen für Versicherungsfälle. Soweit möglich sollte auf Geschäftszeichen oder Kennnummer zurückgegriffen werden.
     * @return string '063'
     */
    const VALUE_063 = '063';
    /**
     * Constant for value '101'
     * Meta information extracted from the WSDL
     * - documentation: Unterscheidung nach Hunderassen.
     * @return string '101'
     */
    const VALUE_101 = '101';
    /**
     * Constant for value '111'
     * Meta information extracted from the WSDL
     * - documentation: KFZ-Klassen definieren die Unterscheidung von Fahrzeugen anhand Ihrer Art und Einordnung. Dies kann einerseits allgemein wie PKW, LKW oder Motorboot sein. Andererseits kann die Unterscheidung auch anhand von speziellen KFZ-Kennungen
     * erfolgen wie z.B. C1 für LKW von 3,5 bis 7,5t.
     * @return string '111'
     */
    const VALUE_111 = '111';
    /**
     * Constant for value '112'
     * Meta information extracted from the WSDL
     * - documentation: Unterscheidung nach KFZ-Kennzeichen, z.B. "HAL-AA - HAL-XT"
     * @return string '112'
     */
    const VALUE_112 = '112';
    /**
     * Return allowed values
     * @uses self::VALUE_001
     * @uses self::VALUE_002
     * @uses self::VALUE_003
     * @uses self::VALUE_004
     * @uses self::VALUE_020
     * @uses self::VALUE_021
     * @uses self::VALUE_022
     * @uses self::VALUE_023
     * @uses self::VALUE_024
     * @uses self::VALUE_041
     * @uses self::VALUE_051
     * @uses self::VALUE_052
     * @uses self::VALUE_061
     * @uses self::VALUE_062
     * @uses self::VALUE_063
     * @uses self::VALUE_101
     * @uses self::VALUE_111
     * @uses self::VALUE_112
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_001,
            self::VALUE_002,
            self::VALUE_003,
            self::VALUE_004,
            self::VALUE_020,
            self::VALUE_021,
            self::VALUE_022,
            self::VALUE_023,
            self::VALUE_024,
            self::VALUE_041,
            self::VALUE_051,
            self::VALUE_052,
            self::VALUE_061,
            self::VALUE_062,
            self::VALUE_063,
            self::VALUE_101,
            self::VALUE_111,
            self::VALUE_112,
        );
    }
}
