<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractCoverageType StructType
 * @subpackage Structs
 */
class AbstractCoverageType extends AbstractStructBase
{
    /**
     * The domainSet
     * @var \StructType\DomainSetType
     */
    public $domainSet;
    /**
     * The rangeSet
     * @var \StructType\RangeSetType
     */
    public $rangeSet;
    /**
     * Constructor method for AbstractCoverageType
     * @uses AbstractCoverageType::setDomainSet()
     * @uses AbstractCoverageType::setRangeSet()
     * @param \StructType\DomainSetType $domainSet
     * @param \StructType\RangeSetType $rangeSet
     */
    public function __construct(\StructType\DomainSetType $domainSet = null, \StructType\RangeSetType $rangeSet = null)
    {
        $this
            ->setDomainSet($domainSet)
            ->setRangeSet($rangeSet);
    }
    /**
     * Get domainSet value
     * @return \StructType\DomainSetType|null
     */
    public function getDomainSet()
    {
        return $this->domainSet;
    }
    /**
     * Set domainSet value
     * @param \StructType\DomainSetType $domainSet
     * @return \StructType\AbstractCoverageType
     */
    public function setDomainSet(\StructType\DomainSetType $domainSet = null)
    {
        $this->domainSet = $domainSet;
        return $this;
    }
    /**
     * Get rangeSet value
     * @return \StructType\RangeSetType|null
     */
    public function getRangeSet()
    {
        return $this->rangeSet;
    }
    /**
     * Set rangeSet value
     * @param \StructType\RangeSetType $rangeSet
     * @return \StructType\AbstractCoverageType
     */
    public function setRangeSet(\StructType\RangeSetType $rangeSet = null)
    {
        $this->rangeSet = $rangeSet;
        return $this;
    }
}
