<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractDS_Aggregate_Type StructType
 * @subpackage Structs
 */
class AbstractDS_Aggregate_Type extends AbstractStructBase
{
    /**
     * The composedOf
     * @var \StructType\DS_DataSet_PropertyType
     */
    public $composedOf;
    /**
     * The seriesMetadata
     * @var \StructType\MD_Metadata_PropertyType
     */
    public $seriesMetadata;
    /**
     * The subset
     * @var \StructType\DS_Aggregate_PropertyType
     */
    public $subset;
    /**
     * The superset
     * @var \StructType\DS_Aggregate_PropertyType
     */
    public $superset;
    /**
     * Constructor method for AbstractDS_Aggregate_Type
     * @uses AbstractDS_Aggregate_Type::setComposedOf()
     * @uses AbstractDS_Aggregate_Type::setSeriesMetadata()
     * @uses AbstractDS_Aggregate_Type::setSubset()
     * @uses AbstractDS_Aggregate_Type::setSuperset()
     * @param \StructType\DS_DataSet_PropertyType $composedOf
     * @param \StructType\MD_Metadata_PropertyType $seriesMetadata
     * @param \StructType\DS_Aggregate_PropertyType $subset
     * @param \StructType\DS_Aggregate_PropertyType $superset
     */
    public function __construct(\StructType\DS_DataSet_PropertyType $composedOf = null, \StructType\MD_Metadata_PropertyType $seriesMetadata = null, \StructType\DS_Aggregate_PropertyType $subset = null, \StructType\DS_Aggregate_PropertyType $superset = null)
    {
        $this
            ->setComposedOf($composedOf)
            ->setSeriesMetadata($seriesMetadata)
            ->setSubset($subset)
            ->setSuperset($superset);
    }
    /**
     * Get composedOf value
     * @return \StructType\DS_DataSet_PropertyType|null
     */
    public function getComposedOf()
    {
        return $this->composedOf;
    }
    /**
     * Set composedOf value
     * @param \StructType\DS_DataSet_PropertyType $composedOf
     * @return \StructType\AbstractDS_Aggregate_Type
     */
    public function setComposedOf(\StructType\DS_DataSet_PropertyType $composedOf = null)
    {
        $this->composedOf = $composedOf;
        return $this;
    }
    /**
     * Get seriesMetadata value
     * @return \StructType\MD_Metadata_PropertyType|null
     */
    public function getSeriesMetadata()
    {
        return $this->seriesMetadata;
    }
    /**
     * Set seriesMetadata value
     * @param \StructType\MD_Metadata_PropertyType $seriesMetadata
     * @return \StructType\AbstractDS_Aggregate_Type
     */
    public function setSeriesMetadata(\StructType\MD_Metadata_PropertyType $seriesMetadata = null)
    {
        $this->seriesMetadata = $seriesMetadata;
        return $this;
    }
    /**
     * Get subset value
     * @return \StructType\DS_Aggregate_PropertyType|null
     */
    public function getSubset()
    {
        return $this->subset;
    }
    /**
     * Set subset value
     * @param \StructType\DS_Aggregate_PropertyType $subset
     * @return \StructType\AbstractDS_Aggregate_Type
     */
    public function setSubset(\StructType\DS_Aggregate_PropertyType $subset = null)
    {
        $this->subset = $subset;
        return $this;
    }
    /**
     * Get superset value
     * @return \StructType\DS_Aggregate_PropertyType|null
     */
    public function getSuperset()
    {
        return $this->superset;
    }
    /**
     * Set superset value
     * @param \StructType\DS_Aggregate_PropertyType $superset
     * @return \StructType\AbstractDS_Aggregate_Type
     */
    public function setSuperset(\StructType\DS_Aggregate_PropertyType $superset = null)
    {
        $this->superset = $superset;
        return $this;
    }
}
