<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for allgemein.anfrage.datei.040005 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Anfrage von Dateien (Binärdaten).
 * @subpackage Structs
 */
class Allgemein_anfrage_datei_040005 extends Basisnachricht
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Eine oder mehrere Dateianfragen.
     * - maxOccurs: unbounded
     * @var \StructType\AnfrageDatei[]
     */
    public $anfrage;
    /**
     * Constructor method for allgemein.anfrage.datei.040005
     * @uses Allgemein_anfrage_datei_040005::setAnfrage()
     * @param \StructType\AnfrageDatei[] $anfrage
     */
    public function __construct(array $anfrage = array())
    {
        $this
            ->setAnfrage($anfrage);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageDatei[]|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * This method is responsible for validating the values passed to the setAnfrage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnfrage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnfrageForArrayConstraintsFromSetAnfrage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $allgemein_anfrage_datei_040005AnfrageItem) {
            // validation for constraint: itemType
            if (!$allgemein_anfrage_datei_040005AnfrageItem instanceof \StructType\AnfrageDatei) {
                $invalidValues[] = is_object($allgemein_anfrage_datei_040005AnfrageItem) ? get_class($allgemein_anfrage_datei_040005AnfrageItem) : sprintf('%s(%s)', gettype($allgemein_anfrage_datei_040005AnfrageItem), var_export($allgemein_anfrage_datei_040005AnfrageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The anfrage property can only contain items of type \StructType\AnfrageDatei, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageDatei[] $anfrage
     * @return \StructType\Allgemein_anfrage_datei_040005
     */
    public function setAnfrage(array $anfrage = array())
    {
        // validation for constraint: array
        if ('' !== ($anfrageArrayErrorMessage = self::validateAnfrageForArrayConstraintsFromSetAnfrage($anfrage))) {
            throw new \InvalidArgumentException($anfrageArrayErrorMessage, __LINE__);
        }
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Add item to anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageDatei $item
     * @return \StructType\Allgemein_anfrage_datei_040005
     */
    public function addToAnfrage(\StructType\AnfrageDatei $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnfrageDatei) {
            throw new \InvalidArgumentException(sprintf('The anfrage property can only contain items of type \StructType\AnfrageDatei, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->anfrage[] = $item;
        return $this;
    }
}
