<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for allgemein.antwort.herausgeber.040002 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Übertragung von Antworten zu Herausgeberanfragen.
 * @subpackage Structs
 */
class Allgemein_antwort_herausgeber_040002 extends Basisnachricht
{
    /**
     * The antwort
     * Meta information extracted from the WSDL
     * - documentation: Übertragene Antworten innerhalb der Nachricht.
     * - maxOccurs: unbounded
     * @var \StructType\AntwortHerausgeber[]
     */
    public $antwort;
    /**
     * Constructor method for allgemein.antwort.herausgeber.040002
     * @uses Allgemein_antwort_herausgeber_040002::setAntwort()
     * @param \StructType\AntwortHerausgeber[] $antwort
     */
    public function __construct(array $antwort = array())
    {
        $this
            ->setAntwort($antwort);
    }
    /**
     * Get antwort value
     * @return \StructType\AntwortHerausgeber[]|null
     */
    public function getAntwort()
    {
        return $this->antwort;
    }
    /**
     * This method is responsible for validating the values passed to the setAntwort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAntwort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAntwortForArrayConstraintsFromSetAntwort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $allgemein_antwort_herausgeber_040002AntwortItem) {
            // validation for constraint: itemType
            if (!$allgemein_antwort_herausgeber_040002AntwortItem instanceof \StructType\AntwortHerausgeber) {
                $invalidValues[] = is_object($allgemein_antwort_herausgeber_040002AntwortItem) ? get_class($allgemein_antwort_herausgeber_040002AntwortItem) : sprintf('%s(%s)', gettype($allgemein_antwort_herausgeber_040002AntwortItem), var_export($allgemein_antwort_herausgeber_040002AntwortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The antwort property can only contain items of type \StructType\AntwortHerausgeber, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortHerausgeber[] $antwort
     * @return \StructType\Allgemein_antwort_herausgeber_040002
     */
    public function setAntwort(array $antwort = array())
    {
        // validation for constraint: array
        if ('' !== ($antwortArrayErrorMessage = self::validateAntwortForArrayConstraintsFromSetAntwort($antwort))) {
            throw new \InvalidArgumentException($antwortArrayErrorMessage, __LINE__);
        }
        $this->antwort = $antwort;
        return $this;
    }
    /**
     * Add item to antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortHerausgeber $item
     * @return \StructType\Allgemein_antwort_herausgeber_040002
     */
    public function addToAntwort(\StructType\AntwortHerausgeber $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AntwortHerausgeber) {
            throw new \InvalidArgumentException(sprintf('The antwort property can only contain items of type \StructType\AntwortHerausgeber, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->antwort[] = $item;
        return $this;
    }
}
