<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlternativeOrganisationshierarchie StructType
 * Meta information extracted from the WSDL
 * - documentation: AlternativeOrganisationshierarchie leitet sich von Hierarchie ab und dient zum Abbilden alternativer Hierarchien / Netze von Organisationen.
 * @subpackage Structs
 */
class AlternativeOrganisationshierarchie extends Hierarchie
{
    /**
     * The fachlicherTyp
     * Meta information extracted from the WSDL
     * - documentation: Typisierung der fachlichen Beziehung zwischen Quell- und Zielorganisationseinheit. Die Codeliste ist frei und muss zwischen den Partnern vereinbart werden.
     * - minOccurs: 0
     * @var \StructType\Code_OrganisationshierarchieTyp
     */
    public $fachlicherTyp;
    /**
     * Constructor method for AlternativeOrganisationshierarchie
     * @uses AlternativeOrganisationshierarchie::setFachlicherTyp()
     * @param \StructType\Code_OrganisationshierarchieTyp $fachlicherTyp
     */
    public function __construct(\StructType\Code_OrganisationshierarchieTyp $fachlicherTyp = null)
    {
        $this
            ->setFachlicherTyp($fachlicherTyp);
    }
    /**
     * Get fachlicherTyp value
     * @return \StructType\Code_OrganisationshierarchieTyp|null
     */
    public function getFachlicherTyp()
    {
        return $this->fachlicherTyp;
    }
    /**
     * Set fachlicherTyp value
     * @param \StructType\Code_OrganisationshierarchieTyp $fachlicherTyp
     * @return \StructType\AlternativeOrganisationshierarchie
     */
    public function setFachlicherTyp(\StructType\Code_OrganisationshierarchieTyp $fachlicherTyp = null)
    {
        $this->fachlicherTyp = $fachlicherTyp;
        return $this;
    }
}
