<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AntwortLeistungskategorieKlasse StructType
 * Meta information extracted from the WSDL
 * - documentation: Antwort zu Leistungskategorieklassenanfragen.
 * @subpackage Structs
 */
class AntwortLeistungskategorieKlasse extends NachrichtAntwort
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Die gestellte Anfrage zur Referenz.
     * @var \StructType\AnfrageLeistungskategorieKlasse
     */
    public $anfrage;
    /**
     * The ergebnisLeistungskategorieklasse
     * Meta information extracted from the WSDL
     * - documentation: Ergebnis der Anfrage.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LeistungskategorieKlasse[]
     */
    public $ergebnisLeistungskategorieklasse;
    /**
     * Constructor method for AntwortLeistungskategorieKlasse
     * @uses AntwortLeistungskategorieKlasse::setAnfrage()
     * @uses AntwortLeistungskategorieKlasse::setErgebnisLeistungskategorieklasse()
     * @param \StructType\AnfrageLeistungskategorieKlasse $anfrage
     * @param \StructType\LeistungskategorieKlasse[] $ergebnisLeistungskategorieklasse
     */
    public function __construct(\StructType\AnfrageLeistungskategorieKlasse $anfrage = null, array $ergebnisLeistungskategorieklasse = array())
    {
        $this
            ->setAnfrage($anfrage)
            ->setErgebnisLeistungskategorieklasse($ergebnisLeistungskategorieklasse);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageLeistungskategorieKlasse|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * Set anfrage value
     * @param \StructType\AnfrageLeistungskategorieKlasse $anfrage
     * @return \StructType\AntwortLeistungskategorieKlasse
     */
    public function setAnfrage(\StructType\AnfrageLeistungskategorieKlasse $anfrage = null)
    {
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Get ergebnisLeistungskategorieklasse value
     * @return \StructType\LeistungskategorieKlasse[]|null
     */
    public function getErgebnisLeistungskategorieklasse()
    {
        return $this->ergebnisLeistungskategorieklasse;
    }
    /**
     * This method is responsible for validating the values passed to the setErgebnisLeistungskategorieklasse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErgebnisLeistungskategorieklasse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErgebnisLeistungskategorieklasseForArrayConstraintsFromSetErgebnisLeistungskategorieklasse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $antwortLeistungskategorieKlasseErgebnisLeistungskategorieklasseItem) {
            // validation for constraint: itemType
            if (!$antwortLeistungskategorieKlasseErgebnisLeistungskategorieklasseItem instanceof \StructType\LeistungskategorieKlasse) {
                $invalidValues[] = is_object($antwortLeistungskategorieKlasseErgebnisLeistungskategorieklasseItem) ? get_class($antwortLeistungskategorieKlasseErgebnisLeistungskategorieklasseItem) : sprintf('%s(%s)', gettype($antwortLeistungskategorieKlasseErgebnisLeistungskategorieklasseItem), var_export($antwortLeistungskategorieKlasseErgebnisLeistungskategorieklasseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ergebnisLeistungskategorieklasse property can only contain items of type \StructType\LeistungskategorieKlasse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ergebnisLeistungskategorieklasse value
     * @throws \InvalidArgumentException
     * @param \StructType\LeistungskategorieKlasse[] $ergebnisLeistungskategorieklasse
     * @return \StructType\AntwortLeistungskategorieKlasse
     */
    public function setErgebnisLeistungskategorieklasse(array $ergebnisLeistungskategorieklasse = array())
    {
        // validation for constraint: array
        if ('' !== ($ergebnisLeistungskategorieklasseArrayErrorMessage = self::validateErgebnisLeistungskategorieklasseForArrayConstraintsFromSetErgebnisLeistungskategorieklasse($ergebnisLeistungskategorieklasse))) {
            throw new \InvalidArgumentException($ergebnisLeistungskategorieklasseArrayErrorMessage, __LINE__);
        }
        $this->ergebnisLeistungskategorieklasse = $ergebnisLeistungskategorieklasse;
        return $this;
    }
    /**
     * Add item to ergebnisLeistungskategorieklasse value
     * @throws \InvalidArgumentException
     * @param \StructType\LeistungskategorieKlasse $item
     * @return \StructType\AntwortLeistungskategorieKlasse
     */
    public function addToErgebnisLeistungskategorieklasse(\StructType\LeistungskategorieKlasse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LeistungskategorieKlasse) {
            throw new \InvalidArgumentException(sprintf('The ergebnisLeistungskategorieklasse property can only contain items of type \StructType\LeistungskategorieKlasse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ergebnisLeistungskategorieklasse[] = $item;
        return $this;
    }
}
