<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AntwortOrganisationseinheit StructType
 * Meta information extracted from the WSDL
 * - documentation: Antwort zur einer Organisationseinheitsabfrage.
 * @subpackage Structs
 */
class AntwortOrganisationseinheit extends NachrichtAntwort
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Zugeordnete Anfrage zur Referenz.
     * @var \StructType\AnfrageOrganisationseinheit
     */
    public $anfrage;
    /**
     * The ergebnis
     * Meta information extracted from the WSDL
     * - documentation: Die Organisationseinheiten als Ergebnis. Je nach Wahl im Suchprofil als Organisationseiheit oder Basisinformation.
     * - minOccurs: 0
     * @var \StructType\AuswahlOrganisationseinheitBasisinformation
     */
    public $ergebnis;
    /**
     * Constructor method for AntwortOrganisationseinheit
     * @uses AntwortOrganisationseinheit::setAnfrage()
     * @uses AntwortOrganisationseinheit::setErgebnis()
     * @param \StructType\AnfrageOrganisationseinheit $anfrage
     * @param \StructType\AuswahlOrganisationseinheitBasisinformation $ergebnis
     */
    public function __construct(\StructType\AnfrageOrganisationseinheit $anfrage = null, \StructType\AuswahlOrganisationseinheitBasisinformation $ergebnis = null)
    {
        $this
            ->setAnfrage($anfrage)
            ->setErgebnis($ergebnis);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageOrganisationseinheit|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * Set anfrage value
     * @param \StructType\AnfrageOrganisationseinheit $anfrage
     * @return \StructType\AntwortOrganisationseinheit
     */
    public function setAnfrage(\StructType\AnfrageOrganisationseinheit $anfrage = null)
    {
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Get ergebnis value
     * @return \StructType\AuswahlOrganisationseinheitBasisinformation|null
     */
    public function getErgebnis()
    {
        return $this->ergebnis;
    }
    /**
     * Set ergebnis value
     * @param \StructType\AuswahlOrganisationseinheitBasisinformation $ergebnis
     * @return \StructType\AntwortOrganisationseinheit
     */
    public function setErgebnis(\StructType\AuswahlOrganisationseinheitBasisinformation $ergebnis = null)
    {
        $this->ergebnis = $ergebnis;
        return $this;
    }
}
