<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AntwortOrganisationseinheitskategorie StructType
 * Meta information extracted from the WSDL
 * - documentation: Antwort zu Abfragen nach Organisationseinheitskategorien.
 * @subpackage Structs
 */
class AntwortOrganisationseinheitskategorie extends NachrichtAntwort
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Die gestellte Anfrage zur Referenz.
     * @var \StructType\AnfrageOrganisationseinheitskategorie
     */
    public $anfrage;
    /**
     * The ergebnisOrganisationseinheitskategorie
     * Meta information extracted from the WSDL
     * - documentation: Ergebnis der Anfrage.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Organisationseinheitskategorie[]
     */
    public $ergebnisOrganisationseinheitskategorie;
    /**
     * Constructor method for AntwortOrganisationseinheitskategorie
     * @uses AntwortOrganisationseinheitskategorie::setAnfrage()
     * @uses AntwortOrganisationseinheitskategorie::setErgebnisOrganisationseinheitskategorie()
     * @param \StructType\AnfrageOrganisationseinheitskategorie $anfrage
     * @param \StructType\Organisationseinheitskategorie[] $ergebnisOrganisationseinheitskategorie
     */
    public function __construct(\StructType\AnfrageOrganisationseinheitskategorie $anfrage = null, array $ergebnisOrganisationseinheitskategorie = array())
    {
        $this
            ->setAnfrage($anfrage)
            ->setErgebnisOrganisationseinheitskategorie($ergebnisOrganisationseinheitskategorie);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageOrganisationseinheitskategorie|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * Set anfrage value
     * @param \StructType\AnfrageOrganisationseinheitskategorie $anfrage
     * @return \StructType\AntwortOrganisationseinheitskategorie
     */
    public function setAnfrage(\StructType\AnfrageOrganisationseinheitskategorie $anfrage = null)
    {
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Get ergebnisOrganisationseinheitskategorie value
     * @return \StructType\Organisationseinheitskategorie[]|null
     */
    public function getErgebnisOrganisationseinheitskategorie()
    {
        return $this->ergebnisOrganisationseinheitskategorie;
    }
    /**
     * This method is responsible for validating the values passed to the setErgebnisOrganisationseinheitskategorie method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErgebnisOrganisationseinheitskategorie method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErgebnisOrganisationseinheitskategorieForArrayConstraintsFromSetErgebnisOrganisationseinheitskategorie(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $antwortOrganisationseinheitskategorieErgebnisOrganisationseinheitskategorieItem) {
            // validation for constraint: itemType
            if (!$antwortOrganisationseinheitskategorieErgebnisOrganisationseinheitskategorieItem instanceof \StructType\Organisationseinheitskategorie) {
                $invalidValues[] = is_object($antwortOrganisationseinheitskategorieErgebnisOrganisationseinheitskategorieItem) ? get_class($antwortOrganisationseinheitskategorieErgebnisOrganisationseinheitskategorieItem) : sprintf('%s(%s)', gettype($antwortOrganisationseinheitskategorieErgebnisOrganisationseinheitskategorieItem), var_export($antwortOrganisationseinheitskategorieErgebnisOrganisationseinheitskategorieItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ergebnisOrganisationseinheitskategorie property can only contain items of type \StructType\Organisationseinheitskategorie, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ergebnisOrganisationseinheitskategorie value
     * @throws \InvalidArgumentException
     * @param \StructType\Organisationseinheitskategorie[] $ergebnisOrganisationseinheitskategorie
     * @return \StructType\AntwortOrganisationseinheitskategorie
     */
    public function setErgebnisOrganisationseinheitskategorie(array $ergebnisOrganisationseinheitskategorie = array())
    {
        // validation for constraint: array
        if ('' !== ($ergebnisOrganisationseinheitskategorieArrayErrorMessage = self::validateErgebnisOrganisationseinheitskategorieForArrayConstraintsFromSetErgebnisOrganisationseinheitskategorie($ergebnisOrganisationseinheitskategorie))) {
            throw new \InvalidArgumentException($ergebnisOrganisationseinheitskategorieArrayErrorMessage, __LINE__);
        }
        $this->ergebnisOrganisationseinheitskategorie = $ergebnisOrganisationseinheitskategorie;
        return $this;
    }
    /**
     * Add item to ergebnisOrganisationseinheitskategorie value
     * @throws \InvalidArgumentException
     * @param \StructType\Organisationseinheitskategorie $item
     * @return \StructType\AntwortOrganisationseinheitskategorie
     */
    public function addToErgebnisOrganisationseinheitskategorie(\StructType\Organisationseinheitskategorie $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Organisationseinheitskategorie) {
            throw new \InvalidArgumentException(sprintf('The ergebnisOrganisationseinheitskategorie property can only contain items of type \StructType\Organisationseinheitskategorie, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ergebnisOrganisationseinheitskategorie[] = $item;
        return $this;
    }
}
