<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AntwortOrganisationseinheitskategorieKlasse StructType
 * Meta information extracted from the WSDL
 * - documentation: Antwort auf eine Abfrage nach Organisationseinheitskategorieklassen.
 * @subpackage Structs
 */
class AntwortOrganisationseinheitskategorieKlasse extends NachrichtAntwort
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Die gestellte Anfrage zur Referenz.
     * @var \StructType\AnfrageOrganisationseinheitskategorieKlasse
     */
    public $anfrage;
    /**
     * The ergebnisOrganisationseinheitskategorieKlasse
     * Meta information extracted from the WSDL
     * - documentation: Ergebnis der Anfrage.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OrganisationseinheitskategorieKlasse[]
     */
    public $ergebnisOrganisationseinheitskategorieKlasse;
    /**
     * Constructor method for AntwortOrganisationseinheitskategorieKlasse
     * @uses AntwortOrganisationseinheitskategorieKlasse::setAnfrage()
     * @uses AntwortOrganisationseinheitskategorieKlasse::setErgebnisOrganisationseinheitskategorieKlasse()
     * @param \StructType\AnfrageOrganisationseinheitskategorieKlasse $anfrage
     * @param \StructType\OrganisationseinheitskategorieKlasse[] $ergebnisOrganisationseinheitskategorieKlasse
     */
    public function __construct(\StructType\AnfrageOrganisationseinheitskategorieKlasse $anfrage = null, array $ergebnisOrganisationseinheitskategorieKlasse = array())
    {
        $this
            ->setAnfrage($anfrage)
            ->setErgebnisOrganisationseinheitskategorieKlasse($ergebnisOrganisationseinheitskategorieKlasse);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageOrganisationseinheitskategorieKlasse|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * Set anfrage value
     * @param \StructType\AnfrageOrganisationseinheitskategorieKlasse $anfrage
     * @return \StructType\AntwortOrganisationseinheitskategorieKlasse
     */
    public function setAnfrage(\StructType\AnfrageOrganisationseinheitskategorieKlasse $anfrage = null)
    {
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Get ergebnisOrganisationseinheitskategorieKlasse value
     * @return \StructType\OrganisationseinheitskategorieKlasse[]|null
     */
    public function getErgebnisOrganisationseinheitskategorieKlasse()
    {
        return $this->ergebnisOrganisationseinheitskategorieKlasse;
    }
    /**
     * This method is responsible for validating the values passed to the setErgebnisOrganisationseinheitskategorieKlasse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErgebnisOrganisationseinheitskategorieKlasse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErgebnisOrganisationseinheitskategorieKlasseForArrayConstraintsFromSetErgebnisOrganisationseinheitskategorieKlasse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $antwortOrganisationseinheitskategorieKlasseErgebnisOrganisationseinheitskategorieKlasseItem) {
            // validation for constraint: itemType
            if (!$antwortOrganisationseinheitskategorieKlasseErgebnisOrganisationseinheitskategorieKlasseItem instanceof \StructType\OrganisationseinheitskategorieKlasse) {
                $invalidValues[] = is_object($antwortOrganisationseinheitskategorieKlasseErgebnisOrganisationseinheitskategorieKlasseItem) ? get_class($antwortOrganisationseinheitskategorieKlasseErgebnisOrganisationseinheitskategorieKlasseItem) : sprintf('%s(%s)', gettype($antwortOrganisationseinheitskategorieKlasseErgebnisOrganisationseinheitskategorieKlasseItem), var_export($antwortOrganisationseinheitskategorieKlasseErgebnisOrganisationseinheitskategorieKlasseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ergebnisOrganisationseinheitskategorieKlasse property can only contain items of type \StructType\OrganisationseinheitskategorieKlasse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ergebnisOrganisationseinheitskategorieKlasse value
     * @throws \InvalidArgumentException
     * @param \StructType\OrganisationseinheitskategorieKlasse[] $ergebnisOrganisationseinheitskategorieKlasse
     * @return \StructType\AntwortOrganisationseinheitskategorieKlasse
     */
    public function setErgebnisOrganisationseinheitskategorieKlasse(array $ergebnisOrganisationseinheitskategorieKlasse = array())
    {
        // validation for constraint: array
        if ('' !== ($ergebnisOrganisationseinheitskategorieKlasseArrayErrorMessage = self::validateErgebnisOrganisationseinheitskategorieKlasseForArrayConstraintsFromSetErgebnisOrganisationseinheitskategorieKlasse($ergebnisOrganisationseinheitskategorieKlasse))) {
            throw new \InvalidArgumentException($ergebnisOrganisationseinheitskategorieKlasseArrayErrorMessage, __LINE__);
        }
        $this->ergebnisOrganisationseinheitskategorieKlasse = $ergebnisOrganisationseinheitskategorieKlasse;
        return $this;
    }
    /**
     * Add item to ergebnisOrganisationseinheitskategorieKlasse value
     * @throws \InvalidArgumentException
     * @param \StructType\OrganisationseinheitskategorieKlasse $item
     * @return \StructType\AntwortOrganisationseinheitskategorieKlasse
     */
    public function addToErgebnisOrganisationseinheitskategorieKlasse(\StructType\OrganisationseinheitskategorieKlasse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrganisationseinheitskategorieKlasse) {
            throw new \InvalidArgumentException(sprintf('The ergebnisOrganisationseinheitskategorieKlasse property can only contain items of type \StructType\OrganisationseinheitskategorieKlasse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ergebnisOrganisationseinheitskategorieKlasse[] = $item;
        return $this;
    }
}
