<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AntwortSprachen StructType
 * Meta information extracted from the WSDL
 * - documentation: Antwort mit untersützten Sprachen des Systems.
 * @subpackage Structs
 */
class AntwortSprachen extends NachrichtAntwort
{
    /**
     * The ergebnisSprache
     * Meta information extracted from the WSDL
     * - documentation: Menge der unterstützen Sprachen.
     * - maxOccurs: unbounded
     * @var \StructType\Sprache[]
     */
    public $ergebnisSprache;
    /**
     * Constructor method for AntwortSprachen
     * @uses AntwortSprachen::setErgebnisSprache()
     * @param \StructType\Sprache[] $ergebnisSprache
     */
    public function __construct(array $ergebnisSprache = array())
    {
        $this
            ->setErgebnisSprache($ergebnisSprache);
    }
    /**
     * Get ergebnisSprache value
     * @return \StructType\Sprache[]|null
     */
    public function getErgebnisSprache()
    {
        return $this->ergebnisSprache;
    }
    /**
     * This method is responsible for validating the values passed to the setErgebnisSprache method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErgebnisSprache method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErgebnisSpracheForArrayConstraintsFromSetErgebnisSprache(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $antwortSprachenErgebnisSpracheItem) {
            // validation for constraint: itemType
            if (!$antwortSprachenErgebnisSpracheItem instanceof \StructType\Sprache) {
                $invalidValues[] = is_object($antwortSprachenErgebnisSpracheItem) ? get_class($antwortSprachenErgebnisSpracheItem) : sprintf('%s(%s)', gettype($antwortSprachenErgebnisSpracheItem), var_export($antwortSprachenErgebnisSpracheItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ergebnisSprache property can only contain items of type \StructType\Sprache, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ergebnisSprache value
     * @throws \InvalidArgumentException
     * @param \StructType\Sprache[] $ergebnisSprache
     * @return \StructType\AntwortSprachen
     */
    public function setErgebnisSprache(array $ergebnisSprache = array())
    {
        // validation for constraint: array
        if ('' !== ($ergebnisSpracheArrayErrorMessage = self::validateErgebnisSpracheForArrayConstraintsFromSetErgebnisSprache($ergebnisSprache))) {
            throw new \InvalidArgumentException($ergebnisSpracheArrayErrorMessage, __LINE__);
        }
        $this->ergebnisSprache = $ergebnisSprache;
        return $this;
    }
    /**
     * Add item to ergebnisSprache value
     * @throws \InvalidArgumentException
     * @param \StructType\Sprache $item
     * @return \StructType\AntwortSprachen
     */
    public function addToErgebnisSprache(\StructType\Sprache $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Sprache) {
            throw new \InvalidArgumentException(sprintf('The ergebnisSprache property can only contain items of type \StructType\Sprache, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ergebnisSprache[] = $item;
        return $this;
    }
}
