<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BegriffImKontextModul StructType
 * Meta information extracted from the WSDL
 * - documentation: Modul zur Definition von Begriffen im Kontext zu einer Leistung. Begriffe im Kontext sind z.B. Synonyme, Schlagworte oder auch fehlerhafte Schreibweisen.
 * @subpackage Structs
 */
class BegriffImKontextModul extends Leistungsmodul
{
    /**
     * The begriffImKontext
     * Meta information extracted from the WSDL
     * - documentation: Die Begriffe.
     * - maxOccurs: unbounded
     * @var \StructType\BegriffImKontext[]
     */
    public $begriffImKontext;
    /**
     * Constructor method for BegriffImKontextModul
     * @uses BegriffImKontextModul::setBegriffImKontext()
     * @param \StructType\BegriffImKontext[] $begriffImKontext
     */
    public function __construct(array $begriffImKontext = array())
    {
        $this
            ->setBegriffImKontext($begriffImKontext);
    }
    /**
     * Get begriffImKontext value
     * @return \StructType\BegriffImKontext[]|null
     */
    public function getBegriffImKontext()
    {
        return $this->begriffImKontext;
    }
    /**
     * This method is responsible for validating the values passed to the setBegriffImKontext method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBegriffImKontext method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBegriffImKontextForArrayConstraintsFromSetBegriffImKontext(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $begriffImKontextModulBegriffImKontextItem) {
            // validation for constraint: itemType
            if (!$begriffImKontextModulBegriffImKontextItem instanceof \StructType\BegriffImKontext) {
                $invalidValues[] = is_object($begriffImKontextModulBegriffImKontextItem) ? get_class($begriffImKontextModulBegriffImKontextItem) : sprintf('%s(%s)', gettype($begriffImKontextModulBegriffImKontextItem), var_export($begriffImKontextModulBegriffImKontextItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The begriffImKontext property can only contain items of type \StructType\BegriffImKontext, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set begriffImKontext value
     * @throws \InvalidArgumentException
     * @param \StructType\BegriffImKontext[] $begriffImKontext
     * @return \StructType\BegriffImKontextModul
     */
    public function setBegriffImKontext(array $begriffImKontext = array())
    {
        // validation for constraint: array
        if ('' !== ($begriffImKontextArrayErrorMessage = self::validateBegriffImKontextForArrayConstraintsFromSetBegriffImKontext($begriffImKontext))) {
            throw new \InvalidArgumentException($begriffImKontextArrayErrorMessage, __LINE__);
        }
        $this->begriffImKontext = $begriffImKontext;
        return $this;
    }
    /**
     * Add item to begriffImKontext value
     * @throws \InvalidArgumentException
     * @param \StructType\BegriffImKontext $item
     * @return \StructType\BegriffImKontextModul
     */
    public function addToBegriffImKontext(\StructType\BegriffImKontext $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BegriffImKontext) {
            throw new \InvalidArgumentException(sprintf('The begriffImKontext property can only contain items of type \StructType\BegriffImKontext, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->begriffImKontext[] = $item;
        return $this;
    }
}
