<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CI_Address_Type StructType
 * @subpackage Structs
 */
class CI_Address_Type extends AbstractStructBase
{
    /**
     * The deliveryPoint
     * @var \StructType\CharacterString_PropertyType
     */
    public $deliveryPoint;
    /**
     * The city
     * @var \StructType\CharacterString_PropertyType
     */
    public $city;
    /**
     * The administrativeArea
     * @var \StructType\CharacterString_PropertyType
     */
    public $administrativeArea;
    /**
     * The postalCode
     * @var \StructType\CharacterString_PropertyType
     */
    public $postalCode;
    /**
     * The country
     * @var \StructType\CharacterString_PropertyType
     */
    public $country;
    /**
     * The electronicMailAddress
     * @var \StructType\CharacterString_PropertyType
     */
    public $electronicMailAddress;
    /**
     * Constructor method for CI_Address_Type
     * @uses CI_Address_Type::setDeliveryPoint()
     * @uses CI_Address_Type::setCity()
     * @uses CI_Address_Type::setAdministrativeArea()
     * @uses CI_Address_Type::setPostalCode()
     * @uses CI_Address_Type::setCountry()
     * @uses CI_Address_Type::setElectronicMailAddress()
     * @param \StructType\CharacterString_PropertyType $deliveryPoint
     * @param \StructType\CharacterString_PropertyType $city
     * @param \StructType\CharacterString_PropertyType $administrativeArea
     * @param \StructType\CharacterString_PropertyType $postalCode
     * @param \StructType\CharacterString_PropertyType $country
     * @param \StructType\CharacterString_PropertyType $electronicMailAddress
     */
    public function __construct(\StructType\CharacterString_PropertyType $deliveryPoint = null, \StructType\CharacterString_PropertyType $city = null, \StructType\CharacterString_PropertyType $administrativeArea = null, \StructType\CharacterString_PropertyType $postalCode = null, \StructType\CharacterString_PropertyType $country = null, \StructType\CharacterString_PropertyType $electronicMailAddress = null)
    {
        $this
            ->setDeliveryPoint($deliveryPoint)
            ->setCity($city)
            ->setAdministrativeArea($administrativeArea)
            ->setPostalCode($postalCode)
            ->setCountry($country)
            ->setElectronicMailAddress($electronicMailAddress);
    }
    /**
     * Get deliveryPoint value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDeliveryPoint()
    {
        return $this->deliveryPoint;
    }
    /**
     * Set deliveryPoint value
     * @param \StructType\CharacterString_PropertyType $deliveryPoint
     * @return \StructType\CI_Address_Type
     */
    public function setDeliveryPoint(\StructType\CharacterString_PropertyType $deliveryPoint = null)
    {
        $this->deliveryPoint = $deliveryPoint;
        return $this;
    }
    /**
     * Get city value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param \StructType\CharacterString_PropertyType $city
     * @return \StructType\CI_Address_Type
     */
    public function setCity(\StructType\CharacterString_PropertyType $city = null)
    {
        $this->city = $city;
        return $this;
    }
    /**
     * Get administrativeArea value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getAdministrativeArea()
    {
        return $this->administrativeArea;
    }
    /**
     * Set administrativeArea value
     * @param \StructType\CharacterString_PropertyType $administrativeArea
     * @return \StructType\CI_Address_Type
     */
    public function setAdministrativeArea(\StructType\CharacterString_PropertyType $administrativeArea = null)
    {
        $this->administrativeArea = $administrativeArea;
        return $this;
    }
    /**
     * Get postalCode value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getPostalCode()
    {
        return $this->postalCode;
    }
    /**
     * Set postalCode value
     * @param \StructType\CharacterString_PropertyType $postalCode
     * @return \StructType\CI_Address_Type
     */
    public function setPostalCode(\StructType\CharacterString_PropertyType $postalCode = null)
    {
        $this->postalCode = $postalCode;
        return $this;
    }
    /**
     * Get country value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param \StructType\CharacterString_PropertyType $country
     * @return \StructType\CI_Address_Type
     */
    public function setCountry(\StructType\CharacterString_PropertyType $country = null)
    {
        $this->country = $country;
        return $this;
    }
    /**
     * Get electronicMailAddress value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getElectronicMailAddress()
    {
        return $this->electronicMailAddress;
    }
    /**
     * Set electronicMailAddress value
     * @param \StructType\CharacterString_PropertyType $electronicMailAddress
     * @return \StructType\CI_Address_Type
     */
    public function setElectronicMailAddress(\StructType\CharacterString_PropertyType $electronicMailAddress = null)
    {
        $this->electronicMailAddress = $electronicMailAddress;
        return $this;
    }
}
