<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CI_Contact_Type StructType
 * @subpackage Structs
 */
class CI_Contact_Type extends AbstractStructBase
{
    /**
     * The phone
     * @var \StructType\CI_Telephone_PropertyType
     */
    public $phone;
    /**
     * The address
     * @var \StructType\CI_Address_PropertyType
     */
    public $address;
    /**
     * The onlineResource
     * @var \StructType\CI_OnlineResource_PropertyType
     */
    public $onlineResource;
    /**
     * The hoursOfService
     * @var \StructType\CharacterString_PropertyType
     */
    public $hoursOfService;
    /**
     * The contactInstructions
     * @var \StructType\CharacterString_PropertyType
     */
    public $contactInstructions;
    /**
     * Constructor method for CI_Contact_Type
     * @uses CI_Contact_Type::setPhone()
     * @uses CI_Contact_Type::setAddress()
     * @uses CI_Contact_Type::setOnlineResource()
     * @uses CI_Contact_Type::setHoursOfService()
     * @uses CI_Contact_Type::setContactInstructions()
     * @param \StructType\CI_Telephone_PropertyType $phone
     * @param \StructType\CI_Address_PropertyType $address
     * @param \StructType\CI_OnlineResource_PropertyType $onlineResource
     * @param \StructType\CharacterString_PropertyType $hoursOfService
     * @param \StructType\CharacterString_PropertyType $contactInstructions
     */
    public function __construct(\StructType\CI_Telephone_PropertyType $phone = null, \StructType\CI_Address_PropertyType $address = null, \StructType\CI_OnlineResource_PropertyType $onlineResource = null, \StructType\CharacterString_PropertyType $hoursOfService = null, \StructType\CharacterString_PropertyType $contactInstructions = null)
    {
        $this
            ->setPhone($phone)
            ->setAddress($address)
            ->setOnlineResource($onlineResource)
            ->setHoursOfService($hoursOfService)
            ->setContactInstructions($contactInstructions);
    }
    /**
     * Get phone value
     * @return \StructType\CI_Telephone_PropertyType|null
     */
    public function getPhone()
    {
        return $this->phone;
    }
    /**
     * Set phone value
     * @param \StructType\CI_Telephone_PropertyType $phone
     * @return \StructType\CI_Contact_Type
     */
    public function setPhone(\StructType\CI_Telephone_PropertyType $phone = null)
    {
        $this->phone = $phone;
        return $this;
    }
    /**
     * Get address value
     * @return \StructType\CI_Address_PropertyType|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param \StructType\CI_Address_PropertyType $address
     * @return \StructType\CI_Contact_Type
     */
    public function setAddress(\StructType\CI_Address_PropertyType $address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get onlineResource value
     * @return \StructType\CI_OnlineResource_PropertyType|null
     */
    public function getOnlineResource()
    {
        return $this->onlineResource;
    }
    /**
     * Set onlineResource value
     * @param \StructType\CI_OnlineResource_PropertyType $onlineResource
     * @return \StructType\CI_Contact_Type
     */
    public function setOnlineResource(\StructType\CI_OnlineResource_PropertyType $onlineResource = null)
    {
        $this->onlineResource = $onlineResource;
        return $this;
    }
    /**
     * Get hoursOfService value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getHoursOfService()
    {
        return $this->hoursOfService;
    }
    /**
     * Set hoursOfService value
     * @param \StructType\CharacterString_PropertyType $hoursOfService
     * @return \StructType\CI_Contact_Type
     */
    public function setHoursOfService(\StructType\CharacterString_PropertyType $hoursOfService = null)
    {
        $this->hoursOfService = $hoursOfService;
        return $this;
    }
    /**
     * Get contactInstructions value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getContactInstructions()
    {
        return $this->contactInstructions;
    }
    /**
     * Set contactInstructions value
     * @param \StructType\CharacterString_PropertyType $contactInstructions
     * @return \StructType\CI_Contact_Type
     */
    public function setContactInstructions(\StructType\CharacterString_PropertyType $contactInstructions = null)
    {
        $this->contactInstructions = $contactInstructions;
        return $this;
    }
}
