<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CI_Date_Type StructType
 * @subpackage Structs
 */
class CI_Date_Type extends AbstractStructBase
{
    /**
     * The date
     * @var \StructType\Date_PropertyType
     */
    public $date;
    /**
     * The dateType
     * @var \StructType\CI_DateTypeCode_PropertyType
     */
    public $dateType;
    /**
     * Constructor method for CI_Date_Type
     * @uses CI_Date_Type::setDate()
     * @uses CI_Date_Type::setDateType()
     * @param \StructType\Date_PropertyType $date
     * @param \StructType\CI_DateTypeCode_PropertyType $dateType
     */
    public function __construct(\StructType\Date_PropertyType $date = null, \StructType\CI_DateTypeCode_PropertyType $dateType = null)
    {
        $this
            ->setDate($date)
            ->setDateType($dateType);
    }
    /**
     * Get date value
     * @return \StructType\Date_PropertyType|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param \StructType\Date_PropertyType $date
     * @return \StructType\CI_Date_Type
     */
    public function setDate(\StructType\Date_PropertyType $date = null)
    {
        $this->date = $date;
        return $this;
    }
    /**
     * Get dateType value
     * @return \StructType\CI_DateTypeCode_PropertyType|null
     */
    public function getDateType()
    {
        return $this->dateType;
    }
    /**
     * Set dateType value
     * @param \StructType\CI_DateTypeCode_PropertyType $dateType
     * @return \StructType\CI_Date_Type
     */
    public function setDateType(\StructType\CI_DateTypeCode_PropertyType $dateType = null)
    {
        $this->dateType = $dateType;
        return $this;
    }
}
