<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CI_OnlineResource_Type StructType
 * @subpackage Structs
 */
class CI_OnlineResource_Type extends AbstractStructBase
{
    /**
     * The linkage
     * @var \StructType\URL_PropertyType
     */
    public $linkage;
    /**
     * The protocol
     * @var \StructType\CharacterString_PropertyType
     */
    public $protocol;
    /**
     * The applicationProfile
     * @var \StructType\CharacterString_PropertyType
     */
    public $applicationProfile;
    /**
     * The name
     * @var \StructType\CharacterString_PropertyType
     */
    public $name;
    /**
     * The description
     * @var \StructType\CharacterString_PropertyType
     */
    public $description;
    /**
     * The function
     * @var \StructType\CI_OnLineFunctionCode_PropertyType
     */
    public $function;
    /**
     * Constructor method for CI_OnlineResource_Type
     * @uses CI_OnlineResource_Type::setLinkage()
     * @uses CI_OnlineResource_Type::setProtocol()
     * @uses CI_OnlineResource_Type::setApplicationProfile()
     * @uses CI_OnlineResource_Type::setName()
     * @uses CI_OnlineResource_Type::setDescription()
     * @uses CI_OnlineResource_Type::setFunction()
     * @param \StructType\URL_PropertyType $linkage
     * @param \StructType\CharacterString_PropertyType $protocol
     * @param \StructType\CharacterString_PropertyType $applicationProfile
     * @param \StructType\CharacterString_PropertyType $name
     * @param \StructType\CharacterString_PropertyType $description
     * @param \StructType\CI_OnLineFunctionCode_PropertyType $function
     */
    public function __construct(\StructType\URL_PropertyType $linkage = null, \StructType\CharacterString_PropertyType $protocol = null, \StructType\CharacterString_PropertyType $applicationProfile = null, \StructType\CharacterString_PropertyType $name = null, \StructType\CharacterString_PropertyType $description = null, \StructType\CI_OnLineFunctionCode_PropertyType $function = null)
    {
        $this
            ->setLinkage($linkage)
            ->setProtocol($protocol)
            ->setApplicationProfile($applicationProfile)
            ->setName($name)
            ->setDescription($description)
            ->setFunction($function);
    }
    /**
     * Get linkage value
     * @return \StructType\URL_PropertyType|null
     */
    public function getLinkage()
    {
        return $this->linkage;
    }
    /**
     * Set linkage value
     * @param \StructType\URL_PropertyType $linkage
     * @return \StructType\CI_OnlineResource_Type
     */
    public function setLinkage(\StructType\URL_PropertyType $linkage = null)
    {
        $this->linkage = $linkage;
        return $this;
    }
    /**
     * Get protocol value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getProtocol()
    {
        return $this->protocol;
    }
    /**
     * Set protocol value
     * @param \StructType\CharacterString_PropertyType $protocol
     * @return \StructType\CI_OnlineResource_Type
     */
    public function setProtocol(\StructType\CharacterString_PropertyType $protocol = null)
    {
        $this->protocol = $protocol;
        return $this;
    }
    /**
     * Get applicationProfile value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getApplicationProfile()
    {
        return $this->applicationProfile;
    }
    /**
     * Set applicationProfile value
     * @param \StructType\CharacterString_PropertyType $applicationProfile
     * @return \StructType\CI_OnlineResource_Type
     */
    public function setApplicationProfile(\StructType\CharacterString_PropertyType $applicationProfile = null)
    {
        $this->applicationProfile = $applicationProfile;
        return $this;
    }
    /**
     * Get name value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param \StructType\CharacterString_PropertyType $name
     * @return \StructType\CI_OnlineResource_Type
     */
    public function setName(\StructType\CharacterString_PropertyType $name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get description value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \StructType\CharacterString_PropertyType $description
     * @return \StructType\CI_OnlineResource_Type
     */
    public function setDescription(\StructType\CharacterString_PropertyType $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get function value
     * @return \StructType\CI_OnLineFunctionCode_PropertyType|null
     */
    public function getFunction()
    {
        return $this->function;
    }
    /**
     * Set function value
     * @param \StructType\CI_OnLineFunctionCode_PropertyType $function
     * @return \StructType\CI_OnlineResource_Type
     */
    public function setFunction(\StructType\CI_OnLineFunctionCode_PropertyType $function = null)
    {
        $this->function = $function;
        return $this;
    }
}
