<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CI_ResponsibleParty_Type StructType
 * @subpackage Structs
 */
class CI_ResponsibleParty_Type extends AbstractStructBase
{
    /**
     * The individualName
     * @var \StructType\CharacterString_PropertyType
     */
    public $individualName;
    /**
     * The organisationName
     * @var \StructType\CharacterString_PropertyType
     */
    public $organisationName;
    /**
     * The positionName
     * @var \StructType\CharacterString_PropertyType
     */
    public $positionName;
    /**
     * The contactInfo
     * @var \StructType\CI_Contact_PropertyType
     */
    public $contactInfo;
    /**
     * The role
     * @var \StructType\CI_RoleCode_PropertyType
     */
    public $role;
    /**
     * Constructor method for CI_ResponsibleParty_Type
     * @uses CI_ResponsibleParty_Type::setIndividualName()
     * @uses CI_ResponsibleParty_Type::setOrganisationName()
     * @uses CI_ResponsibleParty_Type::setPositionName()
     * @uses CI_ResponsibleParty_Type::setContactInfo()
     * @uses CI_ResponsibleParty_Type::setRole()
     * @param \StructType\CharacterString_PropertyType $individualName
     * @param \StructType\CharacterString_PropertyType $organisationName
     * @param \StructType\CharacterString_PropertyType $positionName
     * @param \StructType\CI_Contact_PropertyType $contactInfo
     * @param \StructType\CI_RoleCode_PropertyType $role
     */
    public function __construct(\StructType\CharacterString_PropertyType $individualName = null, \StructType\CharacterString_PropertyType $organisationName = null, \StructType\CharacterString_PropertyType $positionName = null, \StructType\CI_Contact_PropertyType $contactInfo = null, \StructType\CI_RoleCode_PropertyType $role = null)
    {
        $this
            ->setIndividualName($individualName)
            ->setOrganisationName($organisationName)
            ->setPositionName($positionName)
            ->setContactInfo($contactInfo)
            ->setRole($role);
    }
    /**
     * Get individualName value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getIndividualName()
    {
        return $this->individualName;
    }
    /**
     * Set individualName value
     * @param \StructType\CharacterString_PropertyType $individualName
     * @return \StructType\CI_ResponsibleParty_Type
     */
    public function setIndividualName(\StructType\CharacterString_PropertyType $individualName = null)
    {
        $this->individualName = $individualName;
        return $this;
    }
    /**
     * Get organisationName value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getOrganisationName()
    {
        return $this->organisationName;
    }
    /**
     * Set organisationName value
     * @param \StructType\CharacterString_PropertyType $organisationName
     * @return \StructType\CI_ResponsibleParty_Type
     */
    public function setOrganisationName(\StructType\CharacterString_PropertyType $organisationName = null)
    {
        $this->organisationName = $organisationName;
        return $this;
    }
    /**
     * Get positionName value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getPositionName()
    {
        return $this->positionName;
    }
    /**
     * Set positionName value
     * @param \StructType\CharacterString_PropertyType $positionName
     * @return \StructType\CI_ResponsibleParty_Type
     */
    public function setPositionName(\StructType\CharacterString_PropertyType $positionName = null)
    {
        $this->positionName = $positionName;
        return $this;
    }
    /**
     * Get contactInfo value
     * @return \StructType\CI_Contact_PropertyType|null
     */
    public function getContactInfo()
    {
        return $this->contactInfo;
    }
    /**
     * Set contactInfo value
     * @param \StructType\CI_Contact_PropertyType $contactInfo
     * @return \StructType\CI_ResponsibleParty_Type
     */
    public function setContactInfo(\StructType\CI_Contact_PropertyType $contactInfo = null)
    {
        $this->contactInfo = $contactInfo;
        return $this;
    }
    /**
     * Get role value
     * @return \StructType\CI_RoleCode_PropertyType|null
     */
    public function getRole()
    {
        return $this->role;
    }
    /**
     * Set role value
     * @param \StructType\CI_RoleCode_PropertyType $role
     * @return \StructType\CI_ResponsibleParty_Type
     */
    public function setRole(\StructType\CI_RoleCode_PropertyType $role = null)
    {
        $this->role = $role;
        return $this;
    }
}
