<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConventionalUnitType StructType
 * @subpackage Structs
 */
class ConventionalUnitType extends AbstractStructBase
{
    /**
     * The conversionToPreferredUnit
     * @var \StructType\ConversionToPreferredUnitType
     */
    public $conversionToPreferredUnit;
    /**
     * The roughConversionToPreferredUnit
     * @var \StructType\ConversionToPreferredUnitType
     */
    public $roughConversionToPreferredUnit;
    /**
     * The derivationUnitTerm
     * @var \StructType\DerivationUnitTermType
     */
    public $derivationUnitTerm;
    /**
     * Constructor method for ConventionalUnitType
     * @uses ConventionalUnitType::setConversionToPreferredUnit()
     * @uses ConventionalUnitType::setRoughConversionToPreferredUnit()
     * @uses ConventionalUnitType::setDerivationUnitTerm()
     * @param \StructType\ConversionToPreferredUnitType $conversionToPreferredUnit
     * @param \StructType\ConversionToPreferredUnitType $roughConversionToPreferredUnit
     * @param \StructType\DerivationUnitTermType $derivationUnitTerm
     */
    public function __construct(\StructType\ConversionToPreferredUnitType $conversionToPreferredUnit = null, \StructType\ConversionToPreferredUnitType $roughConversionToPreferredUnit = null, \StructType\DerivationUnitTermType $derivationUnitTerm = null)
    {
        $this
            ->setConversionToPreferredUnit($conversionToPreferredUnit)
            ->setRoughConversionToPreferredUnit($roughConversionToPreferredUnit)
            ->setDerivationUnitTerm($derivationUnitTerm);
    }
    /**
     * Get conversionToPreferredUnit value
     * @return \StructType\ConversionToPreferredUnitType|null
     */
    public function getConversionToPreferredUnit()
    {
        return $this->conversionToPreferredUnit;
    }
    /**
     * Set conversionToPreferredUnit value
     * @param \StructType\ConversionToPreferredUnitType $conversionToPreferredUnit
     * @return \StructType\ConventionalUnitType
     */
    public function setConversionToPreferredUnit(\StructType\ConversionToPreferredUnitType $conversionToPreferredUnit = null)
    {
        $this->conversionToPreferredUnit = $conversionToPreferredUnit;
        return $this;
    }
    /**
     * Get roughConversionToPreferredUnit value
     * @return \StructType\ConversionToPreferredUnitType|null
     */
    public function getRoughConversionToPreferredUnit()
    {
        return $this->roughConversionToPreferredUnit;
    }
    /**
     * Set roughConversionToPreferredUnit value
     * @param \StructType\ConversionToPreferredUnitType $roughConversionToPreferredUnit
     * @return \StructType\ConventionalUnitType
     */
    public function setRoughConversionToPreferredUnit(\StructType\ConversionToPreferredUnitType $roughConversionToPreferredUnit = null)
    {
        $this->roughConversionToPreferredUnit = $roughConversionToPreferredUnit;
        return $this;
    }
    /**
     * Get derivationUnitTerm value
     * @return \StructType\DerivationUnitTermType|null
     */
    public function getDerivationUnitTerm()
    {
        return $this->derivationUnitTerm;
    }
    /**
     * Set derivationUnitTerm value
     * @param \StructType\DerivationUnitTermType $derivationUnitTerm
     * @return \StructType\ConventionalUnitType
     */
    public function setDerivationUnitTerm(\StructType\DerivationUnitTermType $derivationUnitTerm = null)
    {
        $this->derivationUnitTerm = $derivationUnitTerm;
        return $this;
    }
}
