<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CoverageFunctionType StructType
 * @subpackage Structs
 */
class CoverageFunctionType extends AbstractStructBase
{
    /**
     * The MappingRule
     * @var \StructType\StringOrRefType
     */
    public $MappingRule;
    /**
     * The CoverageMappingRule
     * @var \StructType\MappingRuleType
     */
    public $CoverageMappingRule;
    /**
     * The GridFunction
     * @var \StructType\GridFunctionType
     */
    public $GridFunction;
    /**
     * Constructor method for CoverageFunctionType
     * @uses CoverageFunctionType::setMappingRule()
     * @uses CoverageFunctionType::setCoverageMappingRule()
     * @uses CoverageFunctionType::setGridFunction()
     * @param \StructType\StringOrRefType $mappingRule
     * @param \StructType\MappingRuleType $coverageMappingRule
     * @param \StructType\GridFunctionType $gridFunction
     */
    public function __construct(\StructType\StringOrRefType $mappingRule = null, \StructType\MappingRuleType $coverageMappingRule = null, \StructType\GridFunctionType $gridFunction = null)
    {
        $this
            ->setMappingRule($mappingRule)
            ->setCoverageMappingRule($coverageMappingRule)
            ->setGridFunction($gridFunction);
    }
    /**
     * Get MappingRule value
     * @return \StructType\StringOrRefType|null
     */
    public function getMappingRule()
    {
        return $this->MappingRule;
    }
    /**
     * Set MappingRule value
     * @param \StructType\StringOrRefType $mappingRule
     * @return \StructType\CoverageFunctionType
     */
    public function setMappingRule(\StructType\StringOrRefType $mappingRule = null)
    {
        $this->MappingRule = $mappingRule;
        return $this;
    }
    /**
     * Get CoverageMappingRule value
     * @return \StructType\MappingRuleType|null
     */
    public function getCoverageMappingRule()
    {
        return $this->CoverageMappingRule;
    }
    /**
     * Set CoverageMappingRule value
     * @param \StructType\MappingRuleType $coverageMappingRule
     * @return \StructType\CoverageFunctionType
     */
    public function setCoverageMappingRule(\StructType\MappingRuleType $coverageMappingRule = null)
    {
        $this->CoverageMappingRule = $coverageMappingRule;
        return $this;
    }
    /**
     * Get GridFunction value
     * @return \StructType\GridFunctionType|null
     */
    public function getGridFunction()
    {
        return $this->GridFunction;
    }
    /**
     * Set GridFunction value
     * @param \StructType\GridFunctionType $gridFunction
     * @return \StructType\CoverageFunctionType
     */
    public function setGridFunction(\StructType\GridFunctionType $gridFunction = null)
    {
        $this->GridFunction = $gridFunction;
        return $this;
    }
}
