<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DQ_ConformanceResult_Type StructType
 * @subpackage Structs
 */
class DQ_ConformanceResult_Type extends AbstractStructBase
{
    /**
     * The specification
     * @var \StructType\CI_Citation_PropertyType
     */
    public $specification;
    /**
     * The explanation
     * @var \StructType\CharacterString_PropertyType
     */
    public $explanation;
    /**
     * The pass
     * @var \StructType\Boolean_PropertyType
     */
    public $pass;
    /**
     * Constructor method for DQ_ConformanceResult_Type
     * @uses DQ_ConformanceResult_Type::setSpecification()
     * @uses DQ_ConformanceResult_Type::setExplanation()
     * @uses DQ_ConformanceResult_Type::setPass()
     * @param \StructType\CI_Citation_PropertyType $specification
     * @param \StructType\CharacterString_PropertyType $explanation
     * @param \StructType\Boolean_PropertyType $pass
     */
    public function __construct(\StructType\CI_Citation_PropertyType $specification = null, \StructType\CharacterString_PropertyType $explanation = null, \StructType\Boolean_PropertyType $pass = null)
    {
        $this
            ->setSpecification($specification)
            ->setExplanation($explanation)
            ->setPass($pass);
    }
    /**
     * Get specification value
     * @return \StructType\CI_Citation_PropertyType|null
     */
    public function getSpecification()
    {
        return $this->specification;
    }
    /**
     * Set specification value
     * @param \StructType\CI_Citation_PropertyType $specification
     * @return \StructType\DQ_ConformanceResult_Type
     */
    public function setSpecification(\StructType\CI_Citation_PropertyType $specification = null)
    {
        $this->specification = $specification;
        return $this;
    }
    /**
     * Get explanation value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getExplanation()
    {
        return $this->explanation;
    }
    /**
     * Set explanation value
     * @param \StructType\CharacterString_PropertyType $explanation
     * @return \StructType\DQ_ConformanceResult_Type
     */
    public function setExplanation(\StructType\CharacterString_PropertyType $explanation = null)
    {
        $this->explanation = $explanation;
        return $this;
    }
    /**
     * Get pass value
     * @return \StructType\Boolean_PropertyType|null
     */
    public function getPass()
    {
        return $this->pass;
    }
    /**
     * Set pass value
     * @param \StructType\Boolean_PropertyType $pass
     * @return \StructType\DQ_ConformanceResult_Type
     */
    public function setPass(\StructType\Boolean_PropertyType $pass = null)
    {
        $this->pass = $pass;
        return $this;
    }
}
