<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DQ_QuantitativeResult_Type StructType
 * @subpackage Structs
 */
class DQ_QuantitativeResult_Type extends AbstractStructBase
{
    /**
     * The valueType
     * @var \StructType\RecordType_PropertyType
     */
    public $valueType;
    /**
     * The valueUnit
     * @var \StructType\UnitOfMeasure_PropertyType
     */
    public $valueUnit;
    /**
     * The errorStatistic
     * @var \StructType\CharacterString_PropertyType
     */
    public $errorStatistic;
    /**
     * The value
     * @var \StructType\Record_PropertyType
     */
    public $value;
    /**
     * Constructor method for DQ_QuantitativeResult_Type
     * @uses DQ_QuantitativeResult_Type::setValueType()
     * @uses DQ_QuantitativeResult_Type::setValueUnit()
     * @uses DQ_QuantitativeResult_Type::setErrorStatistic()
     * @uses DQ_QuantitativeResult_Type::setValue()
     * @param \StructType\RecordType_PropertyType $valueType
     * @param \StructType\UnitOfMeasure_PropertyType $valueUnit
     * @param \StructType\CharacterString_PropertyType $errorStatistic
     * @param \StructType\Record_PropertyType $value
     */
    public function __construct(\StructType\RecordType_PropertyType $valueType = null, \StructType\UnitOfMeasure_PropertyType $valueUnit = null, \StructType\CharacterString_PropertyType $errorStatistic = null, \StructType\Record_PropertyType $value = null)
    {
        $this
            ->setValueType($valueType)
            ->setValueUnit($valueUnit)
            ->setErrorStatistic($errorStatistic)
            ->setValue($value);
    }
    /**
     * Get valueType value
     * @return \StructType\RecordType_PropertyType|null
     */
    public function getValueType()
    {
        return $this->valueType;
    }
    /**
     * Set valueType value
     * @param \StructType\RecordType_PropertyType $valueType
     * @return \StructType\DQ_QuantitativeResult_Type
     */
    public function setValueType(\StructType\RecordType_PropertyType $valueType = null)
    {
        $this->valueType = $valueType;
        return $this;
    }
    /**
     * Get valueUnit value
     * @return \StructType\UnitOfMeasure_PropertyType|null
     */
    public function getValueUnit()
    {
        return $this->valueUnit;
    }
    /**
     * Set valueUnit value
     * @param \StructType\UnitOfMeasure_PropertyType $valueUnit
     * @return \StructType\DQ_QuantitativeResult_Type
     */
    public function setValueUnit(\StructType\UnitOfMeasure_PropertyType $valueUnit = null)
    {
        $this->valueUnit = $valueUnit;
        return $this;
    }
    /**
     * Get errorStatistic value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getErrorStatistic()
    {
        return $this->errorStatistic;
    }
    /**
     * Set errorStatistic value
     * @param \StructType\CharacterString_PropertyType $errorStatistic
     * @return \StructType\DQ_QuantitativeResult_Type
     */
    public function setErrorStatistic(\StructType\CharacterString_PropertyType $errorStatistic = null)
    {
        $this->errorStatistic = $errorStatistic;
        return $this;
    }
    /**
     * Get value value
     * @return \StructType\Record_PropertyType|null
     */
    public function getValue()
    {
        return $this->value;
    }
    /**
     * Set value value
     * @param \StructType\Record_PropertyType $value
     * @return \StructType\DQ_QuantitativeResult_Type
     */
    public function setValue(\StructType\Record_PropertyType $value = null)
    {
        $this->value = $value;
        return $this;
    }
}
