<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EX_Extent_Type StructType
 * @subpackage Structs
 */
class EX_Extent_Type extends AbstractStructBase
{
    /**
     * The description
     * @var \StructType\CharacterString_PropertyType
     */
    public $description;
    /**
     * The geographicElement
     * @var \StructType\EX_GeographicExtent_PropertyType
     */
    public $geographicElement;
    /**
     * The temporalElement
     * @var \StructType\EX_TemporalExtent_PropertyType
     */
    public $temporalElement;
    /**
     * The verticalElement
     * @var \StructType\EX_VerticalExtent_PropertyType
     */
    public $verticalElement;
    /**
     * Constructor method for EX_Extent_Type
     * @uses EX_Extent_Type::setDescription()
     * @uses EX_Extent_Type::setGeographicElement()
     * @uses EX_Extent_Type::setTemporalElement()
     * @uses EX_Extent_Type::setVerticalElement()
     * @param \StructType\CharacterString_PropertyType $description
     * @param \StructType\EX_GeographicExtent_PropertyType $geographicElement
     * @param \StructType\EX_TemporalExtent_PropertyType $temporalElement
     * @param \StructType\EX_VerticalExtent_PropertyType $verticalElement
     */
    public function __construct(\StructType\CharacterString_PropertyType $description = null, \StructType\EX_GeographicExtent_PropertyType $geographicElement = null, \StructType\EX_TemporalExtent_PropertyType $temporalElement = null, \StructType\EX_VerticalExtent_PropertyType $verticalElement = null)
    {
        $this
            ->setDescription($description)
            ->setGeographicElement($geographicElement)
            ->setTemporalElement($temporalElement)
            ->setVerticalElement($verticalElement);
    }
    /**
     * Get description value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \StructType\CharacterString_PropertyType $description
     * @return \StructType\EX_Extent_Type
     */
    public function setDescription(\StructType\CharacterString_PropertyType $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get geographicElement value
     * @return \StructType\EX_GeographicExtent_PropertyType|null
     */
    public function getGeographicElement()
    {
        return $this->geographicElement;
    }
    /**
     * Set geographicElement value
     * @param \StructType\EX_GeographicExtent_PropertyType $geographicElement
     * @return \StructType\EX_Extent_Type
     */
    public function setGeographicElement(\StructType\EX_GeographicExtent_PropertyType $geographicElement = null)
    {
        $this->geographicElement = $geographicElement;
        return $this;
    }
    /**
     * Get temporalElement value
     * @return \StructType\EX_TemporalExtent_PropertyType|null
     */
    public function getTemporalElement()
    {
        return $this->temporalElement;
    }
    /**
     * Set temporalElement value
     * @param \StructType\EX_TemporalExtent_PropertyType $temporalElement
     * @return \StructType\EX_Extent_Type
     */
    public function setTemporalElement(\StructType\EX_TemporalExtent_PropertyType $temporalElement = null)
    {
        $this->temporalElement = $temporalElement;
        return $this;
    }
    /**
     * Get verticalElement value
     * @return \StructType\EX_VerticalExtent_PropertyType|null
     */
    public function getVerticalElement()
    {
        return $this->verticalElement;
    }
    /**
     * Set verticalElement value
     * @param \StructType\EX_VerticalExtent_PropertyType $verticalElement
     * @return \StructType\EX_Extent_Type
     */
    public function setVerticalElement(\StructType\EX_VerticalExtent_PropertyType $verticalElement = null)
    {
        $this->verticalElement = $verticalElement;
        return $this;
    }
}
