<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FachlicheFreigabeModul StructType
 * Meta information extracted from the WSDL
 * - documentation: Modul zur Abbildung der fachlichen Freigabe einer Leistung (Wer? Wann?)
 * @subpackage Structs
 */
class FachlicheFreigabeModul extends Leistungsmodul
{
    /**
     * The fachlichFreigegebenAm
     * Meta information extracted from the WSDL
     * - documentation: Wann wurde die fachliche Freigabe erteilt?
     * - minOccurs: 0
     * @var string
     */
    public $fachlichFreigegebenAm;
    /**
     * The fachlichFreigegebenDurch
     * Meta information extracted from the WSDL
     * - documentation: Durch wen wurde die fachliche Freigabe erteilt?
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\String_Localized[]
     */
    public $fachlichFreigegebenDurch;
    /**
     * Constructor method for FachlicheFreigabeModul
     * @uses FachlicheFreigabeModul::setFachlichFreigegebenAm()
     * @uses FachlicheFreigabeModul::setFachlichFreigegebenDurch()
     * @param string $fachlichFreigegebenAm
     * @param \StructType\String_Localized[] $fachlichFreigegebenDurch
     */
    public function __construct($fachlichFreigegebenAm = null, array $fachlichFreigegebenDurch = array())
    {
        $this
            ->setFachlichFreigegebenAm($fachlichFreigegebenAm)
            ->setFachlichFreigegebenDurch($fachlichFreigegebenDurch);
    }
    /**
     * Get fachlichFreigegebenAm value
     * @return string|null
     */
    public function getFachlichFreigegebenAm()
    {
        return $this->fachlichFreigegebenAm;
    }
    /**
     * Set fachlichFreigegebenAm value
     * @param string $fachlichFreigegebenAm
     * @return \StructType\FachlicheFreigabeModul
     */
    public function setFachlichFreigegebenAm($fachlichFreigegebenAm = null)
    {
        // validation for constraint: string
        if (!is_null($fachlichFreigegebenAm) && !is_string($fachlichFreigegebenAm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fachlichFreigegebenAm, true), gettype($fachlichFreigegebenAm)), __LINE__);
        }
        $this->fachlichFreigegebenAm = $fachlichFreigegebenAm;
        return $this;
    }
    /**
     * Get fachlichFreigegebenDurch value
     * @return \StructType\String_Localized[]|null
     */
    public function getFachlichFreigegebenDurch()
    {
        return $this->fachlichFreigegebenDurch;
    }
    /**
     * This method is responsible for validating the values passed to the setFachlichFreigegebenDurch method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFachlichFreigegebenDurch method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFachlichFreigegebenDurchForArrayConstraintsFromSetFachlichFreigegebenDurch(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $fachlicheFreigabeModulFachlichFreigegebenDurchItem) {
            // validation for constraint: itemType
            if (!$fachlicheFreigabeModulFachlichFreigegebenDurchItem instanceof \StructType\String_Localized) {
                $invalidValues[] = is_object($fachlicheFreigabeModulFachlichFreigegebenDurchItem) ? get_class($fachlicheFreigabeModulFachlichFreigegebenDurchItem) : sprintf('%s(%s)', gettype($fachlicheFreigabeModulFachlichFreigegebenDurchItem), var_export($fachlicheFreigabeModulFachlichFreigegebenDurchItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The fachlichFreigegebenDurch property can only contain items of type \StructType\String_Localized, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set fachlichFreigegebenDurch value
     * @throws \InvalidArgumentException
     * @param \StructType\String_Localized[] $fachlichFreigegebenDurch
     * @return \StructType\FachlicheFreigabeModul
     */
    public function setFachlichFreigegebenDurch(array $fachlichFreigegebenDurch = array())
    {
        // validation for constraint: array
        if ('' !== ($fachlichFreigegebenDurchArrayErrorMessage = self::validateFachlichFreigegebenDurchForArrayConstraintsFromSetFachlichFreigegebenDurch($fachlichFreigegebenDurch))) {
            throw new \InvalidArgumentException($fachlichFreigegebenDurchArrayErrorMessage, __LINE__);
        }
        $this->fachlichFreigegebenDurch = $fachlichFreigegebenDurch;
        return $this;
    }
    /**
     * Add item to fachlichFreigegebenDurch value
     * @throws \InvalidArgumentException
     * @param \StructType\String_Localized $item
     * @return \StructType\FachlicheFreigabeModul
     */
    public function addToFachlichFreigegebenDurch(\StructType\String_Localized $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\String_Localized) {
            throw new \InvalidArgumentException(sprintf('The fachlichFreigegebenDurch property can only contain items of type \StructType\String_Localized, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->fachlichFreigegebenDurch[] = $item;
        return $this;
    }
}
