<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormulardateiXML StructType
 * Meta information extracted from the WSDL
 * - documentation: Hierüber kann eine Formulardatei in XML transportiert werden. Implementiert den abstrakten Typ Formulardatei.
 * @subpackage Structs
 */
class FormulardateiXML extends Formulardatei
{
    /**
     * The xmldaten
     * Meta information extracted from the WSDL
     * - documentation: Formulardokument in beliebigem XML-Format
     * @var \StructType\AnyXMLContent
     */
    public $xmldaten;
    /**
     * Constructor method for FormulardateiXML
     * @uses FormulardateiXML::setXmldaten()
     * @param \StructType\AnyXMLContent $xmldaten
     */
    public function __construct(\StructType\AnyXMLContent $xmldaten = null)
    {
        $this
            ->setXmldaten($xmldaten);
    }
    /**
     * Get xmldaten value
     * @return \StructType\AnyXMLContent|null
     */
    public function getXmldaten()
    {
        return $this->xmldaten;
    }
    /**
     * Set xmldaten value
     * @param \StructType\AnyXMLContent $xmldaten
     * @return \StructType\FormulardateiXML
     */
    public function setXmldaten(\StructType\AnyXMLContent $xmldaten = null)
    {
        $this->xmldaten = $xmldaten;
        return $this;
    }
}
