<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FristStichtag StructType
 * Meta information extracted from the WSDL
 * - documentation: Hierüber können Stichtage oder Intervalle von Stichtagen definiert werden. Es sind geschlossene, offene oder halboffene Intervalle möglich.
 * @subpackage Structs
 */
class FristStichtag extends AbstractStructBase
{
    /**
     * The von
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Von
     */
    public $von;
    /**
     * The bis
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Bis
     */
    public $bis;
    /**
     * Constructor method for FristStichtag
     * @uses FristStichtag::setVon()
     * @uses FristStichtag::setBis()
     * @param \StructType\Von $von
     * @param \StructType\Bis $bis
     */
    public function __construct(\StructType\Von $von = null, \StructType\Bis $bis = null)
    {
        $this
            ->setVon($von)
            ->setBis($bis);
    }
    /**
     * Get von value
     * @return \StructType\Von|null
     */
    public function getVon()
    {
        return $this->von;
    }
    /**
     * Set von value
     * @param \StructType\Von $von
     * @return \StructType\FristStichtag
     */
    public function setVon(\StructType\Von $von = null)
    {
        $this->von = $von;
        return $this;
    }
    /**
     * Get bis value
     * @return \StructType\Bis|null
     */
    public function getBis()
    {
        return $this->bis;
    }
    /**
     * Set bis value
     * @param \StructType\Bis $bis
     * @return \StructType\FristStichtag
     */
    public function setBis(\StructType\Bis $bis = null)
    {
        $this->bis = $bis;
        return $this;
    }
}
