<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for gebiete.anfrage.gebiet.040201 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Anfrage von Gebieten.
 * @subpackage Structs
 */
class Gebiete_anfrage_gebiet_040201 extends Basisnachricht
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Eine oder mehrere Gebietsanfragen.
     * - maxOccurs: unbounded
     * @var \StructType\AnfrageGebiet[]
     */
    public $anfrage;
    /**
     * Constructor method for gebiete.anfrage.gebiet.040201
     * @uses Gebiete_anfrage_gebiet_040201::setAnfrage()
     * @param \StructType\AnfrageGebiet[] $anfrage
     */
    public function __construct(array $anfrage = array())
    {
        $this
            ->setAnfrage($anfrage);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageGebiet[]|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * This method is responsible for validating the values passed to the setAnfrage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnfrage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnfrageForArrayConstraintsFromSetAnfrage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gebiete_anfrage_gebiet_040201AnfrageItem) {
            // validation for constraint: itemType
            if (!$gebiete_anfrage_gebiet_040201AnfrageItem instanceof \StructType\AnfrageGebiet) {
                $invalidValues[] = is_object($gebiete_anfrage_gebiet_040201AnfrageItem) ? get_class($gebiete_anfrage_gebiet_040201AnfrageItem) : sprintf('%s(%s)', gettype($gebiete_anfrage_gebiet_040201AnfrageItem), var_export($gebiete_anfrage_gebiet_040201AnfrageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The anfrage property can only contain items of type \StructType\AnfrageGebiet, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageGebiet[] $anfrage
     * @return \StructType\Gebiete_anfrage_gebiet_040201
     */
    public function setAnfrage(array $anfrage = array())
    {
        // validation for constraint: array
        if ('' !== ($anfrageArrayErrorMessage = self::validateAnfrageForArrayConstraintsFromSetAnfrage($anfrage))) {
            throw new \InvalidArgumentException($anfrageArrayErrorMessage, __LINE__);
        }
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Add item to anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageGebiet $item
     * @return \StructType\Gebiete_anfrage_gebiet_040201
     */
    public function addToAnfrage(\StructType\AnfrageGebiet $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnfrageGebiet) {
            throw new \InvalidArgumentException(sprintf('The anfrage property can only contain items of type \StructType\AnfrageGebiet, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->anfrage[] = $item;
        return $this;
    }
}
