<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for gebiete.antwort.gebiet.040204 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Übertragung von Antworten zu Gebietsanfragen.
 * @subpackage Structs
 */
class Gebiete_antwort_gebiet_040204 extends Basisnachricht
{
    /**
     * The antwort
     * Meta information extracted from the WSDL
     * - documentation: Antwort für Gebiete
     * - maxOccurs: unbounded
     * @var \StructType\AntwortGebiet[]
     */
    public $antwort;
    /**
     * Constructor method for gebiete.antwort.gebiet.040204
     * @uses Gebiete_antwort_gebiet_040204::setAntwort()
     * @param \StructType\AntwortGebiet[] $antwort
     */
    public function __construct(array $antwort = array())
    {
        $this
            ->setAntwort($antwort);
    }
    /**
     * Get antwort value
     * @return \StructType\AntwortGebiet[]|null
     */
    public function getAntwort()
    {
        return $this->antwort;
    }
    /**
     * This method is responsible for validating the values passed to the setAntwort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAntwort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAntwortForArrayConstraintsFromSetAntwort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gebiete_antwort_gebiet_040204AntwortItem) {
            // validation for constraint: itemType
            if (!$gebiete_antwort_gebiet_040204AntwortItem instanceof \StructType\AntwortGebiet) {
                $invalidValues[] = is_object($gebiete_antwort_gebiet_040204AntwortItem) ? get_class($gebiete_antwort_gebiet_040204AntwortItem) : sprintf('%s(%s)', gettype($gebiete_antwort_gebiet_040204AntwortItem), var_export($gebiete_antwort_gebiet_040204AntwortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The antwort property can only contain items of type \StructType\AntwortGebiet, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortGebiet[] $antwort
     * @return \StructType\Gebiete_antwort_gebiet_040204
     */
    public function setAntwort(array $antwort = array())
    {
        // validation for constraint: array
        if ('' !== ($antwortArrayErrorMessage = self::validateAntwortForArrayConstraintsFromSetAntwort($antwort))) {
            throw new \InvalidArgumentException($antwortArrayErrorMessage, __LINE__);
        }
        $this->antwort = $antwort;
        return $this;
    }
    /**
     * Add item to antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortGebiet $item
     * @return \StructType\Gebiete_antwort_gebiet_040204
     */
    public function addToAntwort(\StructType\AntwortGebiet $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AntwortGebiet) {
            throw new \InvalidArgumentException(sprintf('The antwort property can only contain items of type \StructType\AntwortGebiet, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->antwort[] = $item;
        return $this;
    }
}
