<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeocentricCRSType StructType
 * @subpackage Structs
 */
class GeocentricCRSType extends AbstractStructBase
{
    /**
     * The usesCartesianCS
     * @var \StructType\CartesianCSPropertyType
     */
    public $usesCartesianCS;
    /**
     * The usesSphericalCS
     * @var \StructType\SphericalCSPropertyType
     */
    public $usesSphericalCS;
    /**
     * The usesGeodeticDatum
     * @var \StructType\GeodeticDatumPropertyType
     */
    public $usesGeodeticDatum;
    /**
     * Constructor method for GeocentricCRSType
     * @uses GeocentricCRSType::setUsesCartesianCS()
     * @uses GeocentricCRSType::setUsesSphericalCS()
     * @uses GeocentricCRSType::setUsesGeodeticDatum()
     * @param \StructType\CartesianCSPropertyType $usesCartesianCS
     * @param \StructType\SphericalCSPropertyType $usesSphericalCS
     * @param \StructType\GeodeticDatumPropertyType $usesGeodeticDatum
     */
    public function __construct(\StructType\CartesianCSPropertyType $usesCartesianCS = null, \StructType\SphericalCSPropertyType $usesSphericalCS = null, \StructType\GeodeticDatumPropertyType $usesGeodeticDatum = null)
    {
        $this
            ->setUsesCartesianCS($usesCartesianCS)
            ->setUsesSphericalCS($usesSphericalCS)
            ->setUsesGeodeticDatum($usesGeodeticDatum);
    }
    /**
     * Get usesCartesianCS value
     * @return \StructType\CartesianCSPropertyType|null
     */
    public function getUsesCartesianCS()
    {
        return $this->usesCartesianCS;
    }
    /**
     * Set usesCartesianCS value
     * @param \StructType\CartesianCSPropertyType $usesCartesianCS
     * @return \StructType\GeocentricCRSType
     */
    public function setUsesCartesianCS(\StructType\CartesianCSPropertyType $usesCartesianCS = null)
    {
        $this->usesCartesianCS = $usesCartesianCS;
        return $this;
    }
    /**
     * Get usesSphericalCS value
     * @return \StructType\SphericalCSPropertyType|null
     */
    public function getUsesSphericalCS()
    {
        return $this->usesSphericalCS;
    }
    /**
     * Set usesSphericalCS value
     * @param \StructType\SphericalCSPropertyType $usesSphericalCS
     * @return \StructType\GeocentricCRSType
     */
    public function setUsesSphericalCS(\StructType\SphericalCSPropertyType $usesSphericalCS = null)
    {
        $this->usesSphericalCS = $usesSphericalCS;
        return $this;
    }
    /**
     * Get usesGeodeticDatum value
     * @return \StructType\GeodeticDatumPropertyType|null
     */
    public function getUsesGeodeticDatum()
    {
        return $this->usesGeodeticDatum;
    }
    /**
     * Set usesGeodeticDatum value
     * @param \StructType\GeodeticDatumPropertyType $usesGeodeticDatum
     * @return \StructType\GeocentricCRSType
     */
    public function setUsesGeodeticDatum(\StructType\GeodeticDatumPropertyType $usesGeodeticDatum = null)
    {
        $this->usesGeodeticDatum = $usesGeodeticDatum;
        return $this;
    }
}
