<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeodeticDatumType StructType
 * @subpackage Structs
 */
class GeodeticDatumType extends AbstractStructBase
{
    /**
     * The primeMeridian
     * @var \StructType\PrimeMeridianPropertyType
     */
    public $primeMeridian;
    /**
     * The ellipsoid
     * @var \StructType\EllipsoidPropertyType
     */
    public $ellipsoid;
    /**
     * Constructor method for GeodeticDatumType
     * @uses GeodeticDatumType::setPrimeMeridian()
     * @uses GeodeticDatumType::setEllipsoid()
     * @param \StructType\PrimeMeridianPropertyType $primeMeridian
     * @param \StructType\EllipsoidPropertyType $ellipsoid
     */
    public function __construct(\StructType\PrimeMeridianPropertyType $primeMeridian = null, \StructType\EllipsoidPropertyType $ellipsoid = null)
    {
        $this
            ->setPrimeMeridian($primeMeridian)
            ->setEllipsoid($ellipsoid);
    }
    /**
     * Get primeMeridian value
     * @return \StructType\PrimeMeridianPropertyType|null
     */
    public function getPrimeMeridian()
    {
        return $this->primeMeridian;
    }
    /**
     * Set primeMeridian value
     * @param \StructType\PrimeMeridianPropertyType $primeMeridian
     * @return \StructType\GeodeticDatumType
     */
    public function setPrimeMeridian(\StructType\PrimeMeridianPropertyType $primeMeridian = null)
    {
        $this->primeMeridian = $primeMeridian;
        return $this;
    }
    /**
     * Get ellipsoid value
     * @return \StructType\EllipsoidPropertyType|null
     */
    public function getEllipsoid()
    {
        return $this->ellipsoid;
    }
    /**
     * Set ellipsoid value
     * @param \StructType\EllipsoidPropertyType $ellipsoid
     * @return \StructType\GeodeticDatumType
     */
    public function setEllipsoid(\StructType\EllipsoidPropertyType $ellipsoid = null)
    {
        $this->ellipsoid = $ellipsoid;
        return $this;
    }
}
