<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeographicCRSType StructType
 * @subpackage Structs
 */
class GeographicCRSType extends AbstractStructBase
{
    /**
     * The usesEllipsoidalCS
     * @var \StructType\EllipsoidalCSPropertyType
     */
    public $usesEllipsoidalCS;
    /**
     * The usesGeodeticDatum
     * @var \StructType\GeodeticDatumPropertyType
     */
    public $usesGeodeticDatum;
    /**
     * Constructor method for GeographicCRSType
     * @uses GeographicCRSType::setUsesEllipsoidalCS()
     * @uses GeographicCRSType::setUsesGeodeticDatum()
     * @param \StructType\EllipsoidalCSPropertyType $usesEllipsoidalCS
     * @param \StructType\GeodeticDatumPropertyType $usesGeodeticDatum
     */
    public function __construct(\StructType\EllipsoidalCSPropertyType $usesEllipsoidalCS = null, \StructType\GeodeticDatumPropertyType $usesGeodeticDatum = null)
    {
        $this
            ->setUsesEllipsoidalCS($usesEllipsoidalCS)
            ->setUsesGeodeticDatum($usesGeodeticDatum);
    }
    /**
     * Get usesEllipsoidalCS value
     * @return \StructType\EllipsoidalCSPropertyType|null
     */
    public function getUsesEllipsoidalCS()
    {
        return $this->usesEllipsoidalCS;
    }
    /**
     * Set usesEllipsoidalCS value
     * @param \StructType\EllipsoidalCSPropertyType $usesEllipsoidalCS
     * @return \StructType\GeographicCRSType
     */
    public function setUsesEllipsoidalCS(\StructType\EllipsoidalCSPropertyType $usesEllipsoidalCS = null)
    {
        $this->usesEllipsoidalCS = $usesEllipsoidalCS;
        return $this;
    }
    /**
     * Get usesGeodeticDatum value
     * @return \StructType\GeodeticDatumPropertyType|null
     */
    public function getUsesGeodeticDatum()
    {
        return $this->usesGeodeticDatum;
    }
    /**
     * Set usesGeodeticDatum value
     * @param \StructType\GeodeticDatumPropertyType $usesGeodeticDatum
     * @return \StructType\GeographicCRSType
     */
    public function setUsesGeodeticDatum(\StructType\GeodeticDatumPropertyType $usesGeodeticDatum = null)
    {
        $this->usesGeodeticDatum = $usesGeodeticDatum;
        return $this;
    }
}
