<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Geokodierung StructType
 * Meta information extracted from the WSDL
 * - documentation: Geokodierung dient zur Abbildung von Geokoordinaten. Hierdurch wird die Lage eines Punktes im Raum bestimmt.
 * @subpackage Structs
 */
class Geokodierung extends AbstractStructBase
{
    /**
     * The Point
     * Meta information extracted from the WSDL
     * - ref: gml:Point
     * @var \StructType\PointType
     */
    public $Point;
    /**
     * Constructor method for Geokodierung
     * @uses Geokodierung::setPoint()
     * @param \StructType\PointType $point
     */
    public function __construct(\StructType\PointType $point = null)
    {
        $this
            ->setPoint($point);
    }
    /**
     * Get Point value
     * @return \StructType\PointType|null
     */
    public function getPoint()
    {
        return $this->Point;
    }
    /**
     * Set Point value
     * @param \StructType\PointType $point
     * @return \StructType\Geokodierung
     */
    public function setPoint(\StructType\PointType $point = null)
    {
        $this->Point = $point;
        return $this;
    }
}
