<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LI_ProcessStep_Type StructType
 * @subpackage Structs
 */
class LI_ProcessStep_Type extends AbstractStructBase
{
    /**
     * The description
     * @var \StructType\CharacterString_PropertyType
     */
    public $description;
    /**
     * The rationale
     * @var \StructType\CharacterString_PropertyType
     */
    public $rationale;
    /**
     * The dateTime
     * @var \StructType\DateTime_PropertyType
     */
    public $dateTime;
    /**
     * The processor
     * @var \StructType\CI_ResponsibleParty_PropertyType
     */
    public $processor;
    /**
     * The source
     * @var \StructType\LI_Source_PropertyType
     */
    public $source;
    /**
     * Constructor method for LI_ProcessStep_Type
     * @uses LI_ProcessStep_Type::setDescription()
     * @uses LI_ProcessStep_Type::setRationale()
     * @uses LI_ProcessStep_Type::setDateTime()
     * @uses LI_ProcessStep_Type::setProcessor()
     * @uses LI_ProcessStep_Type::setSource()
     * @param \StructType\CharacterString_PropertyType $description
     * @param \StructType\CharacterString_PropertyType $rationale
     * @param \StructType\DateTime_PropertyType $dateTime
     * @param \StructType\CI_ResponsibleParty_PropertyType $processor
     * @param \StructType\LI_Source_PropertyType $source
     */
    public function __construct(\StructType\CharacterString_PropertyType $description = null, \StructType\CharacterString_PropertyType $rationale = null, \StructType\DateTime_PropertyType $dateTime = null, \StructType\CI_ResponsibleParty_PropertyType $processor = null, \StructType\LI_Source_PropertyType $source = null)
    {
        $this
            ->setDescription($description)
            ->setRationale($rationale)
            ->setDateTime($dateTime)
            ->setProcessor($processor)
            ->setSource($source);
    }
    /**
     * Get description value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \StructType\CharacterString_PropertyType $description
     * @return \StructType\LI_ProcessStep_Type
     */
    public function setDescription(\StructType\CharacterString_PropertyType $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get rationale value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getRationale()
    {
        return $this->rationale;
    }
    /**
     * Set rationale value
     * @param \StructType\CharacterString_PropertyType $rationale
     * @return \StructType\LI_ProcessStep_Type
     */
    public function setRationale(\StructType\CharacterString_PropertyType $rationale = null)
    {
        $this->rationale = $rationale;
        return $this;
    }
    /**
     * Get dateTime value
     * @return \StructType\DateTime_PropertyType|null
     */
    public function getDateTime()
    {
        return $this->dateTime;
    }
    /**
     * Set dateTime value
     * @param \StructType\DateTime_PropertyType $dateTime
     * @return \StructType\LI_ProcessStep_Type
     */
    public function setDateTime(\StructType\DateTime_PropertyType $dateTime = null)
    {
        $this->dateTime = $dateTime;
        return $this;
    }
    /**
     * Get processor value
     * @return \StructType\CI_ResponsibleParty_PropertyType|null
     */
    public function getProcessor()
    {
        return $this->processor;
    }
    /**
     * Set processor value
     * @param \StructType\CI_ResponsibleParty_PropertyType $processor
     * @return \StructType\LI_ProcessStep_Type
     */
    public function setProcessor(\StructType\CI_ResponsibleParty_PropertyType $processor = null)
    {
        $this->processor = $processor;
        return $this;
    }
    /**
     * Get source value
     * @return \StructType\LI_Source_PropertyType|null
     */
    public function getSource()
    {
        return $this->source;
    }
    /**
     * Set source value
     * @param \StructType\LI_Source_PropertyType $source
     * @return \StructType\LI_ProcessStep_Type
     */
    public function setSource(\StructType\LI_Source_PropertyType $source = null)
    {
        $this->source = $source;
        return $this;
    }
}
