<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for leistungen.anfrage.leistung.040101 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Anfrage von Leistungen aus Zuständigkeitsfindern bzw. Leistungskatalogen.
 * @subpackage Structs
 */
class Leistungen_anfrage_leistung_040101 extends Basisnachricht
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Eine oder mehrere Leistungsanfragen.
     * - maxOccurs: unbounded
     * @var \StructType\AnfrageLeistung[]
     */
    public $anfrage;
    /**
     * Constructor method for leistungen.anfrage.leistung.040101
     * @uses Leistungen_anfrage_leistung_040101::setAnfrage()
     * @param \StructType\AnfrageLeistung[] $anfrage
     */
    public function __construct(array $anfrage = array())
    {
        $this
            ->setAnfrage($anfrage);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageLeistung[]|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * This method is responsible for validating the values passed to the setAnfrage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnfrage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnfrageForArrayConstraintsFromSetAnfrage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $leistungen_anfrage_leistung_040101AnfrageItem) {
            // validation for constraint: itemType
            if (!$leistungen_anfrage_leistung_040101AnfrageItem instanceof \StructType\AnfrageLeistung) {
                $invalidValues[] = is_object($leistungen_anfrage_leistung_040101AnfrageItem) ? get_class($leistungen_anfrage_leistung_040101AnfrageItem) : sprintf('%s(%s)', gettype($leistungen_anfrage_leistung_040101AnfrageItem), var_export($leistungen_anfrage_leistung_040101AnfrageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The anfrage property can only contain items of type \StructType\AnfrageLeistung, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageLeistung[] $anfrage
     * @return \StructType\Leistungen_anfrage_leistung_040101
     */
    public function setAnfrage(array $anfrage = array())
    {
        // validation for constraint: array
        if ('' !== ($anfrageArrayErrorMessage = self::validateAnfrageForArrayConstraintsFromSetAnfrage($anfrage))) {
            throw new \InvalidArgumentException($anfrageArrayErrorMessage, __LINE__);
        }
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Add item to anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageLeistung $item
     * @return \StructType\Leistungen_anfrage_leistung_040101
     */
    public function addToAnfrage(\StructType\AnfrageLeistung $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnfrageLeistung) {
            throw new \InvalidArgumentException(sprintf('The anfrage property can only contain items of type \StructType\AnfrageLeistung, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->anfrage[] = $item;
        return $this;
    }
}
