<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for leistungen.antwort.leistung.040104 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Übertragung von Antworten zu Leistungsanfragen bzw. zur Rückgabe von Antworten aus Leistungskatalogen.
 * @subpackage Structs
 */
class Leistungen_antwort_leistung_040104 extends Basisnachricht
{
    /**
     * The antwort
     * Meta information extracted from the WSDL
     * - documentation: Übertragene Antworten innerhalb der Nachricht.
     * - maxOccurs: unbounded
     * @var \StructType\AntwortLeistung[]
     */
    public $antwort;
    /**
     * Constructor method for leistungen.antwort.leistung.040104
     * @uses Leistungen_antwort_leistung_040104::setAntwort()
     * @param \StructType\AntwortLeistung[] $antwort
     */
    public function __construct(array $antwort = array())
    {
        $this
            ->setAntwort($antwort);
    }
    /**
     * Get antwort value
     * @return \StructType\AntwortLeistung[]|null
     */
    public function getAntwort()
    {
        return $this->antwort;
    }
    /**
     * This method is responsible for validating the values passed to the setAntwort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAntwort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAntwortForArrayConstraintsFromSetAntwort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $leistungen_antwort_leistung_040104AntwortItem) {
            // validation for constraint: itemType
            if (!$leistungen_antwort_leistung_040104AntwortItem instanceof \StructType\AntwortLeistung) {
                $invalidValues[] = is_object($leistungen_antwort_leistung_040104AntwortItem) ? get_class($leistungen_antwort_leistung_040104AntwortItem) : sprintf('%s(%s)', gettype($leistungen_antwort_leistung_040104AntwortItem), var_export($leistungen_antwort_leistung_040104AntwortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The antwort property can only contain items of type \StructType\AntwortLeistung, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortLeistung[] $antwort
     * @return \StructType\Leistungen_antwort_leistung_040104
     */
    public function setAntwort(array $antwort = array())
    {
        // validation for constraint: array
        if ('' !== ($antwortArrayErrorMessage = self::validateAntwortForArrayConstraintsFromSetAntwort($antwort))) {
            throw new \InvalidArgumentException($antwortArrayErrorMessage, __LINE__);
        }
        $this->antwort = $antwort;
        return $this;
    }
    /**
     * Add item to antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortLeistung $item
     * @return \StructType\Leistungen_antwort_leistung_040104
     */
    public function addToAntwort(\StructType\AntwortLeistung $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AntwortLeistung) {
            throw new \InvalidArgumentException(sprintf('The antwort property can only contain items of type \StructType\AntwortLeistung, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->antwort[] = $item;
        return $this;
    }
}
