<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for leistungen.antwort.leistungsbericht.040108 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Übermittlung von Leistungsberichten. Leistungsberichte enthalten Leistungen sowie für diese Leistungen zuständige Organisationseinheiten (auch in Rolle Ansprechpunkt). Für Organisationseinheiten werden die
 * Zuständigkeitsinformationen, Formulare und Kontaktpersonen übertragen.
 * @subpackage Structs
 */
class Leistungen_antwort_leistungsbericht_040108 extends Basisnachricht
{
    /**
     * The antwort
     * Meta information extracted from the WSDL
     * - documentation: Antwort auf eine Anfrage für einen Leistungsbericht.
     * - maxOccurs: unbounded
     * @var \StructType\AntwortLeistungsbericht[]
     */
    public $antwort;
    /**
     * Constructor method for leistungen.antwort.leistungsbericht.040108
     * @uses Leistungen_antwort_leistungsbericht_040108::setAntwort()
     * @param \StructType\AntwortLeistungsbericht[] $antwort
     */
    public function __construct(array $antwort = array())
    {
        $this
            ->setAntwort($antwort);
    }
    /**
     * Get antwort value
     * @return \StructType\AntwortLeistungsbericht[]|null
     */
    public function getAntwort()
    {
        return $this->antwort;
    }
    /**
     * This method is responsible for validating the values passed to the setAntwort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAntwort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAntwortForArrayConstraintsFromSetAntwort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $leistungen_antwort_leistungsbericht_040108AntwortItem) {
            // validation for constraint: itemType
            if (!$leistungen_antwort_leistungsbericht_040108AntwortItem instanceof \StructType\AntwortLeistungsbericht) {
                $invalidValues[] = is_object($leistungen_antwort_leistungsbericht_040108AntwortItem) ? get_class($leistungen_antwort_leistungsbericht_040108AntwortItem) : sprintf('%s(%s)', gettype($leistungen_antwort_leistungsbericht_040108AntwortItem), var_export($leistungen_antwort_leistungsbericht_040108AntwortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The antwort property can only contain items of type \StructType\AntwortLeistungsbericht, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortLeistungsbericht[] $antwort
     * @return \StructType\Leistungen_antwort_leistungsbericht_040108
     */
    public function setAntwort(array $antwort = array())
    {
        // validation for constraint: array
        if ('' !== ($antwortArrayErrorMessage = self::validateAntwortForArrayConstraintsFromSetAntwort($antwort))) {
            throw new \InvalidArgumentException($antwortArrayErrorMessage, __LINE__);
        }
        $this->antwort = $antwort;
        return $this;
    }
    /**
     * Add item to antwort value
     * @throws \InvalidArgumentException
     * @param \StructType\AntwortLeistungsbericht $item
     * @return \StructType\Leistungen_antwort_leistungsbericht_040108
     */
    public function addToAntwort(\StructType\AntwortLeistungsbericht $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AntwortLeistungsbericht) {
            throw new \InvalidArgumentException(sprintf('The antwort property can only contain items of type \StructType\AntwortLeistungsbericht, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->antwort[] = $item;
        return $this;
    }
}
