<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LeistungsstrukturObjekt StructType
 * Meta information extracted from the WSDL
 * - documentation: Zur Abbildung von Leistungsobjekten nach Leika (Leistungskennung). Beispiel: "Personalausweis"
 * @subpackage Structs
 */
class LeistungsstrukturObjekt extends Leistungsstruktur
{
    /**
     * The leistungsgruppierung
     * Meta information extracted from the WSDL
     * - documentation: Zuordnung der Leistungsgruppierung, z.B. "Baurecht".
     * - minOccurs: 0
     * @var \StructType\LeistungsgruppierungAuswahl
     */
    public $leistungsgruppierung;
    /**
     * Constructor method for LeistungsstrukturObjekt
     * @uses LeistungsstrukturObjekt::setLeistungsgruppierung()
     * @param \StructType\LeistungsgruppierungAuswahl $leistungsgruppierung
     */
    public function __construct(\StructType\LeistungsgruppierungAuswahl $leistungsgruppierung = null)
    {
        $this
            ->setLeistungsgruppierung($leistungsgruppierung);
    }
    /**
     * Get leistungsgruppierung value
     * @return \StructType\LeistungsgruppierungAuswahl|null
     */
    public function getLeistungsgruppierung()
    {
        return $this->leistungsgruppierung;
    }
    /**
     * Set leistungsgruppierung value
     * @param \StructType\LeistungsgruppierungAuswahl $leistungsgruppierung
     * @return \StructType\LeistungsstrukturObjekt
     */
    public function setLeistungsgruppierung(\StructType\LeistungsgruppierungAuswahl $leistungsgruppierung = null)
    {
        $this->leistungsgruppierung = $leistungsgruppierung;
        return $this;
    }
}
