<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LeistungsstrukturObjektMitVerrichtungUndDetail StructType
 * Meta information extracted from the WSDL
 * - documentation: Zur Abbildung von Leistungsobjekten mit Verrichtung und Verrichtungsdetail nach Leika. Beispiel: "Personalausweis Ausstellung neu wegen Verlust"
 * @subpackage Structs
 */
class LeistungsstrukturObjektMitVerrichtungUndDetail extends LeistungsstrukturObjektMitVerrichtung
{
    /**
     * The verrichtungsdetail
     * Meta information extracted from the WSDL
     * - documentation: Angabe des Verrichtungsdetails, z.B. "neu wegen Verlusts"
     * - maxOccurs: unbounded
     * @var \StructType\String_Localized[]
     */
    public $verrichtungsdetail;
    /**
     * Constructor method for LeistungsstrukturObjektMitVerrichtungUndDetail
     * @uses LeistungsstrukturObjektMitVerrichtungUndDetail::setVerrichtungsdetail()
     * @param \StructType\String_Localized[] $verrichtungsdetail
     */
    public function __construct(array $verrichtungsdetail = array())
    {
        $this
            ->setVerrichtungsdetail($verrichtungsdetail);
    }
    /**
     * Get verrichtungsdetail value
     * @return \StructType\String_Localized[]|null
     */
    public function getVerrichtungsdetail()
    {
        return $this->verrichtungsdetail;
    }
    /**
     * This method is responsible for validating the values passed to the setVerrichtungsdetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVerrichtungsdetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVerrichtungsdetailForArrayConstraintsFromSetVerrichtungsdetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $leistungsstrukturObjektMitVerrichtungUndDetailVerrichtungsdetailItem) {
            // validation for constraint: itemType
            if (!$leistungsstrukturObjektMitVerrichtungUndDetailVerrichtungsdetailItem instanceof \StructType\String_Localized) {
                $invalidValues[] = is_object($leistungsstrukturObjektMitVerrichtungUndDetailVerrichtungsdetailItem) ? get_class($leistungsstrukturObjektMitVerrichtungUndDetailVerrichtungsdetailItem) : sprintf('%s(%s)', gettype($leistungsstrukturObjektMitVerrichtungUndDetailVerrichtungsdetailItem), var_export($leistungsstrukturObjektMitVerrichtungUndDetailVerrichtungsdetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The verrichtungsdetail property can only contain items of type \StructType\String_Localized, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set verrichtungsdetail value
     * @throws \InvalidArgumentException
     * @param \StructType\String_Localized[] $verrichtungsdetail
     * @return \StructType\LeistungsstrukturObjektMitVerrichtungUndDetail
     */
    public function setVerrichtungsdetail(array $verrichtungsdetail = array())
    {
        // validation for constraint: array
        if ('' !== ($verrichtungsdetailArrayErrorMessage = self::validateVerrichtungsdetailForArrayConstraintsFromSetVerrichtungsdetail($verrichtungsdetail))) {
            throw new \InvalidArgumentException($verrichtungsdetailArrayErrorMessage, __LINE__);
        }
        $this->verrichtungsdetail = $verrichtungsdetail;
        return $this;
    }
    /**
     * Add item to verrichtungsdetail value
     * @throws \InvalidArgumentException
     * @param \StructType\String_Localized $item
     * @return \StructType\LeistungsstrukturObjektMitVerrichtungUndDetail
     */
    public function addToVerrichtungsdetail(\StructType\String_Localized $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\String_Localized) {
            throw new \InvalidArgumentException(sprintf('The verrichtungsdetail property can only contain items of type \StructType\String_Localized, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->verrichtungsdetail[] = $item;
        return $this;
    }
}
