<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LocationPropertyType StructType
 * @subpackage Structs
 */
class LocationPropertyType extends AbstractStructBase
{
    /**
     * The AbstractGeometry
     * @var \StructType\AbstractGeometryType
     */
    public $AbstractGeometry;
    /**
     * The LocationKeyWord
     * @var \StructType\CodeType
     */
    public $LocationKeyWord;
    /**
     * The LocationString
     * @var \StructType\StringOrRefType
     */
    public $LocationString;
    /**
     * The Null
     * @var string
     */
    public $Null;
    /**
     * The nilReason
     * @var string
     */
    public $nilReason;
    /**
     * The remoteSchema
     * @var string
     */
    public $remoteSchema;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The href
     * @var string
     */
    public $href;
    /**
     * The role
     * @var string
     */
    public $role;
    /**
     * The arcrole
     * @var string
     */
    public $arcrole;
    /**
     * The title
     * @var string
     */
    public $title;
    /**
     * The show
     * @var string
     */
    public $show;
    /**
     * The actuate
     * @var string
     */
    public $actuate;
    /**
     * Constructor method for LocationPropertyType
     * @uses LocationPropertyType::setAbstractGeometry()
     * @uses LocationPropertyType::setLocationKeyWord()
     * @uses LocationPropertyType::setLocationString()
     * @uses LocationPropertyType::setNull()
     * @uses LocationPropertyType::setNilReason()
     * @uses LocationPropertyType::setRemoteSchema()
     * @uses LocationPropertyType::setType()
     * @uses LocationPropertyType::setHref()
     * @uses LocationPropertyType::setRole()
     * @uses LocationPropertyType::setArcrole()
     * @uses LocationPropertyType::setTitle()
     * @uses LocationPropertyType::setShow()
     * @uses LocationPropertyType::setActuate()
     * @param \StructType\AbstractGeometryType $abstractGeometry
     * @param \StructType\CodeType $locationKeyWord
     * @param \StructType\StringOrRefType $locationString
     * @param string $null
     * @param string $nilReason
     * @param string $remoteSchema
     * @param string $type
     * @param string $href
     * @param string $role
     * @param string $arcrole
     * @param string $title
     * @param string $show
     * @param string $actuate
     */
    public function __construct(\StructType\AbstractGeometryType $abstractGeometry = null, \StructType\CodeType $locationKeyWord = null, \StructType\StringOrRefType $locationString = null, $null = null, $nilReason = null, $remoteSchema = null, $type = null, $href = null, $role = null, $arcrole = null, $title = null, $show = null, $actuate = null)
    {
        $this
            ->setAbstractGeometry($abstractGeometry)
            ->setLocationKeyWord($locationKeyWord)
            ->setLocationString($locationString)
            ->setNull($null)
            ->setNilReason($nilReason)
            ->setRemoteSchema($remoteSchema)
            ->setType($type)
            ->setHref($href)
            ->setRole($role)
            ->setArcrole($arcrole)
            ->setTitle($title)
            ->setShow($show)
            ->setActuate($actuate);
    }
    /**
     * Get AbstractGeometry value
     * @return \StructType\AbstractGeometryType|null
     */
    public function getAbstractGeometry()
    {
        return $this->AbstractGeometry;
    }
    /**
     * Set AbstractGeometry value
     * @param \StructType\AbstractGeometryType $abstractGeometry
     * @return \StructType\LocationPropertyType
     */
    public function setAbstractGeometry(\StructType\AbstractGeometryType $abstractGeometry = null)
    {
        $this->AbstractGeometry = $abstractGeometry;
        return $this;
    }
    /**
     * Get LocationKeyWord value
     * @return \StructType\CodeType|null
     */
    public function getLocationKeyWord()
    {
        return $this->LocationKeyWord;
    }
    /**
     * Set LocationKeyWord value
     * @param \StructType\CodeType $locationKeyWord
     * @return \StructType\LocationPropertyType
     */
    public function setLocationKeyWord(\StructType\CodeType $locationKeyWord = null)
    {
        $this->LocationKeyWord = $locationKeyWord;
        return $this;
    }
    /**
     * Get LocationString value
     * @return \StructType\StringOrRefType|null
     */
    public function getLocationString()
    {
        return $this->LocationString;
    }
    /**
     * Set LocationString value
     * @param \StructType\StringOrRefType $locationString
     * @return \StructType\LocationPropertyType
     */
    public function setLocationString(\StructType\StringOrRefType $locationString = null)
    {
        $this->LocationString = $locationString;
        return $this;
    }
    /**
     * Get Null value
     * @return string|null
     */
    public function getNull()
    {
        return $this->Null;
    }
    /**
     * Set Null value
     * @param string $null
     * @return \StructType\LocationPropertyType
     */
    public function setNull($null = null)
    {
        // validation for constraint: string
        if (!is_null($null) && !is_string($null)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($null, true), gettype($null)), __LINE__);
        }
        $this->Null = $null;
        return $this;
    }
    /**
     * Get nilReason value
     * @return string|null
     */
    public function getNilReason()
    {
        return $this->nilReason;
    }
    /**
     * Set nilReason value
     * @param string $nilReason
     * @return \StructType\LocationPropertyType
     */
    public function setNilReason($nilReason = null)
    {
        // validation for constraint: string
        if (!is_null($nilReason) && !is_string($nilReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nilReason, true), gettype($nilReason)), __LINE__);
        }
        $this->nilReason = $nilReason;
        return $this;
    }
    /**
     * Get remoteSchema value
     * @return string|null
     */
    public function getRemoteSchema()
    {
        return $this->remoteSchema;
    }
    /**
     * Set remoteSchema value
     * @param string $remoteSchema
     * @return \StructType\LocationPropertyType
     */
    public function setRemoteSchema($remoteSchema = null)
    {
        // validation for constraint: string
        if (!is_null($remoteSchema) && !is_string($remoteSchema)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteSchema, true), gettype($remoteSchema)), __LINE__);
        }
        $this->remoteSchema = $remoteSchema;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\LocationPropertyType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get href value
     * @return string|null
     */
    public function getHref()
    {
        return $this->href;
    }
    /**
     * Set href value
     * @param string $href
     * @return \StructType\LocationPropertyType
     */
    public function setHref($href = null)
    {
        // validation for constraint: string
        if (!is_null($href) && !is_string($href)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($href, true), gettype($href)), __LINE__);
        }
        $this->href = $href;
        return $this;
    }
    /**
     * Get role value
     * @return string|null
     */
    public function getRole()
    {
        return $this->role;
    }
    /**
     * Set role value
     * @param string $role
     * @return \StructType\LocationPropertyType
     */
    public function setRole($role = null)
    {
        // validation for constraint: string
        if (!is_null($role) && !is_string($role)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($role, true), gettype($role)), __LINE__);
        }
        $this->role = $role;
        return $this;
    }
    /**
     * Get arcrole value
     * @return string|null
     */
    public function getArcrole()
    {
        return $this->arcrole;
    }
    /**
     * Set arcrole value
     * @param string $arcrole
     * @return \StructType\LocationPropertyType
     */
    public function setArcrole($arcrole = null)
    {
        // validation for constraint: string
        if (!is_null($arcrole) && !is_string($arcrole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arcrole, true), gettype($arcrole)), __LINE__);
        }
        $this->arcrole = $arcrole;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\LocationPropertyType
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Get show value
     * @return string|null
     */
    public function getShow()
    {
        return $this->show;
    }
    /**
     * Set show value
     * @param string $show
     * @return \StructType\LocationPropertyType
     */
    public function setShow($show = null)
    {
        // validation for constraint: string
        if (!is_null($show) && !is_string($show)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($show, true), gettype($show)), __LINE__);
        }
        $this->show = $show;
        return $this;
    }
    /**
     * Get actuate value
     * @return string|null
     */
    public function getActuate()
    {
        return $this->actuate;
    }
    /**
     * Set actuate value
     * @param string $actuate
     * @return \StructType\LocationPropertyType
     */
    public function setActuate($actuate = null)
    {
        // validation for constraint: string
        if (!is_null($actuate) && !is_string($actuate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actuate, true), gettype($actuate)), __LINE__);
        }
        $this->actuate = $actuate;
        return $this;
    }
}
