<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_Band_Type StructType
 * @subpackage Structs
 */
class MD_Band_Type extends AbstractStructBase
{
    /**
     * The maxValue
     * @var \StructType\Real_PropertyType
     */
    public $maxValue;
    /**
     * The minValue
     * @var \StructType\Real_PropertyType
     */
    public $minValue;
    /**
     * The units
     * @var \StructType\UomLength_PropertyType
     */
    public $units;
    /**
     * The peakResponse
     * @var \StructType\Real_PropertyType
     */
    public $peakResponse;
    /**
     * The bitsPerValue
     * @var \StructType\Integer_PropertyType
     */
    public $bitsPerValue;
    /**
     * The toneGradation
     * @var \StructType\Integer_PropertyType
     */
    public $toneGradation;
    /**
     * The scaleFactor
     * @var \StructType\Real_PropertyType
     */
    public $scaleFactor;
    /**
     * The offset
     * @var \StructType\Real_PropertyType
     */
    public $offset;
    /**
     * Constructor method for MD_Band_Type
     * @uses MD_Band_Type::setMaxValue()
     * @uses MD_Band_Type::setMinValue()
     * @uses MD_Band_Type::setUnits()
     * @uses MD_Band_Type::setPeakResponse()
     * @uses MD_Band_Type::setBitsPerValue()
     * @uses MD_Band_Type::setToneGradation()
     * @uses MD_Band_Type::setScaleFactor()
     * @uses MD_Band_Type::setOffset()
     * @param \StructType\Real_PropertyType $maxValue
     * @param \StructType\Real_PropertyType $minValue
     * @param \StructType\UomLength_PropertyType $units
     * @param \StructType\Real_PropertyType $peakResponse
     * @param \StructType\Integer_PropertyType $bitsPerValue
     * @param \StructType\Integer_PropertyType $toneGradation
     * @param \StructType\Real_PropertyType $scaleFactor
     * @param \StructType\Real_PropertyType $offset
     */
    public function __construct(\StructType\Real_PropertyType $maxValue = null, \StructType\Real_PropertyType $minValue = null, \StructType\UomLength_PropertyType $units = null, \StructType\Real_PropertyType $peakResponse = null, \StructType\Integer_PropertyType $bitsPerValue = null, \StructType\Integer_PropertyType $toneGradation = null, \StructType\Real_PropertyType $scaleFactor = null, \StructType\Real_PropertyType $offset = null)
    {
        $this
            ->setMaxValue($maxValue)
            ->setMinValue($minValue)
            ->setUnits($units)
            ->setPeakResponse($peakResponse)
            ->setBitsPerValue($bitsPerValue)
            ->setToneGradation($toneGradation)
            ->setScaleFactor($scaleFactor)
            ->setOffset($offset);
    }
    /**
     * Get maxValue value
     * @return \StructType\Real_PropertyType|null
     */
    public function getMaxValue()
    {
        return $this->maxValue;
    }
    /**
     * Set maxValue value
     * @param \StructType\Real_PropertyType $maxValue
     * @return \StructType\MD_Band_Type
     */
    public function setMaxValue(\StructType\Real_PropertyType $maxValue = null)
    {
        $this->maxValue = $maxValue;
        return $this;
    }
    /**
     * Get minValue value
     * @return \StructType\Real_PropertyType|null
     */
    public function getMinValue()
    {
        return $this->minValue;
    }
    /**
     * Set minValue value
     * @param \StructType\Real_PropertyType $minValue
     * @return \StructType\MD_Band_Type
     */
    public function setMinValue(\StructType\Real_PropertyType $minValue = null)
    {
        $this->minValue = $minValue;
        return $this;
    }
    /**
     * Get units value
     * @return \StructType\UomLength_PropertyType|null
     */
    public function getUnits()
    {
        return $this->units;
    }
    /**
     * Set units value
     * @param \StructType\UomLength_PropertyType $units
     * @return \StructType\MD_Band_Type
     */
    public function setUnits(\StructType\UomLength_PropertyType $units = null)
    {
        $this->units = $units;
        return $this;
    }
    /**
     * Get peakResponse value
     * @return \StructType\Real_PropertyType|null
     */
    public function getPeakResponse()
    {
        return $this->peakResponse;
    }
    /**
     * Set peakResponse value
     * @param \StructType\Real_PropertyType $peakResponse
     * @return \StructType\MD_Band_Type
     */
    public function setPeakResponse(\StructType\Real_PropertyType $peakResponse = null)
    {
        $this->peakResponse = $peakResponse;
        return $this;
    }
    /**
     * Get bitsPerValue value
     * @return \StructType\Integer_PropertyType|null
     */
    public function getBitsPerValue()
    {
        return $this->bitsPerValue;
    }
    /**
     * Set bitsPerValue value
     * @param \StructType\Integer_PropertyType $bitsPerValue
     * @return \StructType\MD_Band_Type
     */
    public function setBitsPerValue(\StructType\Integer_PropertyType $bitsPerValue = null)
    {
        $this->bitsPerValue = $bitsPerValue;
        return $this;
    }
    /**
     * Get toneGradation value
     * @return \StructType\Integer_PropertyType|null
     */
    public function getToneGradation()
    {
        return $this->toneGradation;
    }
    /**
     * Set toneGradation value
     * @param \StructType\Integer_PropertyType $toneGradation
     * @return \StructType\MD_Band_Type
     */
    public function setToneGradation(\StructType\Integer_PropertyType $toneGradation = null)
    {
        $this->toneGradation = $toneGradation;
        return $this;
    }
    /**
     * Get scaleFactor value
     * @return \StructType\Real_PropertyType|null
     */
    public function getScaleFactor()
    {
        return $this->scaleFactor;
    }
    /**
     * Set scaleFactor value
     * @param \StructType\Real_PropertyType $scaleFactor
     * @return \StructType\MD_Band_Type
     */
    public function setScaleFactor(\StructType\Real_PropertyType $scaleFactor = null)
    {
        $this->scaleFactor = $scaleFactor;
        return $this;
    }
    /**
     * Get offset value
     * @return \StructType\Real_PropertyType|null
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param \StructType\Real_PropertyType $offset
     * @return \StructType\MD_Band_Type
     */
    public function setOffset(\StructType\Real_PropertyType $offset = null)
    {
        $this->offset = $offset;
        return $this;
    }
}
