<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_DigitalTransferOptions_Type StructType
 * @subpackage Structs
 */
class MD_DigitalTransferOptions_Type extends AbstractStructBase
{
    /**
     * The unitsOfDistribution
     * @var \StructType\CharacterString_PropertyType
     */
    public $unitsOfDistribution;
    /**
     * The transferSize
     * @var \StructType\Real_PropertyType
     */
    public $transferSize;
    /**
     * The onLine
     * @var \StructType\CI_OnlineResource_PropertyType
     */
    public $onLine;
    /**
     * The offLine
     * @var \StructType\MD_Medium_PropertyType
     */
    public $offLine;
    /**
     * Constructor method for MD_DigitalTransferOptions_Type
     * @uses MD_DigitalTransferOptions_Type::setUnitsOfDistribution()
     * @uses MD_DigitalTransferOptions_Type::setTransferSize()
     * @uses MD_DigitalTransferOptions_Type::setOnLine()
     * @uses MD_DigitalTransferOptions_Type::setOffLine()
     * @param \StructType\CharacterString_PropertyType $unitsOfDistribution
     * @param \StructType\Real_PropertyType $transferSize
     * @param \StructType\CI_OnlineResource_PropertyType $onLine
     * @param \StructType\MD_Medium_PropertyType $offLine
     */
    public function __construct(\StructType\CharacterString_PropertyType $unitsOfDistribution = null, \StructType\Real_PropertyType $transferSize = null, \StructType\CI_OnlineResource_PropertyType $onLine = null, \StructType\MD_Medium_PropertyType $offLine = null)
    {
        $this
            ->setUnitsOfDistribution($unitsOfDistribution)
            ->setTransferSize($transferSize)
            ->setOnLine($onLine)
            ->setOffLine($offLine);
    }
    /**
     * Get unitsOfDistribution value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getUnitsOfDistribution()
    {
        return $this->unitsOfDistribution;
    }
    /**
     * Set unitsOfDistribution value
     * @param \StructType\CharacterString_PropertyType $unitsOfDistribution
     * @return \StructType\MD_DigitalTransferOptions_Type
     */
    public function setUnitsOfDistribution(\StructType\CharacterString_PropertyType $unitsOfDistribution = null)
    {
        $this->unitsOfDistribution = $unitsOfDistribution;
        return $this;
    }
    /**
     * Get transferSize value
     * @return \StructType\Real_PropertyType|null
     */
    public function getTransferSize()
    {
        return $this->transferSize;
    }
    /**
     * Set transferSize value
     * @param \StructType\Real_PropertyType $transferSize
     * @return \StructType\MD_DigitalTransferOptions_Type
     */
    public function setTransferSize(\StructType\Real_PropertyType $transferSize = null)
    {
        $this->transferSize = $transferSize;
        return $this;
    }
    /**
     * Get onLine value
     * @return \StructType\CI_OnlineResource_PropertyType|null
     */
    public function getOnLine()
    {
        return $this->onLine;
    }
    /**
     * Set onLine value
     * @param \StructType\CI_OnlineResource_PropertyType $onLine
     * @return \StructType\MD_DigitalTransferOptions_Type
     */
    public function setOnLine(\StructType\CI_OnlineResource_PropertyType $onLine = null)
    {
        $this->onLine = $onLine;
        return $this;
    }
    /**
     * Get offLine value
     * @return \StructType\MD_Medium_PropertyType|null
     */
    public function getOffLine()
    {
        return $this->offLine;
    }
    /**
     * Set offLine value
     * @param \StructType\MD_Medium_PropertyType $offLine
     * @return \StructType\MD_DigitalTransferOptions_Type
     */
    public function setOffLine(\StructType\MD_Medium_PropertyType $offLine = null)
    {
        $this->offLine = $offLine;
        return $this;
    }
}
