<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_Distributor_Type StructType
 * @subpackage Structs
 */
class MD_Distributor_Type extends AbstractStructBase
{
    /**
     * The distributorContact
     * @var \StructType\CI_ResponsibleParty_PropertyType
     */
    public $distributorContact;
    /**
     * The distributionOrderProcess
     * @var \StructType\MD_StandardOrderProcess_PropertyType
     */
    public $distributionOrderProcess;
    /**
     * The distributorFormat
     * @var \StructType\MD_Format_PropertyType
     */
    public $distributorFormat;
    /**
     * The distributorTransferOptions
     * @var \StructType\MD_DigitalTransferOptions_PropertyType
     */
    public $distributorTransferOptions;
    /**
     * Constructor method for MD_Distributor_Type
     * @uses MD_Distributor_Type::setDistributorContact()
     * @uses MD_Distributor_Type::setDistributionOrderProcess()
     * @uses MD_Distributor_Type::setDistributorFormat()
     * @uses MD_Distributor_Type::setDistributorTransferOptions()
     * @param \StructType\CI_ResponsibleParty_PropertyType $distributorContact
     * @param \StructType\MD_StandardOrderProcess_PropertyType $distributionOrderProcess
     * @param \StructType\MD_Format_PropertyType $distributorFormat
     * @param \StructType\MD_DigitalTransferOptions_PropertyType $distributorTransferOptions
     */
    public function __construct(\StructType\CI_ResponsibleParty_PropertyType $distributorContact = null, \StructType\MD_StandardOrderProcess_PropertyType $distributionOrderProcess = null, \StructType\MD_Format_PropertyType $distributorFormat = null, \StructType\MD_DigitalTransferOptions_PropertyType $distributorTransferOptions = null)
    {
        $this
            ->setDistributorContact($distributorContact)
            ->setDistributionOrderProcess($distributionOrderProcess)
            ->setDistributorFormat($distributorFormat)
            ->setDistributorTransferOptions($distributorTransferOptions);
    }
    /**
     * Get distributorContact value
     * @return \StructType\CI_ResponsibleParty_PropertyType|null
     */
    public function getDistributorContact()
    {
        return $this->distributorContact;
    }
    /**
     * Set distributorContact value
     * @param \StructType\CI_ResponsibleParty_PropertyType $distributorContact
     * @return \StructType\MD_Distributor_Type
     */
    public function setDistributorContact(\StructType\CI_ResponsibleParty_PropertyType $distributorContact = null)
    {
        $this->distributorContact = $distributorContact;
        return $this;
    }
    /**
     * Get distributionOrderProcess value
     * @return \StructType\MD_StandardOrderProcess_PropertyType|null
     */
    public function getDistributionOrderProcess()
    {
        return $this->distributionOrderProcess;
    }
    /**
     * Set distributionOrderProcess value
     * @param \StructType\MD_StandardOrderProcess_PropertyType $distributionOrderProcess
     * @return \StructType\MD_Distributor_Type
     */
    public function setDistributionOrderProcess(\StructType\MD_StandardOrderProcess_PropertyType $distributionOrderProcess = null)
    {
        $this->distributionOrderProcess = $distributionOrderProcess;
        return $this;
    }
    /**
     * Get distributorFormat value
     * @return \StructType\MD_Format_PropertyType|null
     */
    public function getDistributorFormat()
    {
        return $this->distributorFormat;
    }
    /**
     * Set distributorFormat value
     * @param \StructType\MD_Format_PropertyType $distributorFormat
     * @return \StructType\MD_Distributor_Type
     */
    public function setDistributorFormat(\StructType\MD_Format_PropertyType $distributorFormat = null)
    {
        $this->distributorFormat = $distributorFormat;
        return $this;
    }
    /**
     * Get distributorTransferOptions value
     * @return \StructType\MD_DigitalTransferOptions_PropertyType|null
     */
    public function getDistributorTransferOptions()
    {
        return $this->distributorTransferOptions;
    }
    /**
     * Set distributorTransferOptions value
     * @param \StructType\MD_DigitalTransferOptions_PropertyType $distributorTransferOptions
     * @return \StructType\MD_Distributor_Type
     */
    public function setDistributorTransferOptions(\StructType\MD_DigitalTransferOptions_PropertyType $distributorTransferOptions = null)
    {
        $this->distributorTransferOptions = $distributorTransferOptions;
        return $this;
    }
}
