<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_ExtendedElementInformation_Type StructType
 * @subpackage Structs
 */
class MD_ExtendedElementInformation_Type extends AbstractStructBase
{
    /**
     * The name
     * @var \StructType\CharacterString_PropertyType
     */
    public $name;
    /**
     * The shortName
     * @var \StructType\CharacterString_PropertyType
     */
    public $shortName;
    /**
     * The domainCode
     * @var \StructType\Integer_PropertyType
     */
    public $domainCode;
    /**
     * The definition
     * @var \StructType\CharacterString_PropertyType
     */
    public $definition;
    /**
     * The obligation
     * @var \StructType\MD_ObligationCode_PropertyType
     */
    public $obligation;
    /**
     * The condition
     * @var \StructType\CharacterString_PropertyType
     */
    public $condition;
    /**
     * The dataType
     * @var \StructType\MD_DatatypeCode_PropertyType
     */
    public $dataType;
    /**
     * The maximumOccurrence
     * @var \StructType\CharacterString_PropertyType
     */
    public $maximumOccurrence;
    /**
     * The domainValue
     * @var \StructType\CharacterString_PropertyType
     */
    public $domainValue;
    /**
     * The parentEntity
     * @var \StructType\CharacterString_PropertyType
     */
    public $parentEntity;
    /**
     * The rule
     * @var \StructType\CharacterString_PropertyType
     */
    public $rule;
    /**
     * The rationale
     * @var \StructType\CharacterString_PropertyType
     */
    public $rationale;
    /**
     * The source
     * @var \StructType\CI_ResponsibleParty_PropertyType
     */
    public $source;
    /**
     * Constructor method for MD_ExtendedElementInformation_Type
     * @uses MD_ExtendedElementInformation_Type::setName()
     * @uses MD_ExtendedElementInformation_Type::setShortName()
     * @uses MD_ExtendedElementInformation_Type::setDomainCode()
     * @uses MD_ExtendedElementInformation_Type::setDefinition()
     * @uses MD_ExtendedElementInformation_Type::setObligation()
     * @uses MD_ExtendedElementInformation_Type::setCondition()
     * @uses MD_ExtendedElementInformation_Type::setDataType()
     * @uses MD_ExtendedElementInformation_Type::setMaximumOccurrence()
     * @uses MD_ExtendedElementInformation_Type::setDomainValue()
     * @uses MD_ExtendedElementInformation_Type::setParentEntity()
     * @uses MD_ExtendedElementInformation_Type::setRule()
     * @uses MD_ExtendedElementInformation_Type::setRationale()
     * @uses MD_ExtendedElementInformation_Type::setSource()
     * @param \StructType\CharacterString_PropertyType $name
     * @param \StructType\CharacterString_PropertyType $shortName
     * @param \StructType\Integer_PropertyType $domainCode
     * @param \StructType\CharacterString_PropertyType $definition
     * @param \StructType\MD_ObligationCode_PropertyType $obligation
     * @param \StructType\CharacterString_PropertyType $condition
     * @param \StructType\MD_DatatypeCode_PropertyType $dataType
     * @param \StructType\CharacterString_PropertyType $maximumOccurrence
     * @param \StructType\CharacterString_PropertyType $domainValue
     * @param \StructType\CharacterString_PropertyType $parentEntity
     * @param \StructType\CharacterString_PropertyType $rule
     * @param \StructType\CharacterString_PropertyType $rationale
     * @param \StructType\CI_ResponsibleParty_PropertyType $source
     */
    public function __construct(\StructType\CharacterString_PropertyType $name = null, \StructType\CharacterString_PropertyType $shortName = null, \StructType\Integer_PropertyType $domainCode = null, \StructType\CharacterString_PropertyType $definition = null, \StructType\MD_ObligationCode_PropertyType $obligation = null, \StructType\CharacterString_PropertyType $condition = null, \StructType\MD_DatatypeCode_PropertyType $dataType = null, \StructType\CharacterString_PropertyType $maximumOccurrence = null, \StructType\CharacterString_PropertyType $domainValue = null, \StructType\CharacterString_PropertyType $parentEntity = null, \StructType\CharacterString_PropertyType $rule = null, \StructType\CharacterString_PropertyType $rationale = null, \StructType\CI_ResponsibleParty_PropertyType $source = null)
    {
        $this
            ->setName($name)
            ->setShortName($shortName)
            ->setDomainCode($domainCode)
            ->setDefinition($definition)
            ->setObligation($obligation)
            ->setCondition($condition)
            ->setDataType($dataType)
            ->setMaximumOccurrence($maximumOccurrence)
            ->setDomainValue($domainValue)
            ->setParentEntity($parentEntity)
            ->setRule($rule)
            ->setRationale($rationale)
            ->setSource($source);
    }
    /**
     * Get name value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param \StructType\CharacterString_PropertyType $name
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setName(\StructType\CharacterString_PropertyType $name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get shortName value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getShortName()
    {
        return $this->shortName;
    }
    /**
     * Set shortName value
     * @param \StructType\CharacterString_PropertyType $shortName
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setShortName(\StructType\CharacterString_PropertyType $shortName = null)
    {
        $this->shortName = $shortName;
        return $this;
    }
    /**
     * Get domainCode value
     * @return \StructType\Integer_PropertyType|null
     */
    public function getDomainCode()
    {
        return $this->domainCode;
    }
    /**
     * Set domainCode value
     * @param \StructType\Integer_PropertyType $domainCode
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setDomainCode(\StructType\Integer_PropertyType $domainCode = null)
    {
        $this->domainCode = $domainCode;
        return $this;
    }
    /**
     * Get definition value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDefinition()
    {
        return $this->definition;
    }
    /**
     * Set definition value
     * @param \StructType\CharacterString_PropertyType $definition
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setDefinition(\StructType\CharacterString_PropertyType $definition = null)
    {
        $this->definition = $definition;
        return $this;
    }
    /**
     * Get obligation value
     * @return \StructType\MD_ObligationCode_PropertyType|null
     */
    public function getObligation()
    {
        return $this->obligation;
    }
    /**
     * Set obligation value
     * @param \StructType\MD_ObligationCode_PropertyType $obligation
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setObligation(\StructType\MD_ObligationCode_PropertyType $obligation = null)
    {
        $this->obligation = $obligation;
        return $this;
    }
    /**
     * Get condition value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getCondition()
    {
        return $this->condition;
    }
    /**
     * Set condition value
     * @param \StructType\CharacterString_PropertyType $condition
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setCondition(\StructType\CharacterString_PropertyType $condition = null)
    {
        $this->condition = $condition;
        return $this;
    }
    /**
     * Get dataType value
     * @return \StructType\MD_DatatypeCode_PropertyType|null
     */
    public function getDataType()
    {
        return $this->dataType;
    }
    /**
     * Set dataType value
     * @param \StructType\MD_DatatypeCode_PropertyType $dataType
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setDataType(\StructType\MD_DatatypeCode_PropertyType $dataType = null)
    {
        $this->dataType = $dataType;
        return $this;
    }
    /**
     * Get maximumOccurrence value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getMaximumOccurrence()
    {
        return $this->maximumOccurrence;
    }
    /**
     * Set maximumOccurrence value
     * @param \StructType\CharacterString_PropertyType $maximumOccurrence
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setMaximumOccurrence(\StructType\CharacterString_PropertyType $maximumOccurrence = null)
    {
        $this->maximumOccurrence = $maximumOccurrence;
        return $this;
    }
    /**
     * Get domainValue value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDomainValue()
    {
        return $this->domainValue;
    }
    /**
     * Set domainValue value
     * @param \StructType\CharacterString_PropertyType $domainValue
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setDomainValue(\StructType\CharacterString_PropertyType $domainValue = null)
    {
        $this->domainValue = $domainValue;
        return $this;
    }
    /**
     * Get parentEntity value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getParentEntity()
    {
        return $this->parentEntity;
    }
    /**
     * Set parentEntity value
     * @param \StructType\CharacterString_PropertyType $parentEntity
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setParentEntity(\StructType\CharacterString_PropertyType $parentEntity = null)
    {
        $this->parentEntity = $parentEntity;
        return $this;
    }
    /**
     * Get rule value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getRule()
    {
        return $this->rule;
    }
    /**
     * Set rule value
     * @param \StructType\CharacterString_PropertyType $rule
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setRule(\StructType\CharacterString_PropertyType $rule = null)
    {
        $this->rule = $rule;
        return $this;
    }
    /**
     * Get rationale value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getRationale()
    {
        return $this->rationale;
    }
    /**
     * Set rationale value
     * @param \StructType\CharacterString_PropertyType $rationale
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setRationale(\StructType\CharacterString_PropertyType $rationale = null)
    {
        $this->rationale = $rationale;
        return $this;
    }
    /**
     * Get source value
     * @return \StructType\CI_ResponsibleParty_PropertyType|null
     */
    public function getSource()
    {
        return $this->source;
    }
    /**
     * Set source value
     * @param \StructType\CI_ResponsibleParty_PropertyType $source
     * @return \StructType\MD_ExtendedElementInformation_Type
     */
    public function setSource(\StructType\CI_ResponsibleParty_PropertyType $source = null)
    {
        $this->source = $source;
        return $this;
    }
}
