<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_Georectified_Type StructType
 * @subpackage Structs
 */
class MD_Georectified_Type extends AbstractStructBase
{
    /**
     * The checkPointAvailability
     * @var \StructType\Boolean_PropertyType
     */
    public $checkPointAvailability;
    /**
     * The checkPointDescription
     * @var \StructType\CharacterString_PropertyType
     */
    public $checkPointDescription;
    /**
     * The cornerPoints
     * @var \StructType\GM_Point_PropertyType
     */
    public $cornerPoints;
    /**
     * The centerPoint
     * @var \StructType\GM_Point_PropertyType
     */
    public $centerPoint;
    /**
     * The pointInPixel
     * @var \StructType\MD_PixelOrientationCode_PropertyType
     */
    public $pointInPixel;
    /**
     * The transformationDimensionDescription
     * @var \StructType\CharacterString_PropertyType
     */
    public $transformationDimensionDescription;
    /**
     * The transformationDimensionMapping
     * @var \StructType\CharacterString_PropertyType
     */
    public $transformationDimensionMapping;
    /**
     * Constructor method for MD_Georectified_Type
     * @uses MD_Georectified_Type::setCheckPointAvailability()
     * @uses MD_Georectified_Type::setCheckPointDescription()
     * @uses MD_Georectified_Type::setCornerPoints()
     * @uses MD_Georectified_Type::setCenterPoint()
     * @uses MD_Georectified_Type::setPointInPixel()
     * @uses MD_Georectified_Type::setTransformationDimensionDescription()
     * @uses MD_Georectified_Type::setTransformationDimensionMapping()
     * @param \StructType\Boolean_PropertyType $checkPointAvailability
     * @param \StructType\CharacterString_PropertyType $checkPointDescription
     * @param \StructType\GM_Point_PropertyType $cornerPoints
     * @param \StructType\GM_Point_PropertyType $centerPoint
     * @param \StructType\MD_PixelOrientationCode_PropertyType $pointInPixel
     * @param \StructType\CharacterString_PropertyType $transformationDimensionDescription
     * @param \StructType\CharacterString_PropertyType $transformationDimensionMapping
     */
    public function __construct(\StructType\Boolean_PropertyType $checkPointAvailability = null, \StructType\CharacterString_PropertyType $checkPointDescription = null, \StructType\GM_Point_PropertyType $cornerPoints = null, \StructType\GM_Point_PropertyType $centerPoint = null, \StructType\MD_PixelOrientationCode_PropertyType $pointInPixel = null, \StructType\CharacterString_PropertyType $transformationDimensionDescription = null, \StructType\CharacterString_PropertyType $transformationDimensionMapping = null)
    {
        $this
            ->setCheckPointAvailability($checkPointAvailability)
            ->setCheckPointDescription($checkPointDescription)
            ->setCornerPoints($cornerPoints)
            ->setCenterPoint($centerPoint)
            ->setPointInPixel($pointInPixel)
            ->setTransformationDimensionDescription($transformationDimensionDescription)
            ->setTransformationDimensionMapping($transformationDimensionMapping);
    }
    /**
     * Get checkPointAvailability value
     * @return \StructType\Boolean_PropertyType|null
     */
    public function getCheckPointAvailability()
    {
        return $this->checkPointAvailability;
    }
    /**
     * Set checkPointAvailability value
     * @param \StructType\Boolean_PropertyType $checkPointAvailability
     * @return \StructType\MD_Georectified_Type
     */
    public function setCheckPointAvailability(\StructType\Boolean_PropertyType $checkPointAvailability = null)
    {
        $this->checkPointAvailability = $checkPointAvailability;
        return $this;
    }
    /**
     * Get checkPointDescription value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getCheckPointDescription()
    {
        return $this->checkPointDescription;
    }
    /**
     * Set checkPointDescription value
     * @param \StructType\CharacterString_PropertyType $checkPointDescription
     * @return \StructType\MD_Georectified_Type
     */
    public function setCheckPointDescription(\StructType\CharacterString_PropertyType $checkPointDescription = null)
    {
        $this->checkPointDescription = $checkPointDescription;
        return $this;
    }
    /**
     * Get cornerPoints value
     * @return \StructType\GM_Point_PropertyType|null
     */
    public function getCornerPoints()
    {
        return $this->cornerPoints;
    }
    /**
     * Set cornerPoints value
     * @param \StructType\GM_Point_PropertyType $cornerPoints
     * @return \StructType\MD_Georectified_Type
     */
    public function setCornerPoints(\StructType\GM_Point_PropertyType $cornerPoints = null)
    {
        $this->cornerPoints = $cornerPoints;
        return $this;
    }
    /**
     * Get centerPoint value
     * @return \StructType\GM_Point_PropertyType|null
     */
    public function getCenterPoint()
    {
        return $this->centerPoint;
    }
    /**
     * Set centerPoint value
     * @param \StructType\GM_Point_PropertyType $centerPoint
     * @return \StructType\MD_Georectified_Type
     */
    public function setCenterPoint(\StructType\GM_Point_PropertyType $centerPoint = null)
    {
        $this->centerPoint = $centerPoint;
        return $this;
    }
    /**
     * Get pointInPixel value
     * @return \StructType\MD_PixelOrientationCode_PropertyType|null
     */
    public function getPointInPixel()
    {
        return $this->pointInPixel;
    }
    /**
     * Set pointInPixel value
     * @param \StructType\MD_PixelOrientationCode_PropertyType $pointInPixel
     * @return \StructType\MD_Georectified_Type
     */
    public function setPointInPixel(\StructType\MD_PixelOrientationCode_PropertyType $pointInPixel = null)
    {
        $this->pointInPixel = $pointInPixel;
        return $this;
    }
    /**
     * Get transformationDimensionDescription value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getTransformationDimensionDescription()
    {
        return $this->transformationDimensionDescription;
    }
    /**
     * Set transformationDimensionDescription value
     * @param \StructType\CharacterString_PropertyType $transformationDimensionDescription
     * @return \StructType\MD_Georectified_Type
     */
    public function setTransformationDimensionDescription(\StructType\CharacterString_PropertyType $transformationDimensionDescription = null)
    {
        $this->transformationDimensionDescription = $transformationDimensionDescription;
        return $this;
    }
    /**
     * Get transformationDimensionMapping value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getTransformationDimensionMapping()
    {
        return $this->transformationDimensionMapping;
    }
    /**
     * Set transformationDimensionMapping value
     * @param \StructType\CharacterString_PropertyType $transformationDimensionMapping
     * @return \StructType\MD_Georectified_Type
     */
    public function setTransformationDimensionMapping(\StructType\CharacterString_PropertyType $transformationDimensionMapping = null)
    {
        $this->transformationDimensionMapping = $transformationDimensionMapping;
        return $this;
    }
}
