<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_Georeferenceable_Type StructType
 * @subpackage Structs
 */
class MD_Georeferenceable_Type extends AbstractStructBase
{
    /**
     * The controlPointAvailability
     * @var \StructType\Boolean_PropertyType
     */
    public $controlPointAvailability;
    /**
     * The orientationParameterAvailability
     * @var \StructType\Boolean_PropertyType
     */
    public $orientationParameterAvailability;
    /**
     * The orientationParameterDescription
     * @var \StructType\CharacterString_PropertyType
     */
    public $orientationParameterDescription;
    /**
     * The georeferencedParameters
     * @var \StructType\Record_PropertyType
     */
    public $georeferencedParameters;
    /**
     * The parameterCitation
     * @var \StructType\CI_Citation_PropertyType
     */
    public $parameterCitation;
    /**
     * Constructor method for MD_Georeferenceable_Type
     * @uses MD_Georeferenceable_Type::setControlPointAvailability()
     * @uses MD_Georeferenceable_Type::setOrientationParameterAvailability()
     * @uses MD_Georeferenceable_Type::setOrientationParameterDescription()
     * @uses MD_Georeferenceable_Type::setGeoreferencedParameters()
     * @uses MD_Georeferenceable_Type::setParameterCitation()
     * @param \StructType\Boolean_PropertyType $controlPointAvailability
     * @param \StructType\Boolean_PropertyType $orientationParameterAvailability
     * @param \StructType\CharacterString_PropertyType $orientationParameterDescription
     * @param \StructType\Record_PropertyType $georeferencedParameters
     * @param \StructType\CI_Citation_PropertyType $parameterCitation
     */
    public function __construct(\StructType\Boolean_PropertyType $controlPointAvailability = null, \StructType\Boolean_PropertyType $orientationParameterAvailability = null, \StructType\CharacterString_PropertyType $orientationParameterDescription = null, \StructType\Record_PropertyType $georeferencedParameters = null, \StructType\CI_Citation_PropertyType $parameterCitation = null)
    {
        $this
            ->setControlPointAvailability($controlPointAvailability)
            ->setOrientationParameterAvailability($orientationParameterAvailability)
            ->setOrientationParameterDescription($orientationParameterDescription)
            ->setGeoreferencedParameters($georeferencedParameters)
            ->setParameterCitation($parameterCitation);
    }
    /**
     * Get controlPointAvailability value
     * @return \StructType\Boolean_PropertyType|null
     */
    public function getControlPointAvailability()
    {
        return $this->controlPointAvailability;
    }
    /**
     * Set controlPointAvailability value
     * @param \StructType\Boolean_PropertyType $controlPointAvailability
     * @return \StructType\MD_Georeferenceable_Type
     */
    public function setControlPointAvailability(\StructType\Boolean_PropertyType $controlPointAvailability = null)
    {
        $this->controlPointAvailability = $controlPointAvailability;
        return $this;
    }
    /**
     * Get orientationParameterAvailability value
     * @return \StructType\Boolean_PropertyType|null
     */
    public function getOrientationParameterAvailability()
    {
        return $this->orientationParameterAvailability;
    }
    /**
     * Set orientationParameterAvailability value
     * @param \StructType\Boolean_PropertyType $orientationParameterAvailability
     * @return \StructType\MD_Georeferenceable_Type
     */
    public function setOrientationParameterAvailability(\StructType\Boolean_PropertyType $orientationParameterAvailability = null)
    {
        $this->orientationParameterAvailability = $orientationParameterAvailability;
        return $this;
    }
    /**
     * Get orientationParameterDescription value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getOrientationParameterDescription()
    {
        return $this->orientationParameterDescription;
    }
    /**
     * Set orientationParameterDescription value
     * @param \StructType\CharacterString_PropertyType $orientationParameterDescription
     * @return \StructType\MD_Georeferenceable_Type
     */
    public function setOrientationParameterDescription(\StructType\CharacterString_PropertyType $orientationParameterDescription = null)
    {
        $this->orientationParameterDescription = $orientationParameterDescription;
        return $this;
    }
    /**
     * Get georeferencedParameters value
     * @return \StructType\Record_PropertyType|null
     */
    public function getGeoreferencedParameters()
    {
        return $this->georeferencedParameters;
    }
    /**
     * Set georeferencedParameters value
     * @param \StructType\Record_PropertyType $georeferencedParameters
     * @return \StructType\MD_Georeferenceable_Type
     */
    public function setGeoreferencedParameters(\StructType\Record_PropertyType $georeferencedParameters = null)
    {
        $this->georeferencedParameters = $georeferencedParameters;
        return $this;
    }
    /**
     * Get parameterCitation value
     * @return \StructType\CI_Citation_PropertyType|null
     */
    public function getParameterCitation()
    {
        return $this->parameterCitation;
    }
    /**
     * Set parameterCitation value
     * @param \StructType\CI_Citation_PropertyType $parameterCitation
     * @return \StructType\MD_Georeferenceable_Type
     */
    public function setParameterCitation(\StructType\CI_Citation_PropertyType $parameterCitation = null)
    {
        $this->parameterCitation = $parameterCitation;
        return $this;
    }
}
