<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_GridSpatialRepresentation_Type StructType
 * @subpackage Structs
 */
class MD_GridSpatialRepresentation_Type extends AbstractStructBase
{
    /**
     * The numberOfDimensions
     * @var \StructType\Integer_PropertyType
     */
    public $numberOfDimensions;
    /**
     * The axisDimensionProperties
     * @var \StructType\MD_Dimension_PropertyType
     */
    public $axisDimensionProperties;
    /**
     * The cellGeometry
     * @var \StructType\MD_CellGeometryCode_PropertyType
     */
    public $cellGeometry;
    /**
     * The transformationParameterAvailability
     * @var \StructType\Boolean_PropertyType
     */
    public $transformationParameterAvailability;
    /**
     * Constructor method for MD_GridSpatialRepresentation_Type
     * @uses MD_GridSpatialRepresentation_Type::setNumberOfDimensions()
     * @uses MD_GridSpatialRepresentation_Type::setAxisDimensionProperties()
     * @uses MD_GridSpatialRepresentation_Type::setCellGeometry()
     * @uses MD_GridSpatialRepresentation_Type::setTransformationParameterAvailability()
     * @param \StructType\Integer_PropertyType $numberOfDimensions
     * @param \StructType\MD_Dimension_PropertyType $axisDimensionProperties
     * @param \StructType\MD_CellGeometryCode_PropertyType $cellGeometry
     * @param \StructType\Boolean_PropertyType $transformationParameterAvailability
     */
    public function __construct(\StructType\Integer_PropertyType $numberOfDimensions = null, \StructType\MD_Dimension_PropertyType $axisDimensionProperties = null, \StructType\MD_CellGeometryCode_PropertyType $cellGeometry = null, \StructType\Boolean_PropertyType $transformationParameterAvailability = null)
    {
        $this
            ->setNumberOfDimensions($numberOfDimensions)
            ->setAxisDimensionProperties($axisDimensionProperties)
            ->setCellGeometry($cellGeometry)
            ->setTransformationParameterAvailability($transformationParameterAvailability);
    }
    /**
     * Get numberOfDimensions value
     * @return \StructType\Integer_PropertyType|null
     */
    public function getNumberOfDimensions()
    {
        return $this->numberOfDimensions;
    }
    /**
     * Set numberOfDimensions value
     * @param \StructType\Integer_PropertyType $numberOfDimensions
     * @return \StructType\MD_GridSpatialRepresentation_Type
     */
    public function setNumberOfDimensions(\StructType\Integer_PropertyType $numberOfDimensions = null)
    {
        $this->numberOfDimensions = $numberOfDimensions;
        return $this;
    }
    /**
     * Get axisDimensionProperties value
     * @return \StructType\MD_Dimension_PropertyType|null
     */
    public function getAxisDimensionProperties()
    {
        return $this->axisDimensionProperties;
    }
    /**
     * Set axisDimensionProperties value
     * @param \StructType\MD_Dimension_PropertyType $axisDimensionProperties
     * @return \StructType\MD_GridSpatialRepresentation_Type
     */
    public function setAxisDimensionProperties(\StructType\MD_Dimension_PropertyType $axisDimensionProperties = null)
    {
        $this->axisDimensionProperties = $axisDimensionProperties;
        return $this;
    }
    /**
     * Get cellGeometry value
     * @return \StructType\MD_CellGeometryCode_PropertyType|null
     */
    public function getCellGeometry()
    {
        return $this->cellGeometry;
    }
    /**
     * Set cellGeometry value
     * @param \StructType\MD_CellGeometryCode_PropertyType $cellGeometry
     * @return \StructType\MD_GridSpatialRepresentation_Type
     */
    public function setCellGeometry(\StructType\MD_CellGeometryCode_PropertyType $cellGeometry = null)
    {
        $this->cellGeometry = $cellGeometry;
        return $this;
    }
    /**
     * Get transformationParameterAvailability value
     * @return \StructType\Boolean_PropertyType|null
     */
    public function getTransformationParameterAvailability()
    {
        return $this->transformationParameterAvailability;
    }
    /**
     * Set transformationParameterAvailability value
     * @param \StructType\Boolean_PropertyType $transformationParameterAvailability
     * @return \StructType\MD_GridSpatialRepresentation_Type
     */
    public function setTransformationParameterAvailability(\StructType\Boolean_PropertyType $transformationParameterAvailability = null)
    {
        $this->transformationParameterAvailability = $transformationParameterAvailability;
        return $this;
    }
}
