<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_LegalConstraints_Type StructType
 * @subpackage Structs
 */
class MD_LegalConstraints_Type extends AbstractStructBase
{
    /**
     * The accessConstraints
     * @var \StructType\MD_RestrictionCode_PropertyType
     */
    public $accessConstraints;
    /**
     * The useConstraints
     * @var \StructType\MD_RestrictionCode_PropertyType
     */
    public $useConstraints;
    /**
     * The otherConstraints
     * @var \StructType\CharacterString_PropertyType
     */
    public $otherConstraints;
    /**
     * Constructor method for MD_LegalConstraints_Type
     * @uses MD_LegalConstraints_Type::setAccessConstraints()
     * @uses MD_LegalConstraints_Type::setUseConstraints()
     * @uses MD_LegalConstraints_Type::setOtherConstraints()
     * @param \StructType\MD_RestrictionCode_PropertyType $accessConstraints
     * @param \StructType\MD_RestrictionCode_PropertyType $useConstraints
     * @param \StructType\CharacterString_PropertyType $otherConstraints
     */
    public function __construct(\StructType\MD_RestrictionCode_PropertyType $accessConstraints = null, \StructType\MD_RestrictionCode_PropertyType $useConstraints = null, \StructType\CharacterString_PropertyType $otherConstraints = null)
    {
        $this
            ->setAccessConstraints($accessConstraints)
            ->setUseConstraints($useConstraints)
            ->setOtherConstraints($otherConstraints);
    }
    /**
     * Get accessConstraints value
     * @return \StructType\MD_RestrictionCode_PropertyType|null
     */
    public function getAccessConstraints()
    {
        return $this->accessConstraints;
    }
    /**
     * Set accessConstraints value
     * @param \StructType\MD_RestrictionCode_PropertyType $accessConstraints
     * @return \StructType\MD_LegalConstraints_Type
     */
    public function setAccessConstraints(\StructType\MD_RestrictionCode_PropertyType $accessConstraints = null)
    {
        $this->accessConstraints = $accessConstraints;
        return $this;
    }
    /**
     * Get useConstraints value
     * @return \StructType\MD_RestrictionCode_PropertyType|null
     */
    public function getUseConstraints()
    {
        return $this->useConstraints;
    }
    /**
     * Set useConstraints value
     * @param \StructType\MD_RestrictionCode_PropertyType $useConstraints
     * @return \StructType\MD_LegalConstraints_Type
     */
    public function setUseConstraints(\StructType\MD_RestrictionCode_PropertyType $useConstraints = null)
    {
        $this->useConstraints = $useConstraints;
        return $this;
    }
    /**
     * Get otherConstraints value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getOtherConstraints()
    {
        return $this->otherConstraints;
    }
    /**
     * Set otherConstraints value
     * @param \StructType\CharacterString_PropertyType $otherConstraints
     * @return \StructType\MD_LegalConstraints_Type
     */
    public function setOtherConstraints(\StructType\CharacterString_PropertyType $otherConstraints = null)
    {
        $this->otherConstraints = $otherConstraints;
        return $this;
    }
}
