<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_MaintenanceInformation_Type StructType
 * @subpackage Structs
 */
class MD_MaintenanceInformation_Type extends AbstractStructBase
{
    /**
     * The maintenanceAndUpdateFrequency
     * @var \StructType\MD_MaintenanceFrequencyCode_PropertyType
     */
    public $maintenanceAndUpdateFrequency;
    /**
     * The dateOfNextUpdate
     * @var \StructType\Date_PropertyType
     */
    public $dateOfNextUpdate;
    /**
     * The userDefinedMaintenanceFrequency
     * @var \StructType\TM_PeriodDuration_PropertyType
     */
    public $userDefinedMaintenanceFrequency;
    /**
     * The updateScope
     * @var \StructType\MD_ScopeCode_PropertyType
     */
    public $updateScope;
    /**
     * The updateScopeDescription
     * @var \StructType\MD_ScopeDescription_PropertyType
     */
    public $updateScopeDescription;
    /**
     * The maintenanceNote
     * @var \StructType\CharacterString_PropertyType
     */
    public $maintenanceNote;
    /**
     * The contact
     * @var \StructType\CI_ResponsibleParty_PropertyType
     */
    public $contact;
    /**
     * Constructor method for MD_MaintenanceInformation_Type
     * @uses MD_MaintenanceInformation_Type::setMaintenanceAndUpdateFrequency()
     * @uses MD_MaintenanceInformation_Type::setDateOfNextUpdate()
     * @uses MD_MaintenanceInformation_Type::setUserDefinedMaintenanceFrequency()
     * @uses MD_MaintenanceInformation_Type::setUpdateScope()
     * @uses MD_MaintenanceInformation_Type::setUpdateScopeDescription()
     * @uses MD_MaintenanceInformation_Type::setMaintenanceNote()
     * @uses MD_MaintenanceInformation_Type::setContact()
     * @param \StructType\MD_MaintenanceFrequencyCode_PropertyType $maintenanceAndUpdateFrequency
     * @param \StructType\Date_PropertyType $dateOfNextUpdate
     * @param \StructType\TM_PeriodDuration_PropertyType $userDefinedMaintenanceFrequency
     * @param \StructType\MD_ScopeCode_PropertyType $updateScope
     * @param \StructType\MD_ScopeDescription_PropertyType $updateScopeDescription
     * @param \StructType\CharacterString_PropertyType $maintenanceNote
     * @param \StructType\CI_ResponsibleParty_PropertyType $contact
     */
    public function __construct(\StructType\MD_MaintenanceFrequencyCode_PropertyType $maintenanceAndUpdateFrequency = null, \StructType\Date_PropertyType $dateOfNextUpdate = null, \StructType\TM_PeriodDuration_PropertyType $userDefinedMaintenanceFrequency = null, \StructType\MD_ScopeCode_PropertyType $updateScope = null, \StructType\MD_ScopeDescription_PropertyType $updateScopeDescription = null, \StructType\CharacterString_PropertyType $maintenanceNote = null, \StructType\CI_ResponsibleParty_PropertyType $contact = null)
    {
        $this
            ->setMaintenanceAndUpdateFrequency($maintenanceAndUpdateFrequency)
            ->setDateOfNextUpdate($dateOfNextUpdate)
            ->setUserDefinedMaintenanceFrequency($userDefinedMaintenanceFrequency)
            ->setUpdateScope($updateScope)
            ->setUpdateScopeDescription($updateScopeDescription)
            ->setMaintenanceNote($maintenanceNote)
            ->setContact($contact);
    }
    /**
     * Get maintenanceAndUpdateFrequency value
     * @return \StructType\MD_MaintenanceFrequencyCode_PropertyType|null
     */
    public function getMaintenanceAndUpdateFrequency()
    {
        return $this->maintenanceAndUpdateFrequency;
    }
    /**
     * Set maintenanceAndUpdateFrequency value
     * @param \StructType\MD_MaintenanceFrequencyCode_PropertyType $maintenanceAndUpdateFrequency
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setMaintenanceAndUpdateFrequency(\StructType\MD_MaintenanceFrequencyCode_PropertyType $maintenanceAndUpdateFrequency = null)
    {
        $this->maintenanceAndUpdateFrequency = $maintenanceAndUpdateFrequency;
        return $this;
    }
    /**
     * Get dateOfNextUpdate value
     * @return \StructType\Date_PropertyType|null
     */
    public function getDateOfNextUpdate()
    {
        return $this->dateOfNextUpdate;
    }
    /**
     * Set dateOfNextUpdate value
     * @param \StructType\Date_PropertyType $dateOfNextUpdate
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setDateOfNextUpdate(\StructType\Date_PropertyType $dateOfNextUpdate = null)
    {
        $this->dateOfNextUpdate = $dateOfNextUpdate;
        return $this;
    }
    /**
     * Get userDefinedMaintenanceFrequency value
     * @return \StructType\TM_PeriodDuration_PropertyType|null
     */
    public function getUserDefinedMaintenanceFrequency()
    {
        return $this->userDefinedMaintenanceFrequency;
    }
    /**
     * Set userDefinedMaintenanceFrequency value
     * @param \StructType\TM_PeriodDuration_PropertyType $userDefinedMaintenanceFrequency
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setUserDefinedMaintenanceFrequency(\StructType\TM_PeriodDuration_PropertyType $userDefinedMaintenanceFrequency = null)
    {
        $this->userDefinedMaintenanceFrequency = $userDefinedMaintenanceFrequency;
        return $this;
    }
    /**
     * Get updateScope value
     * @return \StructType\MD_ScopeCode_PropertyType|null
     */
    public function getUpdateScope()
    {
        return $this->updateScope;
    }
    /**
     * Set updateScope value
     * @param \StructType\MD_ScopeCode_PropertyType $updateScope
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setUpdateScope(\StructType\MD_ScopeCode_PropertyType $updateScope = null)
    {
        $this->updateScope = $updateScope;
        return $this;
    }
    /**
     * Get updateScopeDescription value
     * @return \StructType\MD_ScopeDescription_PropertyType|null
     */
    public function getUpdateScopeDescription()
    {
        return $this->updateScopeDescription;
    }
    /**
     * Set updateScopeDescription value
     * @param \StructType\MD_ScopeDescription_PropertyType $updateScopeDescription
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setUpdateScopeDescription(\StructType\MD_ScopeDescription_PropertyType $updateScopeDescription = null)
    {
        $this->updateScopeDescription = $updateScopeDescription;
        return $this;
    }
    /**
     * Get maintenanceNote value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getMaintenanceNote()
    {
        return $this->maintenanceNote;
    }
    /**
     * Set maintenanceNote value
     * @param \StructType\CharacterString_PropertyType $maintenanceNote
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setMaintenanceNote(\StructType\CharacterString_PropertyType $maintenanceNote = null)
    {
        $this->maintenanceNote = $maintenanceNote;
        return $this;
    }
    /**
     * Get contact value
     * @return \StructType\CI_ResponsibleParty_PropertyType|null
     */
    public function getContact()
    {
        return $this->contact;
    }
    /**
     * Set contact value
     * @param \StructType\CI_ResponsibleParty_PropertyType $contact
     * @return \StructType\MD_MaintenanceInformation_Type
     */
    public function setContact(\StructType\CI_ResponsibleParty_PropertyType $contact = null)
    {
        $this->contact = $contact;
        return $this;
    }
}
