<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_ScopeDescription_Type StructType
 * @subpackage Structs
 */
class MD_ScopeDescription_Type extends AbstractStructBase
{
    /**
     * The attributes
     * @var \StructType\ObjectReference_PropertyType
     */
    public $attributes;
    /**
     * The features
     * @var \StructType\ObjectReference_PropertyType
     */
    public $features;
    /**
     * The featureInstances
     * @var \StructType\ObjectReference_PropertyType
     */
    public $featureInstances;
    /**
     * The attributeInstances
     * @var \StructType\ObjectReference_PropertyType
     */
    public $attributeInstances;
    /**
     * The dataset
     * @var \StructType\CharacterString_PropertyType
     */
    public $dataset;
    /**
     * The other
     * @var \StructType\CharacterString_PropertyType
     */
    public $other;
    /**
     * Constructor method for MD_ScopeDescription_Type
     * @uses MD_ScopeDescription_Type::setAttributes()
     * @uses MD_ScopeDescription_Type::setFeatures()
     * @uses MD_ScopeDescription_Type::setFeatureInstances()
     * @uses MD_ScopeDescription_Type::setAttributeInstances()
     * @uses MD_ScopeDescription_Type::setDataset()
     * @uses MD_ScopeDescription_Type::setOther()
     * @param \StructType\ObjectReference_PropertyType $attributes
     * @param \StructType\ObjectReference_PropertyType $features
     * @param \StructType\ObjectReference_PropertyType $featureInstances
     * @param \StructType\ObjectReference_PropertyType $attributeInstances
     * @param \StructType\CharacterString_PropertyType $dataset
     * @param \StructType\CharacterString_PropertyType $other
     */
    public function __construct(\StructType\ObjectReference_PropertyType $attributes = null, \StructType\ObjectReference_PropertyType $features = null, \StructType\ObjectReference_PropertyType $featureInstances = null, \StructType\ObjectReference_PropertyType $attributeInstances = null, \StructType\CharacterString_PropertyType $dataset = null, \StructType\CharacterString_PropertyType $other = null)
    {
        $this
            ->setAttributes($attributes)
            ->setFeatures($features)
            ->setFeatureInstances($featureInstances)
            ->setAttributeInstances($attributeInstances)
            ->setDataset($dataset)
            ->setOther($other);
    }
    /**
     * Get attributes value
     * @return \StructType\ObjectReference_PropertyType|null
     */
    public function getAttributes()
    {
        return $this->attributes;
    }
    /**
     * Set attributes value
     * @param \StructType\ObjectReference_PropertyType $attributes
     * @return \StructType\MD_ScopeDescription_Type
     */
    public function setAttributes(\StructType\ObjectReference_PropertyType $attributes = null)
    {
        $this->attributes = $attributes;
        return $this;
    }
    /**
     * Get features value
     * @return \StructType\ObjectReference_PropertyType|null
     */
    public function getFeatures()
    {
        return $this->features;
    }
    /**
     * Set features value
     * @param \StructType\ObjectReference_PropertyType $features
     * @return \StructType\MD_ScopeDescription_Type
     */
    public function setFeatures(\StructType\ObjectReference_PropertyType $features = null)
    {
        $this->features = $features;
        return $this;
    }
    /**
     * Get featureInstances value
     * @return \StructType\ObjectReference_PropertyType|null
     */
    public function getFeatureInstances()
    {
        return $this->featureInstances;
    }
    /**
     * Set featureInstances value
     * @param \StructType\ObjectReference_PropertyType $featureInstances
     * @return \StructType\MD_ScopeDescription_Type
     */
    public function setFeatureInstances(\StructType\ObjectReference_PropertyType $featureInstances = null)
    {
        $this->featureInstances = $featureInstances;
        return $this;
    }
    /**
     * Get attributeInstances value
     * @return \StructType\ObjectReference_PropertyType|null
     */
    public function getAttributeInstances()
    {
        return $this->attributeInstances;
    }
    /**
     * Set attributeInstances value
     * @param \StructType\ObjectReference_PropertyType $attributeInstances
     * @return \StructType\MD_ScopeDescription_Type
     */
    public function setAttributeInstances(\StructType\ObjectReference_PropertyType $attributeInstances = null)
    {
        $this->attributeInstances = $attributeInstances;
        return $this;
    }
    /**
     * Get dataset value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDataset()
    {
        return $this->dataset;
    }
    /**
     * Set dataset value
     * @param \StructType\CharacterString_PropertyType $dataset
     * @return \StructType\MD_ScopeDescription_Type
     */
    public function setDataset(\StructType\CharacterString_PropertyType $dataset = null)
    {
        $this->dataset = $dataset;
        return $this;
    }
    /**
     * Get other value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getOther()
    {
        return $this->other;
    }
    /**
     * Set other value
     * @param \StructType\CharacterString_PropertyType $other
     * @return \StructType\MD_ScopeDescription_Type
     */
    public function setOther(\StructType\CharacterString_PropertyType $other = null)
    {
        $this->other = $other;
        return $this;
    }
}
