<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_SecurityConstraints_Type StructType
 * @subpackage Structs
 */
class MD_SecurityConstraints_Type extends AbstractStructBase
{
    /**
     * The classification
     * @var \StructType\MD_ClassificationCode_PropertyType
     */
    public $classification;
    /**
     * The userNote
     * @var \StructType\CharacterString_PropertyType
     */
    public $userNote;
    /**
     * The classificationSystem
     * @var \StructType\CharacterString_PropertyType
     */
    public $classificationSystem;
    /**
     * The handlingDescription
     * @var \StructType\CharacterString_PropertyType
     */
    public $handlingDescription;
    /**
     * Constructor method for MD_SecurityConstraints_Type
     * @uses MD_SecurityConstraints_Type::setClassification()
     * @uses MD_SecurityConstraints_Type::setUserNote()
     * @uses MD_SecurityConstraints_Type::setClassificationSystem()
     * @uses MD_SecurityConstraints_Type::setHandlingDescription()
     * @param \StructType\MD_ClassificationCode_PropertyType $classification
     * @param \StructType\CharacterString_PropertyType $userNote
     * @param \StructType\CharacterString_PropertyType $classificationSystem
     * @param \StructType\CharacterString_PropertyType $handlingDescription
     */
    public function __construct(\StructType\MD_ClassificationCode_PropertyType $classification = null, \StructType\CharacterString_PropertyType $userNote = null, \StructType\CharacterString_PropertyType $classificationSystem = null, \StructType\CharacterString_PropertyType $handlingDescription = null)
    {
        $this
            ->setClassification($classification)
            ->setUserNote($userNote)
            ->setClassificationSystem($classificationSystem)
            ->setHandlingDescription($handlingDescription);
    }
    /**
     * Get classification value
     * @return \StructType\MD_ClassificationCode_PropertyType|null
     */
    public function getClassification()
    {
        return $this->classification;
    }
    /**
     * Set classification value
     * @param \StructType\MD_ClassificationCode_PropertyType $classification
     * @return \StructType\MD_SecurityConstraints_Type
     */
    public function setClassification(\StructType\MD_ClassificationCode_PropertyType $classification = null)
    {
        $this->classification = $classification;
        return $this;
    }
    /**
     * Get userNote value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getUserNote()
    {
        return $this->userNote;
    }
    /**
     * Set userNote value
     * @param \StructType\CharacterString_PropertyType $userNote
     * @return \StructType\MD_SecurityConstraints_Type
     */
    public function setUserNote(\StructType\CharacterString_PropertyType $userNote = null)
    {
        $this->userNote = $userNote;
        return $this;
    }
    /**
     * Get classificationSystem value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getClassificationSystem()
    {
        return $this->classificationSystem;
    }
    /**
     * Set classificationSystem value
     * @param \StructType\CharacterString_PropertyType $classificationSystem
     * @return \StructType\MD_SecurityConstraints_Type
     */
    public function setClassificationSystem(\StructType\CharacterString_PropertyType $classificationSystem = null)
    {
        $this->classificationSystem = $classificationSystem;
        return $this;
    }
    /**
     * Get handlingDescription value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getHandlingDescription()
    {
        return $this->handlingDescription;
    }
    /**
     * Set handlingDescription value
     * @param \StructType\CharacterString_PropertyType $handlingDescription
     * @return \StructType\MD_SecurityConstraints_Type
     */
    public function setHandlingDescription(\StructType\CharacterString_PropertyType $handlingDescription = null)
    {
        $this->handlingDescription = $handlingDescription;
        return $this;
    }
}
