<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_StandardOrderProcess_Type StructType
 * @subpackage Structs
 */
class MD_StandardOrderProcess_Type extends AbstractStructBase
{
    /**
     * The fees
     * @var \StructType\CharacterString_PropertyType
     */
    public $fees;
    /**
     * The plannedAvailableDateTime
     * @var \StructType\DateTime_PropertyType
     */
    public $plannedAvailableDateTime;
    /**
     * The orderingInstructions
     * @var \StructType\CharacterString_PropertyType
     */
    public $orderingInstructions;
    /**
     * The turnaround
     * @var \StructType\CharacterString_PropertyType
     */
    public $turnaround;
    /**
     * Constructor method for MD_StandardOrderProcess_Type
     * @uses MD_StandardOrderProcess_Type::setFees()
     * @uses MD_StandardOrderProcess_Type::setPlannedAvailableDateTime()
     * @uses MD_StandardOrderProcess_Type::setOrderingInstructions()
     * @uses MD_StandardOrderProcess_Type::setTurnaround()
     * @param \StructType\CharacterString_PropertyType $fees
     * @param \StructType\DateTime_PropertyType $plannedAvailableDateTime
     * @param \StructType\CharacterString_PropertyType $orderingInstructions
     * @param \StructType\CharacterString_PropertyType $turnaround
     */
    public function __construct(\StructType\CharacterString_PropertyType $fees = null, \StructType\DateTime_PropertyType $plannedAvailableDateTime = null, \StructType\CharacterString_PropertyType $orderingInstructions = null, \StructType\CharacterString_PropertyType $turnaround = null)
    {
        $this
            ->setFees($fees)
            ->setPlannedAvailableDateTime($plannedAvailableDateTime)
            ->setOrderingInstructions($orderingInstructions)
            ->setTurnaround($turnaround);
    }
    /**
     * Get fees value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getFees()
    {
        return $this->fees;
    }
    /**
     * Set fees value
     * @param \StructType\CharacterString_PropertyType $fees
     * @return \StructType\MD_StandardOrderProcess_Type
     */
    public function setFees(\StructType\CharacterString_PropertyType $fees = null)
    {
        $this->fees = $fees;
        return $this;
    }
    /**
     * Get plannedAvailableDateTime value
     * @return \StructType\DateTime_PropertyType|null
     */
    public function getPlannedAvailableDateTime()
    {
        return $this->plannedAvailableDateTime;
    }
    /**
     * Set plannedAvailableDateTime value
     * @param \StructType\DateTime_PropertyType $plannedAvailableDateTime
     * @return \StructType\MD_StandardOrderProcess_Type
     */
    public function setPlannedAvailableDateTime(\StructType\DateTime_PropertyType $plannedAvailableDateTime = null)
    {
        $this->plannedAvailableDateTime = $plannedAvailableDateTime;
        return $this;
    }
    /**
     * Get orderingInstructions value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getOrderingInstructions()
    {
        return $this->orderingInstructions;
    }
    /**
     * Set orderingInstructions value
     * @param \StructType\CharacterString_PropertyType $orderingInstructions
     * @return \StructType\MD_StandardOrderProcess_Type
     */
    public function setOrderingInstructions(\StructType\CharacterString_PropertyType $orderingInstructions = null)
    {
        $this->orderingInstructions = $orderingInstructions;
        return $this;
    }
    /**
     * Get turnaround value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getTurnaround()
    {
        return $this->turnaround;
    }
    /**
     * Set turnaround value
     * @param \StructType\CharacterString_PropertyType $turnaround
     * @return \StructType\MD_StandardOrderProcess_Type
     */
    public function setTurnaround(\StructType\CharacterString_PropertyType $turnaround = null)
    {
        $this->turnaround = $turnaround;
        return $this;
    }
}
