<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MD_Usage_Type StructType
 * @subpackage Structs
 */
class MD_Usage_Type extends AbstractStructBase
{
    /**
     * The specificUsage
     * @var \StructType\CharacterString_PropertyType
     */
    public $specificUsage;
    /**
     * The usageDateTime
     * @var \StructType\DateTime_PropertyType
     */
    public $usageDateTime;
    /**
     * The userDeterminedLimitations
     * @var \StructType\CharacterString_PropertyType
     */
    public $userDeterminedLimitations;
    /**
     * The userContactInfo
     * @var \StructType\CI_ResponsibleParty_PropertyType
     */
    public $userContactInfo;
    /**
     * Constructor method for MD_Usage_Type
     * @uses MD_Usage_Type::setSpecificUsage()
     * @uses MD_Usage_Type::setUsageDateTime()
     * @uses MD_Usage_Type::setUserDeterminedLimitations()
     * @uses MD_Usage_Type::setUserContactInfo()
     * @param \StructType\CharacterString_PropertyType $specificUsage
     * @param \StructType\DateTime_PropertyType $usageDateTime
     * @param \StructType\CharacterString_PropertyType $userDeterminedLimitations
     * @param \StructType\CI_ResponsibleParty_PropertyType $userContactInfo
     */
    public function __construct(\StructType\CharacterString_PropertyType $specificUsage = null, \StructType\DateTime_PropertyType $usageDateTime = null, \StructType\CharacterString_PropertyType $userDeterminedLimitations = null, \StructType\CI_ResponsibleParty_PropertyType $userContactInfo = null)
    {
        $this
            ->setSpecificUsage($specificUsage)
            ->setUsageDateTime($usageDateTime)
            ->setUserDeterminedLimitations($userDeterminedLimitations)
            ->setUserContactInfo($userContactInfo);
    }
    /**
     * Get specificUsage value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getSpecificUsage()
    {
        return $this->specificUsage;
    }
    /**
     * Set specificUsage value
     * @param \StructType\CharacterString_PropertyType $specificUsage
     * @return \StructType\MD_Usage_Type
     */
    public function setSpecificUsage(\StructType\CharacterString_PropertyType $specificUsage = null)
    {
        $this->specificUsage = $specificUsage;
        return $this;
    }
    /**
     * Get usageDateTime value
     * @return \StructType\DateTime_PropertyType|null
     */
    public function getUsageDateTime()
    {
        return $this->usageDateTime;
    }
    /**
     * Set usageDateTime value
     * @param \StructType\DateTime_PropertyType $usageDateTime
     * @return \StructType\MD_Usage_Type
     */
    public function setUsageDateTime(\StructType\DateTime_PropertyType $usageDateTime = null)
    {
        $this->usageDateTime = $usageDateTime;
        return $this;
    }
    /**
     * Get userDeterminedLimitations value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getUserDeterminedLimitations()
    {
        return $this->userDeterminedLimitations;
    }
    /**
     * Set userDeterminedLimitations value
     * @param \StructType\CharacterString_PropertyType $userDeterminedLimitations
     * @return \StructType\MD_Usage_Type
     */
    public function setUserDeterminedLimitations(\StructType\CharacterString_PropertyType $userDeterminedLimitations = null)
    {
        $this->userDeterminedLimitations = $userDeterminedLimitations;
        return $this;
    }
    /**
     * Get userContactInfo value
     * @return \StructType\CI_ResponsibleParty_PropertyType|null
     */
    public function getUserContactInfo()
    {
        return $this->userContactInfo;
    }
    /**
     * Set userContactInfo value
     * @param \StructType\CI_ResponsibleParty_PropertyType $userContactInfo
     * @return \StructType\MD_Usage_Type
     */
    public function setUserContactInfo(\StructType\CI_ResponsibleParty_PropertyType $userContactInfo = null)
    {
        $this->userContactInfo = $userContactInfo;
        return $this;
    }
}
