<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultiGeometryPropertyType StructType
 * @subpackage Structs
 */
class MultiGeometryPropertyType extends AbstractStructBase
{
    /**
     * The AbstractGeometricAggregate
     * @var \StructType\AbstractGeometricAggregateType
     */
    public $AbstractGeometricAggregate;
    /**
     * The nilReason
     * @var string
     */
    public $nilReason;
    /**
     * The remoteSchema
     * @var string
     */
    public $remoteSchema;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The href
     * @var string
     */
    public $href;
    /**
     * The role
     * @var string
     */
    public $role;
    /**
     * The arcrole
     * @var string
     */
    public $arcrole;
    /**
     * The title
     * @var string
     */
    public $title;
    /**
     * The show
     * @var string
     */
    public $show;
    /**
     * The actuate
     * @var string
     */
    public $actuate;
    /**
     * The owns
     * @var bool
     */
    public $owns;
    /**
     * Constructor method for MultiGeometryPropertyType
     * @uses MultiGeometryPropertyType::setAbstractGeometricAggregate()
     * @uses MultiGeometryPropertyType::setNilReason()
     * @uses MultiGeometryPropertyType::setRemoteSchema()
     * @uses MultiGeometryPropertyType::setType()
     * @uses MultiGeometryPropertyType::setHref()
     * @uses MultiGeometryPropertyType::setRole()
     * @uses MultiGeometryPropertyType::setArcrole()
     * @uses MultiGeometryPropertyType::setTitle()
     * @uses MultiGeometryPropertyType::setShow()
     * @uses MultiGeometryPropertyType::setActuate()
     * @uses MultiGeometryPropertyType::setOwns()
     * @param \StructType\AbstractGeometricAggregateType $abstractGeometricAggregate
     * @param string $nilReason
     * @param string $remoteSchema
     * @param string $type
     * @param string $href
     * @param string $role
     * @param string $arcrole
     * @param string $title
     * @param string $show
     * @param string $actuate
     * @param bool $owns
     */
    public function __construct(\StructType\AbstractGeometricAggregateType $abstractGeometricAggregate = null, $nilReason = null, $remoteSchema = null, $type = null, $href = null, $role = null, $arcrole = null, $title = null, $show = null, $actuate = null, $owns = null)
    {
        $this
            ->setAbstractGeometricAggregate($abstractGeometricAggregate)
            ->setNilReason($nilReason)
            ->setRemoteSchema($remoteSchema)
            ->setType($type)
            ->setHref($href)
            ->setRole($role)
            ->setArcrole($arcrole)
            ->setTitle($title)
            ->setShow($show)
            ->setActuate($actuate)
            ->setOwns($owns);
    }
    /**
     * Get AbstractGeometricAggregate value
     * @return \StructType\AbstractGeometricAggregateType|null
     */
    public function getAbstractGeometricAggregate()
    {
        return $this->AbstractGeometricAggregate;
    }
    /**
     * Set AbstractGeometricAggregate value
     * @param \StructType\AbstractGeometricAggregateType $abstractGeometricAggregate
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setAbstractGeometricAggregate(\StructType\AbstractGeometricAggregateType $abstractGeometricAggregate = null)
    {
        $this->AbstractGeometricAggregate = $abstractGeometricAggregate;
        return $this;
    }
    /**
     * Get nilReason value
     * @return string|null
     */
    public function getNilReason()
    {
        return $this->nilReason;
    }
    /**
     * Set nilReason value
     * @param string $nilReason
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setNilReason($nilReason = null)
    {
        // validation for constraint: string
        if (!is_null($nilReason) && !is_string($nilReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nilReason, true), gettype($nilReason)), __LINE__);
        }
        $this->nilReason = $nilReason;
        return $this;
    }
    /**
     * Get remoteSchema value
     * @return string|null
     */
    public function getRemoteSchema()
    {
        return $this->remoteSchema;
    }
    /**
     * Set remoteSchema value
     * @param string $remoteSchema
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setRemoteSchema($remoteSchema = null)
    {
        // validation for constraint: string
        if (!is_null($remoteSchema) && !is_string($remoteSchema)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remoteSchema, true), gettype($remoteSchema)), __LINE__);
        }
        $this->remoteSchema = $remoteSchema;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get href value
     * @return string|null
     */
    public function getHref()
    {
        return $this->href;
    }
    /**
     * Set href value
     * @param string $href
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setHref($href = null)
    {
        // validation for constraint: string
        if (!is_null($href) && !is_string($href)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($href, true), gettype($href)), __LINE__);
        }
        $this->href = $href;
        return $this;
    }
    /**
     * Get role value
     * @return string|null
     */
    public function getRole()
    {
        return $this->role;
    }
    /**
     * Set role value
     * @param string $role
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setRole($role = null)
    {
        // validation for constraint: string
        if (!is_null($role) && !is_string($role)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($role, true), gettype($role)), __LINE__);
        }
        $this->role = $role;
        return $this;
    }
    /**
     * Get arcrole value
     * @return string|null
     */
    public function getArcrole()
    {
        return $this->arcrole;
    }
    /**
     * Set arcrole value
     * @param string $arcrole
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setArcrole($arcrole = null)
    {
        // validation for constraint: string
        if (!is_null($arcrole) && !is_string($arcrole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arcrole, true), gettype($arcrole)), __LINE__);
        }
        $this->arcrole = $arcrole;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Get show value
     * @return string|null
     */
    public function getShow()
    {
        return $this->show;
    }
    /**
     * Set show value
     * @param string $show
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setShow($show = null)
    {
        // validation for constraint: string
        if (!is_null($show) && !is_string($show)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($show, true), gettype($show)), __LINE__);
        }
        $this->show = $show;
        return $this;
    }
    /**
     * Get actuate value
     * @return string|null
     */
    public function getActuate()
    {
        return $this->actuate;
    }
    /**
     * Set actuate value
     * @param string $actuate
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setActuate($actuate = null)
    {
        // validation for constraint: string
        if (!is_null($actuate) && !is_string($actuate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actuate, true), gettype($actuate)), __LINE__);
        }
        $this->actuate = $actuate;
        return $this;
    }
    /**
     * Get owns value
     * @return bool|null
     */
    public function getOwns()
    {
        return $this->owns;
    }
    /**
     * Set owns value
     * @param bool $owns
     * @return \StructType\MultiGeometryPropertyType
     */
    public function setOwns($owns = null)
    {
        // validation for constraint: boolean
        if (!is_null($owns) && !is_bool($owns)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($owns, true), gettype($owns)), __LINE__);
        }
        $this->owns = $owns;
        return $this;
    }
}
