<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObservationType StructType
 * @subpackage Structs
 */
class ObservationType extends AbstractStructBase
{
    /**
     * The validTime
     * @var \StructType\TimePrimitivePropertyType
     */
    public $validTime;
    /**
     * The using
     * @var \StructType\ProcedurePropertyType
     */
    public $using;
    /**
     * The target
     * @var \StructType\TargetPropertyType
     */
    public $target;
    /**
     * The resultOf
     * @var \StructType\ResultType
     */
    public $resultOf;
    /**
     * Constructor method for ObservationType
     * @uses ObservationType::setValidTime()
     * @uses ObservationType::setUsing()
     * @uses ObservationType::setTarget()
     * @uses ObservationType::setResultOf()
     * @param \StructType\TimePrimitivePropertyType $validTime
     * @param \StructType\ProcedurePropertyType $using
     * @param \StructType\TargetPropertyType $target
     * @param \StructType\ResultType $resultOf
     */
    public function __construct(\StructType\TimePrimitivePropertyType $validTime = null, \StructType\ProcedurePropertyType $using = null, \StructType\TargetPropertyType $target = null, \StructType\ResultType $resultOf = null)
    {
        $this
            ->setValidTime($validTime)
            ->setUsing($using)
            ->setTarget($target)
            ->setResultOf($resultOf);
    }
    /**
     * Get validTime value
     * @return \StructType\TimePrimitivePropertyType|null
     */
    public function getValidTime()
    {
        return $this->validTime;
    }
    /**
     * Set validTime value
     * @param \StructType\TimePrimitivePropertyType $validTime
     * @return \StructType\ObservationType
     */
    public function setValidTime(\StructType\TimePrimitivePropertyType $validTime = null)
    {
        $this->validTime = $validTime;
        return $this;
    }
    /**
     * Get using value
     * @return \StructType\ProcedurePropertyType|null
     */
    public function getUsing()
    {
        return $this->using;
    }
    /**
     * Set using value
     * @param \StructType\ProcedurePropertyType $using
     * @return \StructType\ObservationType
     */
    public function setUsing(\StructType\ProcedurePropertyType $using = null)
    {
        $this->using = $using;
        return $this;
    }
    /**
     * Get target value
     * @return \StructType\TargetPropertyType|null
     */
    public function getTarget()
    {
        return $this->target;
    }
    /**
     * Set target value
     * @param \StructType\TargetPropertyType $target
     * @return \StructType\ObservationType
     */
    public function setTarget(\StructType\TargetPropertyType $target = null)
    {
        $this->target = $target;
        return $this;
    }
    /**
     * Get resultOf value
     * @return \StructType\ResultType|null
     */
    public function getResultOf()
    {
        return $this->resultOf;
    }
    /**
     * Set resultOf value
     * @param \StructType\ResultType $resultOf
     * @return \StructType\ObservationType
     */
    public function setResultOf(\StructType\ResultType $resultOf = null)
    {
        $this->resultOf = $resultOf;
        return $this;
    }
}
