<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PT_LocaleContainer_Type StructType
 * @subpackage Structs
 */
class PT_LocaleContainer_Type extends AbstractStructBase
{
    /**
     * The description
     * @var \StructType\CharacterString_PropertyType
     */
    public $description;
    /**
     * The locale
     * @var \StructType\PT_Locale_PropertyType
     */
    public $locale;
    /**
     * The date
     * @var \StructType\CI_Date_PropertyType
     */
    public $date;
    /**
     * The responsibleParty
     * @var \StructType\CI_ResponsibleParty_PropertyType
     */
    public $responsibleParty;
    /**
     * The localisedString
     * @var \StructType\LocalisedCharacterString_PropertyType
     */
    public $localisedString;
    /**
     * Constructor method for PT_LocaleContainer_Type
     * @uses PT_LocaleContainer_Type::setDescription()
     * @uses PT_LocaleContainer_Type::setLocale()
     * @uses PT_LocaleContainer_Type::setDate()
     * @uses PT_LocaleContainer_Type::setResponsibleParty()
     * @uses PT_LocaleContainer_Type::setLocalisedString()
     * @param \StructType\CharacterString_PropertyType $description
     * @param \StructType\PT_Locale_PropertyType $locale
     * @param \StructType\CI_Date_PropertyType $date
     * @param \StructType\CI_ResponsibleParty_PropertyType $responsibleParty
     * @param \StructType\LocalisedCharacterString_PropertyType $localisedString
     */
    public function __construct(\StructType\CharacterString_PropertyType $description = null, \StructType\PT_Locale_PropertyType $locale = null, \StructType\CI_Date_PropertyType $date = null, \StructType\CI_ResponsibleParty_PropertyType $responsibleParty = null, \StructType\LocalisedCharacterString_PropertyType $localisedString = null)
    {
        $this
            ->setDescription($description)
            ->setLocale($locale)
            ->setDate($date)
            ->setResponsibleParty($responsibleParty)
            ->setLocalisedString($localisedString);
    }
    /**
     * Get description value
     * @return \StructType\CharacterString_PropertyType|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param \StructType\CharacterString_PropertyType $description
     * @return \StructType\PT_LocaleContainer_Type
     */
    public function setDescription(\StructType\CharacterString_PropertyType $description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get locale value
     * @return \StructType\PT_Locale_PropertyType|null
     */
    public function getLocale()
    {
        return $this->locale;
    }
    /**
     * Set locale value
     * @param \StructType\PT_Locale_PropertyType $locale
     * @return \StructType\PT_LocaleContainer_Type
     */
    public function setLocale(\StructType\PT_Locale_PropertyType $locale = null)
    {
        $this->locale = $locale;
        return $this;
    }
    /**
     * Get date value
     * @return \StructType\CI_Date_PropertyType|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param \StructType\CI_Date_PropertyType $date
     * @return \StructType\PT_LocaleContainer_Type
     */
    public function setDate(\StructType\CI_Date_PropertyType $date = null)
    {
        $this->date = $date;
        return $this;
    }
    /**
     * Get responsibleParty value
     * @return \StructType\CI_ResponsibleParty_PropertyType|null
     */
    public function getResponsibleParty()
    {
        return $this->responsibleParty;
    }
    /**
     * Set responsibleParty value
     * @param \StructType\CI_ResponsibleParty_PropertyType $responsibleParty
     * @return \StructType\PT_LocaleContainer_Type
     */
    public function setResponsibleParty(\StructType\CI_ResponsibleParty_PropertyType $responsibleParty = null)
    {
        $this->responsibleParty = $responsibleParty;
        return $this;
    }
    /**
     * Get localisedString value
     * @return \StructType\LocalisedCharacterString_PropertyType|null
     */
    public function getLocalisedString()
    {
        return $this->localisedString;
    }
    /**
     * Set localisedString value
     * @param \StructType\LocalisedCharacterString_PropertyType $localisedString
     * @return \StructType\PT_LocaleContainer_Type
     */
    public function setLocalisedString(\StructType\LocalisedCharacterString_PropertyType $localisedString = null)
    {
        $this->localisedString = $localisedString;
        return $this;
    }
}
