<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PT_Locale_Type StructType
 * @subpackage Structs
 */
class PT_Locale_Type extends AbstractStructBase
{
    /**
     * The languageCode
     * @var \StructType\LanguageCode_PropertyType
     */
    public $languageCode;
    /**
     * The country
     * @var \StructType\Country_PropertyType
     */
    public $country;
    /**
     * The characterEncoding
     * @var \StructType\MD_CharacterSetCode_PropertyType
     */
    public $characterEncoding;
    /**
     * Constructor method for PT_Locale_Type
     * @uses PT_Locale_Type::setLanguageCode()
     * @uses PT_Locale_Type::setCountry()
     * @uses PT_Locale_Type::setCharacterEncoding()
     * @param \StructType\LanguageCode_PropertyType $languageCode
     * @param \StructType\Country_PropertyType $country
     * @param \StructType\MD_CharacterSetCode_PropertyType $characterEncoding
     */
    public function __construct(\StructType\LanguageCode_PropertyType $languageCode = null, \StructType\Country_PropertyType $country = null, \StructType\MD_CharacterSetCode_PropertyType $characterEncoding = null)
    {
        $this
            ->setLanguageCode($languageCode)
            ->setCountry($country)
            ->setCharacterEncoding($characterEncoding);
    }
    /**
     * Get languageCode value
     * @return \StructType\LanguageCode_PropertyType|null
     */
    public function getLanguageCode()
    {
        return $this->languageCode;
    }
    /**
     * Set languageCode value
     * @param \StructType\LanguageCode_PropertyType $languageCode
     * @return \StructType\PT_Locale_Type
     */
    public function setLanguageCode(\StructType\LanguageCode_PropertyType $languageCode = null)
    {
        $this->languageCode = $languageCode;
        return $this;
    }
    /**
     * Get country value
     * @return \StructType\Country_PropertyType|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param \StructType\Country_PropertyType $country
     * @return \StructType\PT_Locale_Type
     */
    public function setCountry(\StructType\Country_PropertyType $country = null)
    {
        $this->country = $country;
        return $this;
    }
    /**
     * Get characterEncoding value
     * @return \StructType\MD_CharacterSetCode_PropertyType|null
     */
    public function getCharacterEncoding()
    {
        return $this->characterEncoding;
    }
    /**
     * Set characterEncoding value
     * @param \StructType\MD_CharacterSetCode_PropertyType $characterEncoding
     * @return \StructType\PT_Locale_Type
     */
    public function setCharacterEncoding(\StructType\MD_CharacterSetCode_PropertyType $characterEncoding = null)
    {
        $this->characterEncoding = $characterEncoding;
        return $this;
    }
}
