<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PriorityLocationPropertyType StructType
 * @subpackage Structs
 */
class PriorityLocationPropertyType extends AbstractStructBase
{
    /**
     * The priority
     * @var string
     */
    public $priority;
    /**
     * Constructor method for PriorityLocationPropertyType
     * @uses PriorityLocationPropertyType::setPriority()
     * @param string $priority
     */
    public function __construct($priority = null)
    {
        $this
            ->setPriority($priority);
    }
    /**
     * Get priority value
     * @return string|null
     */
    public function getPriority()
    {
        return $this->priority;
    }
    /**
     * Set priority value
     * @param string $priority
     * @return \StructType\PriorityLocationPropertyType
     */
    public function setPriority($priority = null)
    {
        // validation for constraint: string
        if (!is_null($priority) && !is_string($priority)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priority, true), gettype($priority)), __LINE__);
        }
        $this->priority = $priority;
        return $this;
    }
}
