<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SC_CRS_PropertyType StructType
 * @subpackage Structs
 */
class SC_CRS_PropertyType extends AbstractStructBase
{
    /**
     * The AbstractCRS
     * @var \StructType\AbstractCRSType
     */
    public $AbstractCRS;
    /**
     * The nilReason
     * @var string
     */
    public $nilReason;
    /**
     * The uuidref
     * @var string
     */
    public $uuidref;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The href
     * @var string
     */
    public $href;
    /**
     * The role
     * @var string
     */
    public $role;
    /**
     * The arcrole
     * @var string
     */
    public $arcrole;
    /**
     * The title
     * @var string
     */
    public $title;
    /**
     * The show
     * @var string
     */
    public $show;
    /**
     * The actuate
     * @var string
     */
    public $actuate;
    /**
     * Constructor method for SC_CRS_PropertyType
     * @uses SC_CRS_PropertyType::setAbstractCRS()
     * @uses SC_CRS_PropertyType::setNilReason()
     * @uses SC_CRS_PropertyType::setUuidref()
     * @uses SC_CRS_PropertyType::setType()
     * @uses SC_CRS_PropertyType::setHref()
     * @uses SC_CRS_PropertyType::setRole()
     * @uses SC_CRS_PropertyType::setArcrole()
     * @uses SC_CRS_PropertyType::setTitle()
     * @uses SC_CRS_PropertyType::setShow()
     * @uses SC_CRS_PropertyType::setActuate()
     * @param \StructType\AbstractCRSType $abstractCRS
     * @param string $nilReason
     * @param string $uuidref
     * @param string $type
     * @param string $href
     * @param string $role
     * @param string $arcrole
     * @param string $title
     * @param string $show
     * @param string $actuate
     */
    public function __construct(\StructType\AbstractCRSType $abstractCRS = null, $nilReason = null, $uuidref = null, $type = null, $href = null, $role = null, $arcrole = null, $title = null, $show = null, $actuate = null)
    {
        $this
            ->setAbstractCRS($abstractCRS)
            ->setNilReason($nilReason)
            ->setUuidref($uuidref)
            ->setType($type)
            ->setHref($href)
            ->setRole($role)
            ->setArcrole($arcrole)
            ->setTitle($title)
            ->setShow($show)
            ->setActuate($actuate);
    }
    /**
     * Get AbstractCRS value
     * @return \StructType\AbstractCRSType|null
     */
    public function getAbstractCRS()
    {
        return $this->AbstractCRS;
    }
    /**
     * Set AbstractCRS value
     * @param \StructType\AbstractCRSType $abstractCRS
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setAbstractCRS(\StructType\AbstractCRSType $abstractCRS = null)
    {
        $this->AbstractCRS = $abstractCRS;
        return $this;
    }
    /**
     * Get nilReason value
     * @return string|null
     */
    public function getNilReason()
    {
        return $this->nilReason;
    }
    /**
     * Set nilReason value
     * @param string $nilReason
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setNilReason($nilReason = null)
    {
        // validation for constraint: string
        if (!is_null($nilReason) && !is_string($nilReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nilReason, true), gettype($nilReason)), __LINE__);
        }
        $this->nilReason = $nilReason;
        return $this;
    }
    /**
     * Get uuidref value
     * @return string|null
     */
    public function getUuidref()
    {
        return $this->uuidref;
    }
    /**
     * Set uuidref value
     * @param string $uuidref
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setUuidref($uuidref = null)
    {
        // validation for constraint: string
        if (!is_null($uuidref) && !is_string($uuidref)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uuidref, true), gettype($uuidref)), __LINE__);
        }
        $this->uuidref = $uuidref;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get href value
     * @return string|null
     */
    public function getHref()
    {
        return $this->href;
    }
    /**
     * Set href value
     * @param string $href
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setHref($href = null)
    {
        // validation for constraint: string
        if (!is_null($href) && !is_string($href)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($href, true), gettype($href)), __LINE__);
        }
        $this->href = $href;
        return $this;
    }
    /**
     * Get role value
     * @return string|null
     */
    public function getRole()
    {
        return $this->role;
    }
    /**
     * Set role value
     * @param string $role
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setRole($role = null)
    {
        // validation for constraint: string
        if (!is_null($role) && !is_string($role)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($role, true), gettype($role)), __LINE__);
        }
        $this->role = $role;
        return $this;
    }
    /**
     * Get arcrole value
     * @return string|null
     */
    public function getArcrole()
    {
        return $this->arcrole;
    }
    /**
     * Set arcrole value
     * @param string $arcrole
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setArcrole($arcrole = null)
    {
        // validation for constraint: string
        if (!is_null($arcrole) && !is_string($arcrole)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arcrole, true), gettype($arcrole)), __LINE__);
        }
        $this->arcrole = $arcrole;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Get show value
     * @return string|null
     */
    public function getShow()
    {
        return $this->show;
    }
    /**
     * Set show value
     * @param string $show
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setShow($show = null)
    {
        // validation for constraint: string
        if (!is_null($show) && !is_string($show)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($show, true), gettype($show)), __LINE__);
        }
        $this->show = $show;
        return $this;
    }
    /**
     * Get actuate value
     * @return string|null
     */
    public function getActuate()
    {
        return $this->actuate;
    }
    /**
     * Set actuate value
     * @param string $actuate
     * @return \StructType\SC_CRS_PropertyType
     */
    public function setActuate($actuate = null)
    {
        // validation for constraint: string
        if (!is_null($actuate) && !is_string($actuate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actuate, true), gettype($actuate)), __LINE__);
        }
        $this->actuate = $actuate;
        return $this;
    }
}
