<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Scale_PropertyType StructType
 * @subpackage Structs
 */
class Scale_PropertyType extends AbstractStructBase
{
    /**
     * The Scale
     * @var \StructType\ScaleType
     */
    public $Scale;
    /**
     * The nilReason
     * @var string
     */
    public $nilReason;
    /**
     * Constructor method for Scale_PropertyType
     * @uses Scale_PropertyType::setScale()
     * @uses Scale_PropertyType::setNilReason()
     * @param \StructType\ScaleType $scale
     * @param string $nilReason
     */
    public function __construct(\StructType\ScaleType $scale = null, $nilReason = null)
    {
        $this
            ->setScale($scale)
            ->setNilReason($nilReason);
    }
    /**
     * Get Scale value
     * @return \StructType\ScaleType|null
     */
    public function getScale()
    {
        return $this->Scale;
    }
    /**
     * Set Scale value
     * @param \StructType\ScaleType $scale
     * @return \StructType\Scale_PropertyType
     */
    public function setScale(\StructType\ScaleType $scale = null)
    {
        $this->Scale = $scale;
        return $this;
    }
    /**
     * Get nilReason value
     * @return string|null
     */
    public function getNilReason()
    {
        return $this->nilReason;
    }
    /**
     * Set nilReason value
     * @param string $nilReason
     * @return \StructType\Scale_PropertyType
     */
    public function setNilReason($nilReason = null)
    {
        // validation for constraint: string
        if (!is_null($nilReason) && !is_string($nilReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nilReason, true), gettype($nilReason)), __LINE__);
        }
        $this->nilReason = $nilReason;
        return $this;
    }
}
