<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SecondDefiningParameter StructType
 * @subpackage Structs
 */
class SecondDefiningParameter_1 extends AbstractStructBase
{
    /**
     * The inverseFlattening
     * @var \StructType\MeasureType
     */
    public $inverseFlattening;
    /**
     * The semiMinorAxis
     * @var \StructType\LengthType
     */
    public $semiMinorAxis;
    /**
     * The isSphere
     * @var bool
     */
    public $isSphere;
    /**
     * Constructor method for SecondDefiningParameter
     * @uses SecondDefiningParameter_1::setInverseFlattening()
     * @uses SecondDefiningParameter_1::setSemiMinorAxis()
     * @uses SecondDefiningParameter_1::setIsSphere()
     * @param \StructType\MeasureType $inverseFlattening
     * @param \StructType\LengthType $semiMinorAxis
     * @param bool $isSphere
     */
    public function __construct(\StructType\MeasureType $inverseFlattening = null, \StructType\LengthType $semiMinorAxis = null, $isSphere = null)
    {
        $this
            ->setInverseFlattening($inverseFlattening)
            ->setSemiMinorAxis($semiMinorAxis)
            ->setIsSphere($isSphere);
    }
    /**
     * Get inverseFlattening value
     * @return \StructType\MeasureType|null
     */
    public function getInverseFlattening()
    {
        return $this->inverseFlattening;
    }
    /**
     * Set inverseFlattening value
     * @param \StructType\MeasureType $inverseFlattening
     * @return \StructType\SecondDefiningParameter_1
     */
    public function setInverseFlattening(\StructType\MeasureType $inverseFlattening = null)
    {
        $this->inverseFlattening = $inverseFlattening;
        return $this;
    }
    /**
     * Get semiMinorAxis value
     * @return \StructType\LengthType|null
     */
    public function getSemiMinorAxis()
    {
        return $this->semiMinorAxis;
    }
    /**
     * Set semiMinorAxis value
     * @param \StructType\LengthType $semiMinorAxis
     * @return \StructType\SecondDefiningParameter_1
     */
    public function setSemiMinorAxis(\StructType\LengthType $semiMinorAxis = null)
    {
        $this->semiMinorAxis = $semiMinorAxis;
        return $this;
    }
    /**
     * Get isSphere value
     * @return bool|null
     */
    public function getIsSphere()
    {
        return $this->isSphere;
    }
    /**
     * Set isSphere value
     * @param bool $isSphere
     * @return \StructType\SecondDefiningParameter_1
     */
    public function setIsSphere($isSphere = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSphere) && !is_bool($isSphere)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSphere, true), gettype($isSphere)), __LINE__);
        }
        $this->isSphere = $isSphere;
        return $this;
    }
}
