<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SuchprofilGebietstyp StructType
 * Meta information extracted from the WSDL
 * - documentation: Suchprofil für Gebietstypen.
 * @subpackage Structs
 */
class SuchprofilGebietstyp extends Suchprofil
{
    /**
     * The gebietstypKlasseID
     * Meta information extracted from the WSDL
     * - documentation: Einschränkung auf bestimmte Gebietsklassen.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Identifikator[]
     */
    public $gebietstypKlasseID;
    /**
     * Constructor method for SuchprofilGebietstyp
     * @uses SuchprofilGebietstyp::setGebietstypKlasseID()
     * @param \StructType\Identifikator[] $gebietstypKlasseID
     */
    public function __construct(array $gebietstypKlasseID = array())
    {
        $this
            ->setGebietstypKlasseID($gebietstypKlasseID);
    }
    /**
     * Get gebietstypKlasseID value
     * @return \StructType\Identifikator[]|null
     */
    public function getGebietstypKlasseID()
    {
        return $this->gebietstypKlasseID;
    }
    /**
     * This method is responsible for validating the values passed to the setGebietstypKlasseID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGebietstypKlasseID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGebietstypKlasseIDForArrayConstraintsFromSetGebietstypKlasseID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $suchprofilGebietstypGebietstypKlasseIDItem) {
            // validation for constraint: itemType
            if (!$suchprofilGebietstypGebietstypKlasseIDItem instanceof \StructType\Identifikator) {
                $invalidValues[] = is_object($suchprofilGebietstypGebietstypKlasseIDItem) ? get_class($suchprofilGebietstypGebietstypKlasseIDItem) : sprintf('%s(%s)', gettype($suchprofilGebietstypGebietstypKlasseIDItem), var_export($suchprofilGebietstypGebietstypKlasseIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The gebietstypKlasseID property can only contain items of type \StructType\Identifikator, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set gebietstypKlasseID value
     * @throws \InvalidArgumentException
     * @param \StructType\Identifikator[] $gebietstypKlasseID
     * @return \StructType\SuchprofilGebietstyp
     */
    public function setGebietstypKlasseID(array $gebietstypKlasseID = array())
    {
        // validation for constraint: array
        if ('' !== ($gebietstypKlasseIDArrayErrorMessage = self::validateGebietstypKlasseIDForArrayConstraintsFromSetGebietstypKlasseID($gebietstypKlasseID))) {
            throw new \InvalidArgumentException($gebietstypKlasseIDArrayErrorMessage, __LINE__);
        }
        $this->gebietstypKlasseID = $gebietstypKlasseID;
        return $this;
    }
    /**
     * Add item to gebietstypKlasseID value
     * @throws \InvalidArgumentException
     * @param \StructType\Identifikator $item
     * @return \StructType\SuchprofilGebietstyp
     */
    public function addToGebietstypKlasseID(\StructType\Identifikator $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Identifikator) {
            throw new \InvalidArgumentException(sprintf('The gebietstypKlasseID property can only contain items of type \StructType\Identifikator, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->gebietstypKlasseID[] = $item;
        return $this;
    }
}
