<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SuchprofilOrganisationseinheitskategorie StructType
 * Meta information extracted from the WSDL
 * - documentation: Suchprofil für Organisationseinheitskategorien.
 * @subpackage Structs
 */
class SuchprofilOrganisationseinheitskategorie extends Suchprofil
{
    /**
     * The organisationseinheitskategorieKlasseID
     * Meta information extracted from the WSDL
     * - documentation: Einschränkung auf bestimmte Organisationseinheitskategorieklassen.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Identifikator[]
     */
    public $organisationseinheitskategorieKlasseID;
    /**
     * The uebergeordneteOrganisationseinheitskategorieID
     * Meta information extracted from the WSDL
     * - documentation: Einschränkung auf Kindelemente von übergebener Kategorie.
     * - minOccurs: 0
     * @var \StructType\Identifikator
     */
    public $uebergeordneteOrganisationseinheitskategorieID;
    /**
     * Constructor method for SuchprofilOrganisationseinheitskategorie
     * @uses SuchprofilOrganisationseinheitskategorie::setOrganisationseinheitskategorieKlasseID()
     * @uses SuchprofilOrganisationseinheitskategorie::setUebergeordneteOrganisationseinheitskategorieID()
     * @param \StructType\Identifikator[] $organisationseinheitskategorieKlasseID
     * @param \StructType\Identifikator $uebergeordneteOrganisationseinheitskategorieID
     */
    public function __construct(array $organisationseinheitskategorieKlasseID = array(), \StructType\Identifikator $uebergeordneteOrganisationseinheitskategorieID = null)
    {
        $this
            ->setOrganisationseinheitskategorieKlasseID($organisationseinheitskategorieKlasseID)
            ->setUebergeordneteOrganisationseinheitskategorieID($uebergeordneteOrganisationseinheitskategorieID);
    }
    /**
     * Get organisationseinheitskategorieKlasseID value
     * @return \StructType\Identifikator[]|null
     */
    public function getOrganisationseinheitskategorieKlasseID()
    {
        return $this->organisationseinheitskategorieKlasseID;
    }
    /**
     * This method is responsible for validating the values passed to the setOrganisationseinheitskategorieKlasseID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrganisationseinheitskategorieKlasseID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrganisationseinheitskategorieKlasseIDForArrayConstraintsFromSetOrganisationseinheitskategorieKlasseID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $suchprofilOrganisationseinheitskategorieOrganisationseinheitskategorieKlasseIDItem) {
            // validation for constraint: itemType
            if (!$suchprofilOrganisationseinheitskategorieOrganisationseinheitskategorieKlasseIDItem instanceof \StructType\Identifikator) {
                $invalidValues[] = is_object($suchprofilOrganisationseinheitskategorieOrganisationseinheitskategorieKlasseIDItem) ? get_class($suchprofilOrganisationseinheitskategorieOrganisationseinheitskategorieKlasseIDItem) : sprintf('%s(%s)', gettype($suchprofilOrganisationseinheitskategorieOrganisationseinheitskategorieKlasseIDItem), var_export($suchprofilOrganisationseinheitskategorieOrganisationseinheitskategorieKlasseIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The organisationseinheitskategorieKlasseID property can only contain items of type \StructType\Identifikator, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set organisationseinheitskategorieKlasseID value
     * @throws \InvalidArgumentException
     * @param \StructType\Identifikator[] $organisationseinheitskategorieKlasseID
     * @return \StructType\SuchprofilOrganisationseinheitskategorie
     */
    public function setOrganisationseinheitskategorieKlasseID(array $organisationseinheitskategorieKlasseID = array())
    {
        // validation for constraint: array
        if ('' !== ($organisationseinheitskategorieKlasseIDArrayErrorMessage = self::validateOrganisationseinheitskategorieKlasseIDForArrayConstraintsFromSetOrganisationseinheitskategorieKlasseID($organisationseinheitskategorieKlasseID))) {
            throw new \InvalidArgumentException($organisationseinheitskategorieKlasseIDArrayErrorMessage, __LINE__);
        }
        $this->organisationseinheitskategorieKlasseID = $organisationseinheitskategorieKlasseID;
        return $this;
    }
    /**
     * Add item to organisationseinheitskategorieKlasseID value
     * @throws \InvalidArgumentException
     * @param \StructType\Identifikator $item
     * @return \StructType\SuchprofilOrganisationseinheitskategorie
     */
    public function addToOrganisationseinheitskategorieKlasseID(\StructType\Identifikator $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Identifikator) {
            throw new \InvalidArgumentException(sprintf('The organisationseinheitskategorieKlasseID property can only contain items of type \StructType\Identifikator, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->organisationseinheitskategorieKlasseID[] = $item;
        return $this;
    }
    /**
     * Get uebergeordneteOrganisationseinheitskategorieID value
     * @return \StructType\Identifikator|null
     */
    public function getUebergeordneteOrganisationseinheitskategorieID()
    {
        return $this->uebergeordneteOrganisationseinheitskategorieID;
    }
    /**
     * Set uebergeordneteOrganisationseinheitskategorieID value
     * @param \StructType\Identifikator $uebergeordneteOrganisationseinheitskategorieID
     * @return \StructType\SuchprofilOrganisationseinheitskategorie
     */
    public function setUebergeordneteOrganisationseinheitskategorieID(\StructType\Identifikator $uebergeordneteOrganisationseinheitskategorieID = null)
    {
        $this->uebergeordneteOrganisationseinheitskategorieID = $uebergeordneteOrganisationseinheitskategorieID;
        return $this;
    }
}
