<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TemporalCRSType StructType
 * @subpackage Structs
 */
class TemporalCRSType extends AbstractStructBase
{
    /**
     * The timeCS
     * @var \StructType\TimeCSPropertyType
     */
    public $timeCS;
    /**
     * The usesTemporalCS
     * @var \StructType\TemporalCSPropertyType
     */
    public $usesTemporalCS;
    /**
     * The temporalDatum
     * @var \StructType\TemporalDatumPropertyType
     */
    public $temporalDatum;
    /**
     * Constructor method for TemporalCRSType
     * @uses TemporalCRSType::setTimeCS()
     * @uses TemporalCRSType::setUsesTemporalCS()
     * @uses TemporalCRSType::setTemporalDatum()
     * @param \StructType\TimeCSPropertyType $timeCS
     * @param \StructType\TemporalCSPropertyType $usesTemporalCS
     * @param \StructType\TemporalDatumPropertyType $temporalDatum
     */
    public function __construct(\StructType\TimeCSPropertyType $timeCS = null, \StructType\TemporalCSPropertyType $usesTemporalCS = null, \StructType\TemporalDatumPropertyType $temporalDatum = null)
    {
        $this
            ->setTimeCS($timeCS)
            ->setUsesTemporalCS($usesTemporalCS)
            ->setTemporalDatum($temporalDatum);
    }
    /**
     * Get timeCS value
     * @return \StructType\TimeCSPropertyType|null
     */
    public function getTimeCS()
    {
        return $this->timeCS;
    }
    /**
     * Set timeCS value
     * @param \StructType\TimeCSPropertyType $timeCS
     * @return \StructType\TemporalCRSType
     */
    public function setTimeCS(\StructType\TimeCSPropertyType $timeCS = null)
    {
        $this->timeCS = $timeCS;
        return $this;
    }
    /**
     * Get usesTemporalCS value
     * @return \StructType\TemporalCSPropertyType|null
     */
    public function getUsesTemporalCS()
    {
        return $this->usesTemporalCS;
    }
    /**
     * Set usesTemporalCS value
     * @param \StructType\TemporalCSPropertyType $usesTemporalCS
     * @return \StructType\TemporalCRSType
     */
    public function setUsesTemporalCS(\StructType\TemporalCSPropertyType $usesTemporalCS = null)
    {
        $this->usesTemporalCS = $usesTemporalCS;
        return $this;
    }
    /**
     * Get temporalDatum value
     * @return \StructType\TemporalDatumPropertyType|null
     */
    public function getTemporalDatum()
    {
        return $this->temporalDatum;
    }
    /**
     * Set temporalDatum value
     * @param \StructType\TemporalDatumPropertyType $temporalDatum
     * @return \StructType\TemporalCRSType
     */
    public function setTemporalDatum(\StructType\TemporalDatumPropertyType $temporalDatum = null)
    {
        $this->temporalDatum = $temporalDatum;
        return $this;
    }
}
