<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TimeOrdinalEraType StructType
 * @subpackage Structs
 */
class TimeOrdinalEraType extends AbstractStructBase
{
    /**
     * The relatedTime
     * @var \StructType\RelatedTimeType
     */
    public $relatedTime;
    /**
     * The start
     * @var \StructType\TimeNodePropertyType
     */
    public $start;
    /**
     * The end
     * @var \StructType\TimeNodePropertyType
     */
    public $end;
    /**
     * The extent
     * @var \StructType\TimePeriodPropertyType
     */
    public $extent;
    /**
     * The member
     * @var \StructType\TimeOrdinalEraPropertyType
     */
    public $member;
    /**
     * The group
     * @var \StructType\ReferenceType
     */
    public $group;
    /**
     * Constructor method for TimeOrdinalEraType
     * @uses TimeOrdinalEraType::setRelatedTime()
     * @uses TimeOrdinalEraType::setStart()
     * @uses TimeOrdinalEraType::setEnd()
     * @uses TimeOrdinalEraType::setExtent()
     * @uses TimeOrdinalEraType::setMember()
     * @uses TimeOrdinalEraType::setGroup()
     * @param \StructType\RelatedTimeType $relatedTime
     * @param \StructType\TimeNodePropertyType $start
     * @param \StructType\TimeNodePropertyType $end
     * @param \StructType\TimePeriodPropertyType $extent
     * @param \StructType\TimeOrdinalEraPropertyType $member
     * @param \StructType\ReferenceType $group
     */
    public function __construct(\StructType\RelatedTimeType $relatedTime = null, \StructType\TimeNodePropertyType $start = null, \StructType\TimeNodePropertyType $end = null, \StructType\TimePeriodPropertyType $extent = null, \StructType\TimeOrdinalEraPropertyType $member = null, \StructType\ReferenceType $group = null)
    {
        $this
            ->setRelatedTime($relatedTime)
            ->setStart($start)
            ->setEnd($end)
            ->setExtent($extent)
            ->setMember($member)
            ->setGroup($group);
    }
    /**
     * Get relatedTime value
     * @return \StructType\RelatedTimeType|null
     */
    public function getRelatedTime()
    {
        return $this->relatedTime;
    }
    /**
     * Set relatedTime value
     * @param \StructType\RelatedTimeType $relatedTime
     * @return \StructType\TimeOrdinalEraType
     */
    public function setRelatedTime(\StructType\RelatedTimeType $relatedTime = null)
    {
        $this->relatedTime = $relatedTime;
        return $this;
    }
    /**
     * Get start value
     * @return \StructType\TimeNodePropertyType|null
     */
    public function getStart()
    {
        return $this->start;
    }
    /**
     * Set start value
     * @param \StructType\TimeNodePropertyType $start
     * @return \StructType\TimeOrdinalEraType
     */
    public function setStart(\StructType\TimeNodePropertyType $start = null)
    {
        $this->start = $start;
        return $this;
    }
    /**
     * Get end value
     * @return \StructType\TimeNodePropertyType|null
     */
    public function getEnd()
    {
        return $this->end;
    }
    /**
     * Set end value
     * @param \StructType\TimeNodePropertyType $end
     * @return \StructType\TimeOrdinalEraType
     */
    public function setEnd(\StructType\TimeNodePropertyType $end = null)
    {
        $this->end = $end;
        return $this;
    }
    /**
     * Get extent value
     * @return \StructType\TimePeriodPropertyType|null
     */
    public function getExtent()
    {
        return $this->extent;
    }
    /**
     * Set extent value
     * @param \StructType\TimePeriodPropertyType $extent
     * @return \StructType\TimeOrdinalEraType
     */
    public function setExtent(\StructType\TimePeriodPropertyType $extent = null)
    {
        $this->extent = $extent;
        return $this;
    }
    /**
     * Get member value
     * @return \StructType\TimeOrdinalEraPropertyType|null
     */
    public function getMember()
    {
        return $this->member;
    }
    /**
     * Set member value
     * @param \StructType\TimeOrdinalEraPropertyType $member
     * @return \StructType\TimeOrdinalEraType
     */
    public function setMember(\StructType\TimeOrdinalEraPropertyType $member = null)
    {
        $this->member = $member;
        return $this;
    }
    /**
     * Get group value
     * @return \StructType\ReferenceType|null
     */
    public function getGroup()
    {
        return $this->group;
    }
    /**
     * Set group value
     * @param \StructType\ReferenceType $group
     * @return \StructType\TimeOrdinalEraType
     */
    public function setGroup(\StructType\ReferenceType $group = null)
    {
        $this->group = $group;
        return $this;
    }
}
