<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for zustaendigkeiten.anfrage.onlinedienst.040413 StructType
 * Meta information extracted from the WSDL
 * - documentation: Nachricht zur Anfrage von Onlinediensten.
 * @subpackage Structs
 */
class Zustaendigkeiten_anfrage_onlinedienst_040413 extends Basisnachricht
{
    /**
     * The anfrage
     * Meta information extracted from the WSDL
     * - documentation: Eine oder mehrere Onlinedienstanfragen.
     * - maxOccurs: unbounded
     * @var \StructType\AnfrageOnlinedienst[]
     */
    public $anfrage;
    /**
     * Constructor method for zustaendigkeiten.anfrage.onlinedienst.040413
     * @uses Zustaendigkeiten_anfrage_onlinedienst_040413::setAnfrage()
     * @param \StructType\AnfrageOnlinedienst[] $anfrage
     */
    public function __construct(array $anfrage = array())
    {
        $this
            ->setAnfrage($anfrage);
    }
    /**
     * Get anfrage value
     * @return \StructType\AnfrageOnlinedienst[]|null
     */
    public function getAnfrage()
    {
        return $this->anfrage;
    }
    /**
     * This method is responsible for validating the values passed to the setAnfrage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnfrage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnfrageForArrayConstraintsFromSetAnfrage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $zustaendigkeiten_anfrage_onlinedienst_040413AnfrageItem) {
            // validation for constraint: itemType
            if (!$zustaendigkeiten_anfrage_onlinedienst_040413AnfrageItem instanceof \StructType\AnfrageOnlinedienst) {
                $invalidValues[] = is_object($zustaendigkeiten_anfrage_onlinedienst_040413AnfrageItem) ? get_class($zustaendigkeiten_anfrage_onlinedienst_040413AnfrageItem) : sprintf('%s(%s)', gettype($zustaendigkeiten_anfrage_onlinedienst_040413AnfrageItem), var_export($zustaendigkeiten_anfrage_onlinedienst_040413AnfrageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The anfrage property can only contain items of type \StructType\AnfrageOnlinedienst, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageOnlinedienst[] $anfrage
     * @return \StructType\Zustaendigkeiten_anfrage_onlinedienst_040413
     */
    public function setAnfrage(array $anfrage = array())
    {
        // validation for constraint: array
        if ('' !== ($anfrageArrayErrorMessage = self::validateAnfrageForArrayConstraintsFromSetAnfrage($anfrage))) {
            throw new \InvalidArgumentException($anfrageArrayErrorMessage, __LINE__);
        }
        $this->anfrage = $anfrage;
        return $this;
    }
    /**
     * Add item to anfrage value
     * @throws \InvalidArgumentException
     * @param \StructType\AnfrageOnlinedienst $item
     * @return \StructType\Zustaendigkeiten_anfrage_onlinedienst_040413
     */
    public function addToAnfrage(\StructType\AnfrageOnlinedienst $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnfrageOnlinedienst) {
            throw new \InvalidArgumentException(sprintf('The anfrage property can only contain items of type \StructType\AnfrageOnlinedienst, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->anfrage[] = $item;
        return $this;
    }
}
